/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABApplication.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABApplication.h"


#include	"GUIApp.h"
#include	"GameView.h"
#include	"ABView.h"

#include	"ABTestRender.h"
#include	"ABTestScheme.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABApplication::ABApplication( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABApplication::~ABApplication( void )
{
}

//-------------------------------------------------------------------------------------------------
//	initialize
//-------------------------------------------------------------------------------------------------
ABbool			ABApplication::initialize( void )
{
	ABbool		ret = false;

	//	Q[GW̏ȂǂȂ
	do{
		ret = true;
	}while( false );
	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	finalize
//-------------------------------------------------------------------------------------------------
void			ABApplication::finalize( void )
{
	//	Q[GW̌nȂǂȂ
}

//-------------------------------------------------------------------------------------------------
//	run
//-------------------------------------------------------------------------------------------------
void			ABApplication::run( void )
{
	ABView			abView;
//	ABTestRender	abView;//	Render@\JeXg
//	ABTestScheme	abView;//	Scheme@\JeXg
	
	GameView	gameView( abView );		//	Q[GWGUIVF
	GUIApp		gameApp( gameView );	//	Q[GWGUIVF

	do{
		//	AB̏
		if( ! this->initialize() ){ 
			break;
		}
		
		//	Q[GWGUIVF̏
		if( ! gameApp.initialize() ){ 
			break;
		}

		//	siI܂Ŗ߂܂j
		gameApp.run();

	}while( false );

	//	Q[GWGUIVF̏I
	gameApp.finalize();

	//	AB̏I
	this->finalize();
}