/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneStageEntry.h

				Q[V[NX

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/15	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#ifndef	ABSceneStageEntry_h
#define	ABSceneStageEntry_h

#include	"GlobalConfig.h"
#include	"ABSceneBase.h"

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSceneStageEntry : public ABSceneBase
{
public:
	explicit	ABSceneStageEntry( ABSceneRunner&  inRunner );
	virtual ~ABSceneStageEntry();

	//--------------------------------------------------------------------------
	//	V[Cxgnh[
	//--------------------------------------------------------------------------

	//	V[i[NɌĂяo܂
	//		[mۓs܂
	virtual ABbool	onInitialize( void );

	//	V[i[IOɌĂяo܂
	//		[mۓs܂
	virtual void	onFinalize( void );

	//	V[JnɌĂяo܂
	//		f[^̏s܂
	virtual void	onEnterScene( void );

	//	V[IɌĂяo܂
	//		f[^̌ns܂
	virtual void	onExitScene( void );

	//	Q[[v
	//		1/60b̏ɌĂяo܂B`揈͂ōs܂B
	virtual void	onGameLoop( void );

	//	AvP[VCxg
	//		falseԂƁACxg̑sj~܂B
	virtual ABbool	onAppEvent( GEeventAppType  inAppEventType );

	//--------------------------------------------------------------------------
	//	VhEV[Cxgnh[
	//		VhEV[ƂĐݒ肵Ƃ̂ݎs܂
	//--------------------------------------------------------------------------

	//	Q[[vȌ
	//		V[onGameLoop()̑OŌĂяo܂B
	virtual void	onEnterGameLoop( void );

	//	Q[[vȌ
	//		V[onGameLoop()̌ŌĂяo܂B
	virtual void	onExitGameLoop( void );

};

#endif	//	ABSceneStageEntry_h
