/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSingleton.cpp

				AquanBeatsVOg
				VOgȃNX܂Ƃ߂̃VOgNXB
				ɂ̓O[oȗ̈ŎgpAABf[^݂̂ĉB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSingleton_h
#define	ABSingleton_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"CWorkerSingletonBase.h"


#include	"AquanBeatsPreference.h"
//#include	"ABMusicData.h"
//#include	"ABBMSRunner.h"
//#include	"ABBMLibrary.h"

#include	"BMSLibrary.h"
#include	"ABBMSRunner.h"
#include	"BMSFolder.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABSingleton
{
public:

	ABGamePreference		m_preference;	//	Q[CONFIG
	
	ABgamePlayngStatusInfo	m_playngStatus;		//	BMS game playng status structure
//	ABDJCollection			m_djCollection;		//	bms database manage member Object
//	ABMusicData				m_musicData;		//	current music data
//	ABBMSRunner				mBMSRunner;			//	BMS Sequencer
//	ABBMLibrary				mBMSLibrary;		//	BMS Database
	
	BMSLibrary				mBMSLibrary;		//	BMS Database
	ABBMSRunner				mABBMSRunner;		//	AB BMS Runner
	
	//	fobOp
	BMSFolder				mBMSFolder;			//	DEBUG
	
protected:
	ABSingleton( void ){
		m_preference.clean();
		//	Ƃ͕ʂɌX̃o[ʂ̏ꏊŏ邱
	};
	virtual ~ABSingleton( void ){
	};
	ABSingleton( const ABSingleton& );
	ABSingleton&	operator = ( const ABSingleton& );
};
//	singleton
typedef	code_worker::CWorkerSingletonBase<ABSingleton>		ABSingletonClass;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	Get singleton
//
//////////////////////////////////////////////////////////////////////////////////////////////////
ABSingleton&			ABGetSingleton( void );
ABGamePreference&		ABGetPreference( void );
//ABMusicData&			ABGetBMSMusicData( void );
//ABBMSRunner&			ABGetBMSRunner( void );
//ABBMLibrary&			ABGetBMSLibrary( void );

BMSLibrary&				ABGetBMSLibrary( void );
ABBMSRunner&			ABGetBMSRunner( void );

#endif	ABSingleton_h
