/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABView.cpp

				Q[\
				̃NX͔@ˑɂȂ悤A
				@ˑR[hL܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABView_h
#define	ABView_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"ABSceneRunner.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABView
{
private:
	ABSceneRunner	m_sceneRunner;
	ABint			m_framecount;
public:
	ABView( void );
	virtual ~ABView( void );

	//	initialize
	//		AvP[V̏ɌĂт܂B
	virtual ABbool		initialize( void );

	//	finalize
	//		AvP[V̏IsOɌĂт܂B
	virtual void		finalize( void );

	//	change screen mode
	//		j[tXN[[hύXsƂɌĂт܂B
	virtual void		changeScreenMode( ABbool  inTrueIsFullScreenMode );

	//	`ƃ_[ƃXbv
	//		̃^C~Oi1/60bԊujŌĂт܂B
	//		̊֐IAglFlushyуobt@[̃Xbvs܂B
	virtual ABbool		draw( const ABuint32  inWidth, const ABuint32  inHeight );

	//	`̈XV
	//		EBhETCYύXƂɌĂт܂B
	//		tXN[[hύXɂĂт܂B
	virtual void		reshape( const ABuint32  inWidth, const ABuint32  inHeight );

	//	AvP[VCxgɌĂт܂
	virtual ABbool		appEvent( const GEeventAppType  inEvent );
	
};


#endif	ABView_h
