/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemResFont.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABVAItemResFont.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemResFontObject
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABVAItemResFontObject::ABVAItemResFontObject( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABVAItemResFontObject::~ABVAItemResFontObject( void )
{
}

//-------------------------------------------------------------------------------------------------
//	setup
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemResFontObject::setup( void )
{
	ABint					i;
	ABVAItemResFont*		item;
	ABVAResource*			resource;
	ABVAGetResource( this, &item, &resource );

	for( i = 0 ; i < 256 ; i ++ ){
		GGFont::MFont	f;
		f.cellX = item->mFontMapTable[i].cellX;
		f.cellY = item->mFontMapTable[i].cellY;
		f.enable = item->mFontMapTable[i].enable;
		this->mFont.setFontTable( i, f );
	}
	this->mFont.mSurfaceOffsetX = item->mCellLeft;
	this->mFont.mSurfaceOffsetY = item->mCellTop;
	this->mFont.mCellWidth = item->mCellWidth;
	this->mFont.mCellHeight = item->mCellHeight;

	return	true;
};

//-------------------------------------------------------------------------------------------------
//	cleanup
//-------------------------------------------------------------------------------------------------
void	ABVAItemResFontObject::cleanup( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Instancẽf[^ݒ肷
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemResFontObject::setData( const ABVAItemObjData  inType, void*  outData )
{
	return	true;
}

//-------------------------------------------------------------------------------------------------
//	Instancẽf[^擾
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemResFontObject::getData( const ABVAItemObjData  inType, void**  outData )
{
	return	true;
}
