/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemResImage.cpp

	Encoding:	Shift-JIS

				eNX`摜

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItemResImage_h
#define	ABVAItemResImage_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<stdio.h>
#include	<iostream>

#include	"GlobalConfig.h"
#include	"ABVAItemObject.h"
#include	"ABVAItem.h"

#include	"GGTexture.h"
#include	"GameFile.h"

//	f[^
//		ABVAItemObjData

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemResImageObject
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemResImageObject : public ABVAItemObject
{
public:
	GGTexture		mTexture;

private:
	ABbool	mSetup;

public:
	ABVAItemResImageObject( void );
	virtual	~ABVAItemResImageObject( void );
	
	//-----------------------------------------------
	//	setup
	//	EArchitectureɁAsB
	//-----------------------------------------------
	virtual	ABbool	setup( void );

	//-----------------------------------------------
	//	cleanup
	//	Esetup̌nB
	//-----------------------------------------------
	virtual	void	cleanup( void );

	//-----------------------------------------------
	//	Property
	//-----------------------------------------------
	
	//	Instancẽf[^ݒ肷
	//		EhNXinTypeŎʂAvoid*Œlݒ肷邱
	virtual	ABbool	setData( const ABVAItemObjData  inType, void*  outData );

	//	Instancẽf[^擾
	//		EhNXinTypeŎʂAvoid*ŒlԂ
	virtual	ABbool	getData( const ABVAItemObjData  inType, void**  outData );

};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemResImage
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemResImage : public ABVAItem
{
public:
	//-----------------------------------------------
	//	ACȅ
	//-----------------------------------------------

	//-----------------------------------------------
	//	InstanceɊւ
	//-----------------------------------------------

	//	file
	GameFileInfo				mFileInfo;
	
	//	size
	ABint32						mWidth;
	ABint32						mHeight;

	//	TransparentType
	GEbmpTransparentType		mTransparentType;

public:
	//-----------------------------------------------
	//	Constructor
	//-----------------------------------------------
	ABVAItemResImage( void )
	{
		mWidth	= 0;
		mHeight	= 0;
		mTransparentType = GE_BMP_TRANSPARENT_NONE;
	}

	//-----------------------------------------------
	//	Destructor
	//-----------------------------------------------
	virtual	~ABVAItemResImage( void ){
	}
	
	//-----------------------------------------------
	//	Create instance
	//		hNXŎ̊֐`Ă
	//-----------------------------------------------
	ABVAItemResImageObject*	createInstance( void ) throw( std::bad_alloc )
	{
		return	new 	ABVAItemResImageObject;
	};
};


#endif	ABVAItemResImage_h
