/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemPreset.cpp

	Encoding:	Shift-JIS

				Schemeݒn[hR[fBO邽߂̃NXB
				MacBeatScheme

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBVAItemPreset_h
#define	ABMBVAItemPreset_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<iostream>

#include	"GlobalConfig.h"

#include	"ABVARunner.h"
#include	"ABVAItemPreset.h"

#include	"ABSceneConfig.h"
#include	"AquanBeatsConfig.h"
#include	"ABVAItemBinderConfig.h"

#include	"ABVAItemTextSprite.h"
#include	"ABVAItemResFont.h"
#include	"ABVAItemResImage.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	PRESET ITEM ID
//
//	eACeQƂ邽߂̔ԍBScheme̔ԍƂ͑S֌W܂B
//
//	V[ɁAOn܂AlŗpӂĂB
//	ԍ̂܂ܔzCfbNXƂėp邽߁A傫ȂƗ]vɃ[܂B
//	ʂ͏̂ŁAgpʂCɂKv͂܂񂪁AʂɊԂJȂ悤ɂĂB
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------------------------
//	V[@ENTRANCE
//------------------------------------------------------------------------------------------------
enum{
	ABVA_ITEM_ID_ENTRANCE_MENU_CONTROL,		//	j[ACe
};	

//------------------------------------------------------------------------------------------------
//	V[@AB_SCENE_CONFIGURATION
//------------------------------------------------------------------------------------------------
enum{
	ABVA_ITEM_ID_CONFIG_MENU_CONTROL,		//	j[x
	ABVA_ITEM_ID_CONFIG_MENU_VALUE,			//	j[l
};	

//------------------------------------------------------------------------------------------------
//	V[@AB_SCENE_MUSIC_SELECT
//------------------------------------------------------------------------------------------------
enum{
	ABVA_ITEM_ID_SELECT_SPRITE_TURN_TABLE,		//	^[e[u
	ABVA_ITEM_ID_SELECT_TEXT_MUSIC_TITLE_LIST,	//	ȖXg
	ABVA_ITEM_ID_SELECT_SPRITE_PLAY_LEVEL_MARK,	//	vCx}[N
	
	ABVA_ITEM_ID_SELECT_SPRITE_LOCATE_PLAY_STEP,			//	lFPlayStepFQ[[h̍Wʒu

	ABVA_ITEM_ID_SELECT_SPRITE_GAME_MODE_LABEL, 	//	[hx(ARCADE, EXPERT)
	ABVA_ITEM_ID_SELECT_SPRITE_STAGE_NUMBER_LABEL,	//	Xe[Wio[x(ARCADE, EXPERT)
	ABVA_ITEM_ID_SELECT_SPRITE_STAGE_NUMBER,		//	Xe[Wio[l(ARCADE, EXPERT)

	ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P1,	//	ACR摜FI[gvCF1p
	ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P2,	//	ACR摜FI[gvCF2p

	ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO,		//	ACR摜FBMSFVETEvC[EBGA̗LEN

	ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO,				//	FInfoAreaFBMS^Cg,W,A[eBXg,BPM,BMStH_[ԍ,BMSf[^ԍ
	ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE,		//	FInfoAreaFBMS^Cg,W,A[eBXg,BPM,BMStH_[ԍ,BMSf[^ԍ
};

//------------------------------------------------------------------------------------------------
//	V[@AB_SCENE_PLAY
//------------------------------------------------------------------------------------------------
enum{
	ABVA_ITEM_ID_BACK_COLOR,				//	wiF

	ABVA_ITEM_ID_PLAY_GAP,					//	Mbvl

	ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_0,	//	Poor摜
	ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_1,	//	Poor摜
	ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_2,	//	Poor摜
	ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_3,	//	Poor摜

	ABVA_ITEM_ID_PLAY_IMAGE_LAYER_0,		//	LayerO摜
	ABVA_ITEM_ID_PLAY_SPRITE_LAYER_0,		//	LayerO
	ABVA_ITEM_ID_PLAY_SPRITE_LAYER_1,		//	LayerP
	
	ABVA_ITEM_ID_PLAY_SPRITE_FIELD_BASE,	//	vCtB[h
	ABVA_ITEM_ID_PLAY_SPRITE_FIELD_P1,		//	vCtB[h
	ABVA_ITEM_ID_PLAY_SPRITE_FIELD_P2,		//	vCtB[h
	
	ABVA_ITEM_ID_PLAY_SPRITE_GREAT_ZONE_BASE,
	ABVA_ITEM_ID_PLAY_SPRITE_GREAT_ZONE_P1,	//	O[gZone
	ABVA_ITEM_ID_PLAY_SPRITE_GREAT_ZONE_P2,	//	O[gZone
	
	ABVA_ITEM_ID_PLAY_SPRITE_NEON_BASE,		//	lI
	ABVA_ITEM_ID_PLAY_SPRITE_NEON_P1,		//	lI
	ABVA_ITEM_ID_PLAY_SPRITE_NEON_P2,		//	lI
	ABVA_ITEM_ID_PLAY_SPRITE_NEON_ANIME_P1,	//	lIǃAj
	ABVA_ITEM_ID_PLAY_SPRITE_NEON_ANIME_P2,	//	lIǃAj
	
	ABVA_ITEM_ID_PLAY_SPRITE_BAR_P1,		//	߃o[
	ABVA_ITEM_ID_PLAY_SPRITE_BAR_P2,		//	߃o[
	
	ABVA_ITEM_ID_PLAY_VALUE_LINE,			//	C
	ABVA_ITEM_ID_PLAY_VALUE_NOTE_OFFSET,	//	m[gItZbg
	ABVA_ITEM_ID_PLAY_VALUE_NOTE_SIZE,		//	TCY
	
	ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_WHITE,		//	obNCg
	ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_BLACK,		//	obNCg
	ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_SCRATCH,	//	obNCg
	
	ABVA_ITEM_ID_PLAY_SPRITE_NOTE_WHITE,	//	ev[g
	ABVA_ITEM_ID_PLAY_SPRITE_NOTE_BLACK,	//	ev[g
	ABVA_ITEM_ID_PLAY_SPRITE_NOTE_SCRACH,	//	ev[g
	ABVA_ITEM_ID_PLAY_SPRITE_NOTE_OBJECT,			//	IuWFNg
	ABVA_ITEM_ID_PLAY_SPRITE_FREE_SCRATCH_OBJECT,	//	t[XNb`IuWFNg
	ABVA_ITEM_ID_PLAY_SPRITE_NOTE_ANIME,			//	IuWFNgAj
	ABVA_ITEM_ID_PLAY_SPRITE_TEMPLATE_NOTE_FREE_SCRATCH,	//	t[XNb`
	
	ABVA_ITEM_ID_PLAY_SPRITE_JUDGE_P1,		//	摜
	ABVA_ITEM_ID_PLAY_SPRITE_JUDGE_P2,		//	摜
	
	ABVA_ITEM_ID_PLAY_SPRITE_SPARK,			//	SPARK
	ABVA_ITEM_ID_PLAY_SPRITE_SPARK_ANIME,	//	SPARK

	ABVA_ITEM_ID_PLAY_SPRITE_ANIME_1,		//	摜
	ABVA_ITEM_ID_PLAY_SPRITE_ANIME_2,		//	摜
	ABVA_ITEM_ID_PLAY_SPRITE_ANIME_3,		//	摜
	ABVA_ITEM_ID_PLAY_SPRITE_ANIME_4,		//	摜

	ABVA_ITEM_ID_PLAY_SPRITE_DANCE_1,		//	摜
	ABVA_ITEM_ID_PLAY_SPRITE_DANCE_2,		//	摜
	ABVA_ITEM_ID_PLAY_SPRITE_DANCE_3,		//	摜
	ABVA_ITEM_ID_PLAY_SPRITE_DANCE_4,		//	摜
	
	ABVA_ITEM_ID_PLAY_SPRITE_COMBO_COUNTER_P1,	//	R{JE^[
	ABVA_ITEM_ID_PLAY_SPRITE_COMBO_COUNTER_P2,	//	R{JE^[
	
	ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P2_OFFSET,	//	TENSIONGAUGE@Qo@ItZbgl
	ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P1,			//	TENSIONGAUGE
	ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P2,			//	TENSIONGAUGE
	
	ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG,	//	iE[fBOwi
	ABVA_ITEM_ID_PLAY_IMAGE_NOWvLOADING_BG,		//	iE[fBOwi摜
	ABVA_ITEM_ID_PLAY_SPRITE_NOW_LOADING_LOGO,	//	iE[fBOLOGO
	ABVA_ITEM_ID_PLAY_IMAGE_NOW_LOADING_LOGO,	//	iE[fBOLOGO摜
	ABVA_ITEM_ID_PLAY_SPRITE_PROGRESS_BAR,		//	iE[fBOvOXo[
	
};	

//------------------------------------------------------------------------------------------------
//	V[@AB_SCENE_FINISH
//------------------------------------------------------------------------------------------------
enum{
	ABVA_ITEM_ID_FINISH_SPRITE_COMPLETE,	//	Xe[WNALogo
	ABVA_ITEM_ID_FINISH_SPRITE_FAILED,		//	Xe[WiLogo

	ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_AREA,	//	Grapḧ
	ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_P1,	//	Graph player1
	ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_P2,	//	Graph player2
	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE_OFFSET,	//	XRA̕\ʒu
	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE_P1,	//	FPLAY StatusFSCORE, JustGreat, Great, good, bad, poor, max combo, Total
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE2_P1,	//	LꂩɊYBԂ͑S֌WȂAPɃL[蓖Ă邾ɎgpB
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE3_P1,	//	\XRApӂȂ΂ȂȂB
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE4_P1,	//	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE5_P1,	//	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE6_P1,	//	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE7_P1,	//	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE8P1,	//	

	ABVA_ITEM_ID_FINISH_SPRITE_SCORE_P2,	//	FPLAY StatusFSCORE, JustGreat, Great, good, bad, poor, max combo, Total
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE2_P2,	//	LꂩɊYBԂ͑S֌WȂAPɃL[蓖Ă邾ɎgpB
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE3_P2,	//	\XRApӂȂ΂ȂȂB
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE4_P2,	//	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE5_P2,	//	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE6_P2,	//	
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE7_P2,	//	 
	ABVA_ITEM_ID_FINISH_SPRITE_SCORE8_P2,	//	

};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABMBVAItemPreset : public ABVAItemPreset
{
private:

public:
	ABMBVAItemPreset( void );
	virtual ~ABMBVAItemPreset( void );
	
	//	ZbgAbv
	virtual void	setup( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc );

private:
	//-------------------------------------------------------------------
	//	schene	AB_SCENE_SPLASH
	//-------------------------------------------------------------------
	void	setupSplash( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc );
		
	//-------------------------------------------------------------------
	//	schene	AB_SCENE_ENTRANCE
	//-------------------------------------------------------------------
	void	setupEntrance( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc );
	
	//-------------------------------------------------------------------
	//	schene	AB_SCENE_CONFIGURATION
	//-------------------------------------------------------------------
	void	setupConfigration( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc );

	//-------------------------------------------------------------------
	//	schene	AB_SCENE_KEY_CONFIGURATION
	//-------------------------------------------------------------------
	void	setupKeyConfigration( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc );

	//-------------------------------------------------------------------
	//	schene	AB_SCENE_MUSIC_SELECT	Iȉ
	//-------------------------------------------------------------------
	void	setupMusicSelect( ABVASchemeSetupper&  inSetupper, ABVAItemBindMusicSelect*  inBinder ) throw( std::bad_alloc );
	
	//-------------------------------------------------------------------
	//	schene	AB_SCENE_ENTRY	ȏЉ
	//-------------------------------------------------------------------
	void	setupEntry( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc );

	//-------------------------------------------------------------------
	//	schene	AB_SCENE_PLAY	vC
	//-------------------------------------------------------------------
	void	setupPlay( ABVASchemeSetupper&  inSetupper, ABVAItemBindStagePlay*  inBinder ) throw( std::bad_alloc );

	//-------------------------------------------------------------------
	//	schene	AB_SCENE_FINISH	PȏI
	//-------------------------------------------------------------------
	void	setupFinish( ABVASchemeSetupper&  inSetupper, ABVAItemBindStageFinish*  inBinder ) throw( std::bad_alloc );

	//-------------------------------------------------------------------
	//	create font
	//		this->m_resFont, this->m_fontTexture Ɋi[
	//-------------------------------------------------------------------
	void	setupFont( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc );

private:
	ABVAItemResFont*		m_resFont[  ABVAItemTextSprite::M_FONT_TABLE_COUNT  ];
	ABVAItemResImage*		m_fontTexture;
};


#endif	ABMBVAItemPreset_h
