/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderEntrance.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABMBVAItemPreset.h"

#include	"ABMBVAItemRenderEntrance.h"
#include	"ABVARunner.h"

#include	"ABVAItemTextSprite.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABMBVAItemRenderEntrance
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderEntrance::ABMBVAItemRenderEntrance( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderEntrance::~ABMBVAItemRenderEntrance( void )
{
}

//-------------------------------------------------------------------------------------------------
//	
//-------------------------------------------------------------------------------------------------
ABbool	ABMBVAItemRenderEntrance::initialize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABbool	ret = true;
	ABuint	i;
	ABuint	count = inRunner->getInstanceCount( ABVA_ITEM_ID_ENTRANCE_MENU_CONTROL );
		
	//	j[zu܂B
	for( i = 0 ; i < count; i ++ ){

		//	j[InstanceQ

		//	static_cast<>Ȃ̂ŊԈႢ悤ӂ܂BNbVƂ͊ԈĂ\łB
		//	Ƃ́AABVA_ITEM_ID_ENTRANCE_MENU_CONTROL̒`ꏊƌׂȂAACeȂ̂mFĂB
		ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_ENTRANCE_MENU_CONTROL, i ));
		
		//	cɕׂ܂
		//	Instance쐬́Aŏ̃XvCgWɒtĂ̂ŁA
		//	XvCg̕AZĂ܂B
		//	iǂȂƂ͂̂QsRgAEgĎĂ݂ĉBj
		GGSprite*	sprite = &(obj->mSprite);
		sprite->m_locate.y += sprite->m_height * i;
		
		//	eNX`ݒ肵܂
		obj->setCellNumber( 0, i );
		
		//	XvCgXV܂
		sprite->update();
	}
	
 	return ret;
}

//-------------------------------------------------------------------------------------------------
//	I
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderEntrance::finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
}

//-------------------------------------------------------------------------------------------------
//	Render
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderEntrance::render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABVAItemBindEntrance*	binder = static_cast<ABVAItemBindEntrance*>(inBinder);
	ABuint	i;
	ABuint	count = inRunner->getInstanceCount( ABVA_ITEM_ID_ENTRANCE_MENU_CONTROL );
		
	//	j[̉摜ύXāAIEIԂɂ܂B

	//	EOpenGL`Ȃ̂ŁAAt@ufBOgpΓľʂoB
	//	@{IɁÅ֐FX|ƂŁAȕ\yނƂłB
	//	@ႦΉ]ƂAgkƂAWς蓙Xc
	//
	//		obj->mSprite.m_color.a = 0.5;	//	At@ufBOύX
	//

	for( i = 0 ; i < count; i ++ ){

		//	j[InstanceQ
		ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_ENTRANCE_MENU_CONTROL, i ));

		//	eNX`ݒ肵܂
		if( binder->mSelectMenuIndex == i ){
			//	IԂ̃j[BZԍw肷邾B
			obj->setCellNumber( 0, i );
		}
		else{
			//	IԂ̃j[BZԍw肷邾B
			obj->setCellNumber( 1, i );
		}
		
		//	XvCgXV܂BĂ΂Ȃƕ\ς܂B
		obj->mSprite.update();
	}

	//	Ƃ̎̓GWɔCĊłB
}

