/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMSArchitect.h

				BMS`
				ʓ|ȎĂ邪Ao邾Select-Case𖳂enumȂǒlɂ镪ȂB
				萔͔ޕɕÛŁAT̂̂t̂ʓ|B
				ȂقǁAdlύXɋȂB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABBMSArchitect_h
#define	ABBMSArchitect_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"AquanBeatsConfig.h"

#include	"ABBMseqDataArchitecture.h"


/*//////////////////////////////////////////////////////////////////////////////
*	BMS`Setup
*///////////////////////////////////////////////////////////////////////////////

//	BMStH[}bg̒`
inline	int	ABBMSeqSetArchitecture( ABBMseqDataArchitecture*  inArchitect ){
	
	//	MacBeats compatible
	//	01:dont play WAV
	inArchitect->add( 	AB_BMSEQ_EVENT_BACK_CHORUS,
						AB_BMSEQ_EVENT_KIND_NOTHING,
						AB_BMSEQ_KEYTRACK_NOTHING,
						AB_BMSEQ_OBJECT_ARRAY_NOTHING,
						AB_BMS_MUSIC_DATA_EVENT_BACK_CHORUS	);

	//	02:߂̔{i_j
	inArchitect->add( 	AB_BMSEQ_EVENT_SET_BAR_RATE,	
						AB_BMSEQ_EVENT_KIND_NOTHING,
						AB_BMSEQ_KEYTRACK_NOTHING,
						AB_BMSEQ_OBJECT_ARRAY_NOTHING,
						AB_BMS_MUSIC_DATA_EVENT_SET_BAR_RATE	);

	//	03:BPMl̓rύX
	inArchitect->add( 	AB_BMSEQ_EVENT_CHANGE_BPM,	
						AB_BMSEQ_EVENT_KIND_NOTHING,
						AB_BMSEQ_KEYTRACK_NOTHING,
						AB_BMSEQ_OBJECT_ARRAY,
						AB_BMS_MUSIC_DATA_EVENT_CHANGE_BPM	);

	//	04:BGA
	inArchitect->add( 	AB_BMSEQ_EVENT_SET_BGA,		
						AB_BMSEQ_EVENT_KIND_NOTHING,
						AB_BMSEQ_KEYTRACK_NOTHING,
						AB_BMSEQ_OBJECT_ARRAY,
						AB_BMS_MUSIC_DATA_EVENT_SET_BGA	);


//	AB_BMSEQ_EVENT_SET_EXTEND,			//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.

	//	06:PoorAj[V̕ύX
	inArchitect->add( 	AB_BMSEQ_EVENT_SET_ANIMATION,	
						AB_BMSEQ_EVENT_KIND_NOTHING,
						AB_BMSEQ_KEYTRACK_NOTHING,
						AB_BMSEQ_OBJECT_ARRAY_NOTHING,
						AB_BMS_MUSIC_DATA_EVENT_SET_ANIMATION	);

	//	07:BGA Layer transparency key color
	inArchitect->add( 	AB_BMSEQ_EVENT_SET_LAYER,		
						AB_BMSEQ_EVENT_KIND_NOTHING,
						AB_BMSEQ_KEYTRACK_NOTHING,
						AB_BMSEQ_OBJECT_ARRAY,
						AB_BMS_MUSIC_DATA_EVENT_SET_LAYER	);

	//	08:gBPM
	inArchitect->add( 	AB_BMSEQ_EVENT_SET_EX_BPM,	
						AB_BMSEQ_KEYTRACK_NOTHING,
						AB_BMSEQ_EVENT_KIND_NOTHING,
						AB_BMSEQ_OBJECT_ARRAY,
						AB_BMS_MUSIC_DATA_EVENT_SET_EX_BPM	);

	{
		//	KEYBOARDƂ͂̕ӂC
		ABBMseqSubEventType		keyTrackStart	= AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY1;
		ABBMseqSubEventType		keyTrackEnd		= AB_BMSEQ_SUB_EVENT_KEYTRACK_COUNT;

		//	enumɈˑȂ悤ɋtϊe[u
		//	KEYBOARDƂ͂̕ӂCiABBMseqSubEventTypeƕт킹邱Ɓj
		static ABbmsMusicDataNoteNumber	noteNumbers[][] = {
			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY1			, AB_BMS_MUSIC_DATA_OBJECT_KEY1 },			//	1 Key			(11,21,31,41)
			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY2			, AB_BMS_MUSIC_DATA_OBJECT_KEY2 },			//	2 Key
			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY3			, AB_BMS_MUSIC_DATA_OBJECT_KEY3 },			//	3 Key
			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY4			, AB_BMS_MUSIC_DATA_OBJECT_KEY4 },			//	4 Key
			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY5			, AB_BMS_MUSIC_DATA_OBJECT_KEY5 },			//	5 Key
			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_SCRATCH		, AB_BMS_MUSIC_DATA_OBJECT_SCRATCH },		//	scratch
			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_SCRATCH_FREE	, AB_BMS_MUSIC_DATA_OBJECT_SCRATCH_FREE },	//	free scratch

			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY6			, AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY6 },	//	6 key
			{ AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY7			, AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY7 },	//	7 key
		};

		{
			//	11-19:1P	IuWFNg
			int		i = 0;
			for( keyTrack = keyTrackStart ; keyTrack < keyTrackEnd ; keyTrack++ ){
				inArchitect->add( 	AB_BMSEQ_EVENT_OBJECT_1P,			
									AB_BMSEQ_EVENT_KIND_KEY_TRACK,
									noteNumbers[ i ][0],
									AB_BMSEQ_OBJECT_ARRAY,
									AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P + noteNumbers[ i ][1]	);
				++i;
			}
		}


		{
			//	21-29:2P	IuWFNg
			int		i = 0;
			for( keyTrack = keyTrackStart ; keyTrack < keyTrackEnd ; keyTrack++ ){
				inArchitect->add( 	AB_BMSEQ_EVENT_OBJECT_2P,			
									AB_BMSEQ_EVENT_KIND_KEY_TRACK,
									noteNumbers[ i ][0],
									AB_BMSEQ_OBJECT_ARRAY,
									AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P + noteNumbers[ i ][1] );
				++i;
			}
		}

		{
			//	31-39:1P	sIuWFNg
			int		i = 0;
			for( keyTrack = keyTrackStart ; keyTrack < keyTrackEnd ; keyTrack++ ){
				inArchitect->add( 	AB_BMSEQ_EVENT_HIDE_OBJECT_1P,	
									AB_BMSEQ_EVENT_KIND_KEY_TRACK,
									noteNumbers[ i ][0],
									AB_BMSEQ_OBJECT_ARRAY,
									AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_1P + noteNumbers[ i ][1]	);
				++i;
			}
		}

		{
			//	41-49:2P	sIuWFNg
			int		i = 0;
			for( keyTrack = keyTrackStart ; keyTrack < keyTrackEnd ; keyTrack++ ){
				inArchitect->add( 	AB_BMSEQ_EVENT_HIDE_OBJECT_2P,	
									AB_BMSEQ_EVENT_KIND_KEY_TRACK,
									noteNumbers[ i ][0],
									AB_BMSEQ_OBJECT_ARRAY,
									AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_2P + noteNumbers[ i ][1]	);
				++i;
			}
		}

	}

}

#endif	//	ABBMSArchitect_h
