/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMSRunner.h

				AquaBeats BMSV[PT[i[
				EBMSSsequencer𑀍삷AAquaBeatspclassB
				@ėp߂ׂWrapperNXłB
				@̃NXoRő삷鎖ŁAQ[vCSceneȊO̕ōĐ\ɂ鎖_܂B
				@AI[vjOAGfBOAȑIAvCȂǂł̍Đp\B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABBMSRunner_h
#define	ABBMSRunner_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"ABSequencer.h"
#include	"ABBMSTimer.h"
#include	"ABSeqBMEventAction.h"
#include	"ABMusicData.h"

class	ABVARunner;

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABBMSRunner
{
public:
	ABBMSRunner();
	virtual	~ABBMSRunner();

	//	initialize
	bool	initialize( ABVARunner*  inRunner );

	//-------------------------
	//	Method	
	//-------------------------
	//	BMSI
	bool	selectBMS( ABint8*  inSelectBMSMusic );
	
	//	IBMSJ
	bool	open( void );

	//	IBMS
	void	close( void );

	//-------------------------
	//	Method	t
	//-------------------------
	//	tJn
	void	play( void );

	//	t~
	void	stop( void );

	//	t
	bool	doPlay( void );

public:
	ABVARunner*			mVARunner;
	ABSeqBMEventAction	mBmsEventAction;
	ABSequencer			m_sequencer;
	bool				m_trueIsPlay;
private:
	ABBMSTimer			m_timer;
	ABMusicData			m_bmsMusic;
};

#endif	//	ABBMSRunner_h
