/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMSTimer.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABBMSTimer.h"

#include	<iostream>
using namespace std;

//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABBMSTimer::ABBMSTimer()
{
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABBMSTimer::~ABBMSTimer()
{
}
//-------------------------------------------------------
//	setup
//-------------------------------------------------------
void	ABBMSTimer::setup( void )
{
}

//-------------------------------------------------------
//	^C}[R[obN
//-------------------------------------------------------
void	ABBMSTimer::onEventLoop( void )
{
	double	location = 0;

	//	inNowDiffMillisećA^C}[Jňoߎ
//	this->m_baseMillisec = this->getCurrentTime();
	
	//	BPMlƁAǑĂяoԂ̍AOƌ݂̃P[VvZ
	location = (double)( this->getCurrentTime() * 1000.0d - this->m_startTime * 1000.0d ) / this->m_rezo_millisec;
	this->m_currentLocation = this->m_baseLocation + location;

	//	fire
	//	݂̃P[Vln
	this->fire( this->m_currentLocation );

//	timer->m_pre_millisec = inNowDiffMillisec;
};

//-------------------------------------------------------
//	E^C}[ZbgB
//-------------------------------------------------------
void	ABBMSTimer::startTimer( int  inBPM )
{	
	double	second = AB_GET_VALUE_BPM_TO_SECOND(inBPM);	//	P\Pʂ̕b
	this->m_rezo_millisec = second * 1000.0d;
	
	this->m_pre_millisec = 0;
	this->m_currentLocation = 0;
	this->m_baseLocation = 0;
//	this->m_baseMillisec = 0;

	//	^C}[CXg[
	this->installTimerLoop( second );
	this->m_startTime = this->getCurrentTime();
}
//-------------------------------------------------------
//	E^C}[Đݒ肷B
//-------------------------------------------------------
void	ABBMSTimer::resetTimer( int  inBPM )
{
	double	second = AB_GET_VALUE_BPM_TO_SECOND(inBPM);	//	P\Pʂ̕b
	this->m_rezo_millisec = second * 1000.0d;

	this->m_baseLocation = this->m_currentLocation;
//	this->m_baseMillisec = this->m_pre_millisec;
	
	//	^C}[Zbg
//	this->resetTimerLoop( second );
	this->removeTimerLoop();
	this->installTimerLoop( second );
	this->m_startTime = this->getCurrentTime();
}

//-------------------------------------------------------
//	E^C}[~B
//-------------------------------------------------------
void	ABBMSTimer::stopTimer( void )
{
	//	^C}[ACXg[
	this->removeTimerLoop();
}
