/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMSRunner.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABBMSRunner_h
#define	ABBMSRunner_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"BMSRunner.h"
#include	"BMSTimerAquanBeats.h"
#include	"BMSEventAquanBeats.h"

class	BMSFolder;
class	ABVARunner;
class	BMSProgressReporter;
////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	ABBMSRunner
{
public:
	BMSRunner				mBMSRunner;			//	BMS Sequencer
	BMSTimerAquanBeats		mBMSTimer;			//	BMS Sequencer timer
	BMSEventAquanBeats		mBMSEventActor;		//	BMS Sequencer event
	BMSSong*				mSong;				//	tBMS Song

	BMSFolder*				mBMSFolder;			//	DEBUG
	
public:
	ABBMSRunner();
	virtual	~ABBMSRunner();
	
	//	BMS̍Đ
	ABbool	setup( BMSPlayerConfig*  inConfig, 
					BMSProgressReporter*  inReporter, 
					BMSFolder*	inBMSFolder, 
					ABint8*		inBMSFolderName, 
					ABuint		inBMSNumber,
					ABVARunner*					inVARunner,
					ABVAItemBindStagePlay*		inItemBinder, 
					ABMBVAItemRenderStagePlay*	inItemRender );
	
	//	BMS̍ĐI
	void	cleanup( void );
};

#endif	//	ABBMSRunner_h
