/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSEventAquanBeats.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSEventAquanBeats_h
#define	BMSEventAquanBeats_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"BMSEvent.h"

class	ABMBVAItemRenderStagePlay;
class	ABVAItemBindStagePlay;
class	ABVARunner;

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSEventAquanBeats	:	public	BMSEvent
{
public:
	ABVARunner*						mVARunner;
	ABMBVAItemRenderStagePlay*		mVAItemRenderStagePlay;
	ABVAItemBindStagePlay*			mVAItemBindStagePlay;
	
public:
	BMSEventAquanBeats();
	virtual	~BMSEventAquanBeats();

	//	
	virtual	ABbool	onInit( void );
	
	//	I
	virtual	void	onFinal( void );
	
	//	CxgsRequest
	virtual	void	onPlayerEvent( ABint  inLocation, BMSSeqPlayerEvent  inEvent );

	//	ߕύXRequest
	//	Eߋ؂o[zus܂B
	virtual	void	onChangeBivrant( ABint  inLocation );
	
	//	CxgzuRequest
	//	EIuWFNg̔zus܂B
	virtual	void	onAllocEvent( ABint  inLocation, BMSSongEventData*  inEventData );

	//	CxgsRequest
	//	ECxg̎ss܂B
	virtual	void	onExecuteEvent( ABint  inLocation, BMSSongEventData*  inEventData );

	//	ǂ݃CxgsRequest
	//	EtJn̉摜\Ȃǂs܂B
	virtual	void	onFetchEvent( ABint  inLocation, BMSSongEventData*  inEventData );

	//	ATCRequest
	//	EegbNɑΉWCXeBbNL[ɉ蓖Ă܂B
	//	iۂɂ́AGW邽߁AȂĂOKłj
	virtual	void	onAssignNote( ABint  inAssignLocation,BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrackType  inTrackNumber, BMSSongEventData*  inEventData );
	//	[U[TriggerRequest
	//	EWCXeBbN̓͂͂ōsĉB
	virtual	void	onRequestTrigger( BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrigger*  ioTrigger, ABfloat32  inLocation, ABfloat32*  outTriggerLocation );
	//	ANVRequest
	//	E[U[TriggerRequestATriggerꍇɌĂт܂BŉĐĂB
	//	EtɂĂт܂B
	virtual	void	onTriggerAction( BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrackType  inTrackNumber, BMSSongEventData*  inEventData );
	
};

#endif	//	BMSEventAquanBeats_h
