/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSFolder.h

				BMS̊ǗƍĐi܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSFolder_h
#define	BMSFolder_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"GameFile.h"

#include	"BMSParserConfig.h"

#include	<vector>
#include	<string>

class	BMSResource;
class	BMSSong;

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSFolder
{
private:
	BMSResource*		m_resource;			//	ResourceǗNX
	BMSSong*			m_song;				//	JĂ\O

public:
	BMSFolder();
	virtual	~BMSFolder();
	
	//////////////////////////////
	//	BMSt@C
	//
	//	p@F
	//		1 tH_[J
	//		2 \OI 
	//		3 \OJ
	//		4 tJn
	//		5 tImF
	//		6 IA\O
	//		7 tH_[
	//
	//////////////////////////////
	
	//	BMStH_J
	//		inFolderPath	tH_[̃pX
	ABbool		openFolder( ABint8*  inFolderPath );

	//	BMStH_\O擾
	ABuint		countSong( void );
	
	//	BMStH_\OI
	ABbool		selectSong( const ABuint  inSongNumber );

	//	BMS\O擾
	ABbool		getInformation( BMSTPSongInformationPtr*  outSongInformation );

	//	BMSt@CJ
	//
	//		inDisableBMP		true = BMPt@C𖳎ēǂݍ
	//		inIntroOnly			true = ŏ̐߂̂ݓǂݎ
	//
	ABbool		openSong( const ABbool  inDisableBMP = false, const  ABbool  inIntroOnly = false );

	//	BMSt@C
	//	EĐ̂Ƃ́AIɒ~B
	void		closeSong( void );
	
	//	BMStH_
	//	E\OJĂƂ́A\OB
	void		closeFolder( void );

	//	Resource擾
	BMSResource*	getResource( void ){
		return this->m_resource;
	}
	//	\O擾
	BMSSong*		getSong( void ){
		return this->m_song;
	}

};

#endif	//	BMSFolder_h
