/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSProgressReporter.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSProgressReporter_h
#define	BMSProgressReporter_h

#include	"GlobalConfig.h"

class	BMSSong;
class	BMSResource;

////////////////////////////////////////////////////////////////////////////////
//	class BMSFolderProgressReporter
//	i󋵂񍐂NXB̃NXpāAvOXo[܂B
////////////////////////////////////////////////////////////////////////////////
class	BMSProgressReporter
{
public:
	ABint			mPhase;
	ABint			mPhaseMax;
	BMSResource*	mResource;

	BMSProgressReporter(){
	}
	virtual	~BMSProgressReporter(){
	}
	
	void	countPhaze(){
		++mPhase;
	}
	
	//	i񍐊Jn
	virtual	void	onBegin( void ){
		//	inTotalPhaseɂ̓tF[Y܂BɂςȃvOXo[z߂܂B
	}
	//	i񍐏I
	virtual	void	onEnd( void ){
	}

	//	i|[g
	virtual	void	onReport( const ABint  inSize, const ABint  inPosition ){
		//	inSizeɑAinPositionɓǂݍݐn܂B
	}
	
	void	begin( ABint  inTotalPhase, BMSResource*  inResource ){
		mPhase = 0;
		mPhaseMax = inTotalPhase;
		mResource = inResource;
		this->onBegin();
	}
	void	end( void ){
		this->onEnd();
	}
};


#endif	//	BMSProgressReporter_h
