/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSRunner.h

				BMS̊ǗƍĐi܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSRunner_h
#define	BMSRunner_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"BMSConfig.h"

class	BMSTimer;
class	BMSEvent;
class	BMSSong;
class	BMSPlayer;
class	BMSResource;

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSRunner
{
private:
	BMSTimer*		m_timer;
	BMSEvent*		m_event;
	BMSSong*  		m_song;
	BMSPlayer*		m_musicPlayer;
	BMSPlayerConfig m_config;

public:
	BMSRunner();
	virtual	~BMSRunner();
	
	//	Initialize
	ABbool	initialize( BMSPlayerConfig*  inConfig, BMSTimer*  inTimer, BMSEvent*  inEvent );

	//	finalize
	void	finalize( void );
	
	//	tJn
	ABbool		playSong( BMSSong*  inSong, BMSResource*  inRes );
	
	//	t~
	ABbool		stopSong( void );
	
	//	tIH
	ABbool		isEnd( void );

	//	BMSPlayer
	BMSPlayer*	getMusicPlayer( void ){
		return	this->m_musicPlayer;
	}
};

#endif	//	BMSRunner_h
