/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqBMJudge.h

				AquaBeatsV[PT[	

				EL[ɂ͂Ɖ̈ʒuABAD,GOOD,GREAT,JUST GREAT𔻒肷B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSeqBMJudge_h
#define	ABSeqBMJudge_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABBMSConfig.h"
#include	"ABSeqJudge.h"

/*//////////////////////////////////////////////////////////////////////////////
*	`
*///////////////////////////////////////////////////////////////////////////////

//	背x
enum{
	//	DĂ珇ɋLqĂ
	AB_SEQ_JUDGE_JUST_GREATE = 0,
	AB_SEQ_JUDGE_GREATE,
	AB_SEQ_JUDGE_GOOD,
	AB_SEQ_JUDGE_BAD,
	AB_SEQ_JUDGE_POOR,
	AB_SEQ_JUDGE_MISS,

	AB_SEQ_JUDGE_COUNT,
};
typedef	int		ABseqJudgeType;

//	Q[x
enum{
	AB_SEQ_GAME_LEVEL_EASY			= 0,
	AB_SEQ_GAME_LEVEL_NOMAL,
	AB_SEQ_GAME_LEVEL_HARD,
	AB_SEQ_GAME_LEVEL_VERY_HARD,
	
	AB_SEQ_GAME_LEVEL_COUNT,
};
typedef	int		ABseqGameLevelType;


/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqBMJudge
{
private:
	ABSeqJudge		m_judgeArray[ AB_SEQ_GAME_LEVEL_COUNT ];				//	Q[̃xɕێ

public:
	ABSeqBMJudge(){};
	~ABSeqBMJudge(){};

	//---------------------
	//	
	//---------------------
	
	//	̏
	void		initJudge( int  inBPM ){
		ABSeqJudge*			jc;
		ABseqJudgeType		jt;
		
		float	balance = 1.0f;

		//	ABł́A{Iɉ𑜓xx[XŏĂ̂ŁAɂvZ͗vȂ񂶂ȂƁB
		//	@lMacBeatɋ߂Ă܂B
		//	@ÅIɈႤci
		//	@BPMlႢAǂ悤H
		
		//	DĂ珇ɋLqĂ( ABseqJudgeTypeɕĂ )

		//	AB_SEQ_GAME_LEVEL_EASY
		jc	= &this->m_judgeArray[ AB_SEQ_GAME_LEVEL_EASY ];
		jc->clear();
		jt	= jc->addJudgeInfo(  9.5f	* balance );	//	AB_SEQ_JUDGE_JUST_GREATE
		jt	= jc->addJudgeInfo( 19.0f	* balance );	//	AB_SEQ_JUDGE_GREATE
		jt	= jc->addJudgeInfo( 36.0f	* balance );	//	AB_SEQ_JUDGE_GOOD
		jt	= jc->addJudgeInfo( 46.0f	* balance);		//	AB_SEQ_JUDGE_BAD
		jt	= jc->addJudgeInfo( -1				  );	//	AB_SEQ_JUDGE_POOR	(<--ŌɕKĂB)

		//	AB_SEQ_GAME_LEVEL_NOMAL
		jc	= &this->m_judgeArray[ AB_SEQ_GAME_LEVEL_NOMAL ];
		jc->clear();
		jt	= jc->addJudgeInfo(  8.2f	* balance );	//	AB_SEQ_JUDGE_JUST_GREATE
		jt	= jc->addJudgeInfo( 16.4f	* balance );	//	AB_SEQ_JUDGE_GREATE
		jt	= jc->addJudgeInfo( 34.0f	* balance );	//	AB_SEQ_JUDGE_GOOD
		jt	= jc->addJudgeInfo( 46.0f	* balance );	//	AB_SEQ_JUDGE_BAD
		jt	= jc->addJudgeInfo( -1				  );	//	AB_SEQ_JUDGE_POOR	(<--ŌɕKĂB)

		//	AB_SEQ_GAME_LEVEL_HARD
		jc	= &this->m_judgeArray[ AB_SEQ_GAME_LEVEL_HARD ];
		jc->clear();
		jt	= jc->addJudgeInfo(  7.0f	* balance );	//	AB_SEQ_JUDGE_JUST_GREATE
		jt	= jc->addJudgeInfo( 14.0f	* balance );	//	AB_SEQ_JUDGE_GREATE
		jt	= jc->addJudgeInfo( 29.0f	* balance );	//	AB_SEQ_JUDGE_GOOD
		jt	= jc->addJudgeInfo( 45.0f	* balance );	//	AB_SEQ_JUDGE_BAD
		jt	= jc->addJudgeInfo( -1				  );	//	AB_SEQ_JUDGE_POOR	(<--ŌɕKĂB)

		//	AB_SEQ_GAME_LEVEL_VERY_HARD
		jc	= &this->m_judgeArray[ AB_SEQ_GAME_LEVEL_VERY_HARD ];
		jc->clear();
		jt	= jc->addJudgeInfo(  6.0f 	* balance);		//	AB_SEQ_JUDGE_JUST_GREATE
		jt	= jc->addJudgeInfo( 12.0f	* balance );	//	AB_SEQ_JUDGE_GREATE
		jt	= jc->addJudgeInfo( 24.0f	* balance );	//	AB_SEQ_JUDGE_GOOD
		jt	= jc->addJudgeInfo( 43.0f	* balance );	//	AB_SEQ_JUDGE_BAD
		jt	= jc->addJudgeInfo( -1				  );	//	AB_SEQ_JUDGE_POOR	(<--ŌɕKĂB)
	}

	//---------------------
	//	
	//---------------------
		bool judge( ABseqGameLevelType  inGameLevel, float  inLocation, float  inNoteLocation, ABseqJudgeType*  outJudgeType ){
		int		j;
		bool	result;
		bool	poorIsTrue;

		for( j = 0 ; j < AB_SEQ_JUDGE_COUNT; j++ ){
			result = this->m_judgeArray[ inGameLevel ].judge( j, inLocation, inNoteLocation, &poorIsTrue );
			if( ! result ){
				//	薳̎
				if( poorIsTrue ){
					//	Ă
					*outJudgeType = AB_SEQ_JUDGE_POOR;
					return	true;
				}
				//	̑̔Ȃ̂ŁAs
			}
			else{
				//	L̎
				*outJudgeType = j;
				return	true;
			}
		}

		//	Y
		*outJudgeType = AB_SEQ_JUDGE_POOR;
		return	true;
	}

};

#endif	//	ABSeqBMJudge_h
