/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqBMSong.h

				AquaBeatsV[PT[	BMS Song

				DTMAvP[V̂悤ȕ\C[WB
				DTMł́APȂÁuTrackvuSongvƂĈA≉tsB
				eL[iP`VASCRATCHjABPMABMPȂǁAgbNɓĂ͂߂ƎRłA
				ObjectzP̃gbNƂĒۉł̂ŁAObjectz̎ʂӎKvB
				DꂽvO}[ȂA̍l𐄂i߂āAVL[g邱ƂAMODCNȃVXeւ̉ǂeՂH

				̃NXSONGƂẴf[^Ǘ̂ݍsAۂ̉t͕ʃNXSB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSeqBMSong_h
#define	ABSeqBMSong_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABBMSConfig.h"
#include	"ABSeqSong.h"

/*//////////////////////////////////////////////////////////////////////////////
*	const,etc
*///////////////////////////////////////////////////////////////////////////////
//-------------------------
//	marker
//	Eʂɕ\邽߂Ƀf[^ς鎞AB_SEQ_MARKER_HEAD_LOCATIONŎQƂA
//	@EventsƂiĐAJudgejAB_SEQ_MARKER_TAIL_LOCATIONŎQƂB
//-------------------------
enum{
	AB_SEQ_MARKER_HEAD_LOCATION,
	AB_SEQ_MARKER_TAIL_LOCATION,
	
	AB_SEQ_MARKER_COUNT,
};
typedef	int		ABseqMarkerType;

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqBMSong
{
public:
	//	method
	ABSeqBMSong(){};
	~ABSeqBMSong(){};

	//------------------
	//	setup
	//------------------
	void	setup( int  inRangeVibrantCount ){
		this->m_rangeVibrantCount	= inRangeVibrantCount;
		
		this->getSong()->createTrack( AB_SEQ_TRACK_COUNT );
		this->getSong()->createMarker( AB_SEQ_MARKER_COUNT );
		this->setMarker( 0 - this->m_rangeVibrantCount );
	}
	//------------------
	//	cleanup
	//------------------
	void	cleanup( void ){
		this->getSong()->deleteTrack();
	}
	
	//-------------------------
	//	song
	//-------------------------
	//	get song
	ABSeqSong*	getSong( void ){
		return	&this->m_song;
	}

	//-------------------------
	//	}[J[
	//-------------------------
	//	set marker
	//	gƃ[vł܂BK[hƂB
	//	ߓւ̐ݒ͂ƕGȂ̂őΉȂB
	void	setMarker( int  inVibrantPointer ){
		this->getSong()->setMarker( AB_SEQ_MARKER_HEAD_LOCATION, inVibrantPointer + this->m_rangeVibrantCount );
		this->getSong()->setMarker( AB_SEQ_MARKER_TAIL_LOCATION, inVibrantPointer );
	}
	//	move Next marker
	void	moveNextMarker( void ){
		this->getSong()->moveNextMarker( AB_SEQ_MARKER_HEAD_LOCATION );
		this->getSong()->moveNextMarker( AB_SEQ_MARKER_TAIL_LOCATION );
	}

private:
	//	member
	ABSeqSong		m_song;
	int				m_rangeVibrantCount;
};

#endif	//	ABSeqBMSong_h
