/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqBMSongAdapter.h

				BMSf[^AsequencerSongf[^ɓWJB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSeqBMSongAdapter_h
#define	ABSeqBMSongAdapter_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABBMSConfig.h"
#include	"ABSeqBMSong.h"

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqBMSongAdapter
{
public:
	ABSeqBMSongAdapter();
	~ABSeqBMSongAdapter();

	//-------------------------------------------------------
	//	Song <- BMSdata
	//-------------------------------------------------------
	bool	fill( ABSeqBMSong*  inSong, ABbmsMusicData*  inMusicData );


private:
	//	Event𔻕ʁAIuWFNgzĂƂWJB
	void	analyzeBMSEvent( ABSeqBMSong*  inSong, ABbmsEventData*  inEvent, int  inVibrantResolution, int  inVibrantLocation );

	//	BMSEventAIuWFNgWJAzɊi[
	void	analyzeObjectArray( ABSeqTrack*  inTrack, ABbmsEventData*  inEvent, int  inVibrantLocation, bool  inTrueIsObjectZeroCut );
	//	BMSEventzɊi[
	void	analyzeValue( ABSeqTrack*  inTrack, ABbmsEventData*  inEvent, int  inVibrantLocation );
	
	//
	//	͍ςEventz𐮗B
	//	ETEh̃L[ABCxgƂĖߍށB
	//	@͂ɂāAߒPʂŕ邽߁AɊ蓖Ă鉹𒲂ׂ邱ƂȂĂ܂BŃTEh`FWCxg𖄂ߍłƂɂB
	//
	void	optimizeEventArray( ABSeqTrack*  inTrack );

	//	߂LkēWJ邽߂̕ϐ
	ABfloat32	m_vibrant_rate;
	ABint		m_vr_startVibrant;
	ABint		m_currentLocation;
};

#endif	//	ABSeqBMSongAdapter_h
