/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqData.h

				AquaBeatsV[PT[f[^

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#ifndef	ABSeqData_h
#define	ABSeqData_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABSeqBMSong.h"
#include	"ABSeqBMJudge.h"
#include	"ABSeqConsumer.h"

#include	<list>
#include	<vector>

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqData
{
public:
//	typedef	std::list<int>	MSoundNumberArray;
	typedef	std::vector<int>	MSoundNumberArray;

public:
	ABSeqData(){
		m_bpm = 0;
		m_requestPlaySoundAssignNote.resize(AB_SEQ_TRACK_COUNT, 0);
		m_BMSdata = NULL;
	};
	~ABSeqData(){};
	
public:
	//---------------------------
	//	Sound list	:	L[Ɋ蓖ĂĂ鉹io[Xg(m[g)
	//---------------------------
	void	setSoundAssignNote( ABseqTrackType  inNoteKeyNumber, int  inSoundNumber ){
		this->m_requestPlaySoundAssignNote[inNoteKeyNumber] = inSoundNumber;
	}
	int		getSoundAssignNote( ABseqTrackType  inNoteKeyNumber ){
		return	this->m_requestPlaySoundAssignNote[inNoteKeyNumber];
	}
	//---------------------------
	//	BPM
	//---------------------------
	void	setBPM( int  inValue ){
		this->m_bpm = inValue;
	}
	int		getBPM( void ){
		return	this->m_bpm;
	}

public:
	//	PlayɊ֌W
	bool				m_doubleMirrorIsTrue;		//	doubleMirror[hH

	ABSeqBMSong			m_song;						//	BMSf[^
	ABSeqBMJudge		m_judge;
	int					m_bpm;
	MSoundNumberArray	m_requestPlaySoundAssignNote;	
													//	L[Ɋ蓖ĂĂ鉹io[Xg(m[g)

	ABSeqConsumer		m_consumer;
	ABbmsMusicData*		m_BMSdata;
};

#endif	//	ABSeqData_h
