/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqLoop.h

				AquaBeatsV[PT[LOOP

				BMSĐBĐ̂ݒŜŁA`A͕͂ʃNX邱ƁB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSeqLoop_h
#define	ABSeqLoop_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABSeqData.h"
#include	"ABSeqEventActionBase.h"
#include	"ABSeqBMEventAction.h"

#include	<vector>

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqLoop
{
public:
	ABSeqLoop();
	~ABSeqLoop();

	//-------------------------
	//	Method
	//-------------------------
	
	//	initialize
	bool initialize( int  inVibrantRange, ABbmsMusicData*  inBMSdata, ABSeqEventActionBase*  inEventAction );
	//	finalize
	void finalize( void );
	//	Event
	void	doEvent( int  inLocation );
	//	IH
	bool	isEnd( void );
	
	//	get bpm
	int		getBPM( void ){
		return	this->m_sequencerData.getBPM();
	}

	//	get data
	ABSeqData*	getSequencerData( void ){
		return	&this->m_sequencerData;
	}

private:
	//	݂̃P[VEvents
	void	doEventActionObjectAllocate( int  inLocation, int  inVibrantCount, int*  outVibrantResolution );
	void	doEventAction( int  inLocation );

private:
	ABSeqData					m_sequencerData;
	ABSeqEventActionBase*		m_clientEventAction;
	int			m_vibrantCount;
	int			m_vibrantOnLocationCount;
//	int			m_vibrantOnTailLocationCount;
	int			m_vibrantRange;
//	int			m_preLocation;

	std::vector<int>		m_preFetchFlagArray;
	int			m_nowBpm;

	int			m_noteCount;

};

#endif	//	ABSeqLoop_h
