/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSequencerConfig.h

				BMS Sequencer֘A̒`
				Sequencer֘A͂ŊǗ܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#ifndef	ABSequencerConfig_h
#define	ABSequencerConfig_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"ABBMSConfig.h"
#include	"ABSeqBMJudge.h"

#include	<iostream>
#include	<vector>
#include	<list>

/*//////////////////////////////////////////////////////////////////////////////
*	`
*///////////////////////////////////////////////////////////////////////////////
//-----------------------------------------
//	`IuWFNg
//-----------------------------------------
class ABSequenceDrawObject
{
public:
	ABSequenceDrawObject(){
		this->initialize(0);
	};
	~ABSequenceDrawObject(){
	};
	
	//	init
	void	initialize( ABint  inTrackCount ){
		//	1P, 2Pp
		this->mDrawTrackInfoArray.resize(inTrackCount);
		this->mDrawBGAInfo.resouceBuffer = NULL;
		this->mLocation = 0;
		this->mLocationInAlocate = 0;
		this->mPoorBMPNumber = 0;
		this->mJudgeTypeNeon = -1;
		this->mTrueIsPoorBMPDisplay = false;
		
		memset( this->mJudgeTypeSpark, false, sizeof(this->mJudgeTypeSpark) );
		this->mDrawVibrantLineArray.resize( 8, 0 );	//	ʕ\̎A߂̒KvB\鏬ߐ]TB
	}

	//	push object
	void	pushObject( ABseqTrackType  inTrackType, ABint  inLocation){
		using namespace std;
		MdrawNoteInfoArray*	array = &( this->mDrawTrackInfoArray[inTrackType].mDrawNoteInfoArray);
		MdrawNoteInfo	value;
		value.location		= inLocation;
		value.spriteNumber	= -1;
		array->push_back(value);
		cout << "-ABSequenceDrawObject::pushObject() + " << "inTrackType:" << inTrackType << " ,inLocation:" << inLocation << endl;
	}
	//	pop object	̂ĂB擾͂ȂB
	void	popObject( ABseqTrackType  inTrackType, ABint  inLocation ){
		using namespace std;
		MdrawNoteInfoArray*	array = &( this->mDrawTrackInfoArray[inTrackType].mDrawNoteInfoArray);
		MdrawNoteInfo  note = array->front();
		if( note.location < inLocation ){
			array->pop_front();
			cout << "-ABSequenceDrawObject::popObject() - " << "inTrackType:" << inTrackType << " ,inLocation:" << inLocation << endl;
		}
	}

	//	\ɎgpegbNɁA̕`zŎĂB
	//	͈̃L[\ƂȂĂAVIuWFNg͌ɒǉA
	//	`̍ς񂾃IuWFNg͐擪폜ĂB
	typedef	struct{
		ABint	location;		//	P[Vʒu
		ABint	spriteNumber;	//	XvCg
	} MdrawNoteInfo;
	typedef	std::list<MdrawNoteInfo>	MdrawNoteInfoArray;
	
	//	gbN̏
	typedef	struct{
		MdrawNoteInfoArray	mDrawNoteInfoArray;
	} MdrawTrackInfo;
	typedef	std::vector<MdrawTrackInfo>	MdrawTrackInfoArray;
	
	MdrawTrackInfoArray	mDrawTrackInfoArray;
	
	//	ߋ؂胉C̈ʒuXg
	typedef	std::list<ABint>		MdrawVibrantLength;
	MdrawVibrantLength	mDrawVibrantLineArray;
	
	//	BGA\p̏	
	typedef	struct{
		void*			resouceBuffer;	//	\Resourceԍ
		unsigned int	resouceInfo;	//	OpenGLpsurfaceԍ
	} MdrawBGAInfo;

	MdrawBGAInfo		mDrawBGAInfo;
	MdrawBGAInfo		mDrawBGALayerInfo;
	MdrawBGAInfo		mDrawBGAPoorInfo;
	
	//	IuWFNgzũP[V
	ABint	mLocationInAlocate;

	//	ŏIXṼP[V
	//	摜`SequencerƈقȂ铯xɂȂĂ邱ƂL邽߁A
	//	̒lăP[Vl߂Ȃ΂ȂȂB
	ABint	mLocation;
	
	//	߂̋؂
	bool	mTrueIsVibrantChange;
	
	//	茋
	ABseqJudgeType		mJudgeType;
	ABseqJudgeType		mJudgeTypeNeon;	//	lI\pɎgBĂsB
	bool				mJudgeTypeSpark[ AB_SEQ_TRACK_COUNT ];	//	L[ĔItrueɂB
	
	//	poor摜ԍ
	ABint	mPoorBMPNumber;
	bool	mTrueIsPoorBMPDisplay;
	ABint	mPoorTimeCounter;	//	poor摜LȎԐ
	
	//	egbÑL[
	bool	mPushedKeyInfoArray[ AB_SEQ_TRACK_COUNT ];

};

#endif	//	ABSequencerConfig_h
