/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMSConfig.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABBMSConfig_h
#define	ABBMSConfig_h

#include	"GlobalConfig.h"

/*//////////////////////////////////////////////////////////////////////////////
*	`
*///////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////
//
//	Sequencer̒`
//
//	EABł́ABMSeLXgtH[}bĝ܂܈킸A`ɕϊĎgp܂B
//@@`ɕϊ鎖ŁÃeLXgtH[}bgɈˑȂvOdlڎw܂B
//	@ႦBMSȊÕtH[}bgɑΉƂłAޕ if ȂčςނƗǂłB
//
/////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	l
//------------------------------------------------------------------------------
enum {
	AB_BMSEQ_NOTHING	= -1,		
};

//------------------------------------------------------------------------------
//	\B
//------------------------------------------------------------------------------
enum{
	AB_SEQ_EVENT_RESOLUTION		= 192,							//	Pߓ̕\B
	AB_SEQ_EVENT_RESOLUTION4	= AB_SEQ_EVENT_RESOLUTION / 4,	//	S̕\B
};


//	BPMlAP\Pʓ̕b擾
#define	AB_GET_VALUE_BPM_TO_SECOND( BPM )	( 60.0d / (double)( BPM * AB_SEQ_EVENT_RESOLUTION4) )
//	bA\Pʒl擾
#define	AB_GET_VALUE_SECOND_TO_BPM( BPM, SECOND )	( SECOND / AB_GET_VALUE_BPM_TO_SECOND(BPM) )

//---------------------------------------------
/*
*	BMS music data event type (sequencerp)
*/
//---------------------------------------------
enum {
	AB_BMSEQ_EVENT_NOTHING	= AB_BMSEQ_NOTHING,		//	l
	
	//	MacBeats compatible
	AB_BMSEQ_EVENT_BACK_CHORUS,			//	01:dont play WAV
	AB_BMSEQ_EVENT_SET_BAR_RATE,		//	02:߂̔{i_j
	AB_BMSEQ_EVENT_CHANGE_BPM,			//	03:BPMl̓rύX
	AB_BMSEQ_EVENT_SET_BGA,				//	04:BGA
//	AB_BMSEQ_EVENT_SET_EXTEND,			//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
	AB_BMSEQ_EVENT_SET_ANIMATION,		//	06:PoorAj[V̕ύX
	AB_BMSEQ_EVENT_SET_LAYER,			//	07:BGA Layer transparency key color
	AB_BMSEQ_EVENT_SET_EX_BPM,			//	08:gBPM

	AB_BMSEQ_EVENT_OBJECT_1P,			//	11-19:1P	IuWFNg
	AB_BMSEQ_EVENT_OBJECT_2P,			//	21-29:2P	IuWFNg
	AB_BMSEQ_EVENT_HIDE_OBJECT_1P,		//	31-39:1P	sIuWFNg
	AB_BMSEQ_EVENT_HIDE_OBJECT_2P,		//	41-49:2P	sIuWFNg

	//::TODO::ǉdĺAK̊gdlȂ̂L
	//ex	AB_BMSEQ_AB0100_OBJECT					//	aqua beats 1.00g
	
	AB_BMSEQ_EVENT_COUNT,
};
typedef	int		ABBMseqEventType;


//------------------------------------------------------------------------------
//	BMS music data event type (sequencerp)
//------------------------------------------------------------------------------

//	̃Cxgĺ@ABbmsMusicDataEventType@Sequencerł̂ݎgpAgCxgłB
//	Sequencer̃vO~O邽߂̂̂Ȃ̂ŁABMSf[^Ɋ܂߂Ă͂܂B
enum{
	AB_BMSEQ_EVENT_SOUND_CHANGE		= (int)0x10000001,		//	TEh`FWCxg(L[ɉ蓖Ă^C~Ow肷Cxg)
};

//------------------------------------------------------------------------------
//	TRACK
//	BMStH[}bgƈقȂlB
//------------------------------------------------------------------------------
enum{
	AB_SEQ_TRACK_EVENT,		//	ObjectzȂEvent

	AB_SEQ_TRACK_PLAYER1_KEY1,
	AB_SEQ_TRACK_PLAYER1_KEY2,
	AB_SEQ_TRACK_PLAYER1_KEY3,
	AB_SEQ_TRACK_PLAYER1_KEY4,
	AB_SEQ_TRACK_PLAYER1_KEY5,
	AB_SEQ_TRACK_PLAYER1_KEY6,
	AB_SEQ_TRACK_PLAYER1_KEY7,
	AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH,
	AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE,
	
	AB_SEQ_TRACK_PLAYER2_KEY1,
	AB_SEQ_TRACK_PLAYER2_KEY2,
	AB_SEQ_TRACK_PLAYER2_KEY3,
	AB_SEQ_TRACK_PLAYER2_KEY4,
	AB_SEQ_TRACK_PLAYER2_KEY5,
	AB_SEQ_TRACK_PLAYER2_KEY6,
	AB_SEQ_TRACK_PLAYER2_KEY7,
	AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH,
	AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH_FREE,
	
//	AB_SEQ_TRACK_BACK_CHORUS,
//	AB_SEQ_TRACK_BGA,
//	AB_SEQ_TRACK_BPM,
//	AB_SEQ_TRACK_POOR_ANIMATION,
//	AB_SEQ_TRACK_LAYER,

	AB_SEQ_TRACK_COUNT,
};
typedef	int		ABseqTrackType;

//---------------------------------------------
/*
*	BMS music data event key track type (sequencerp)
*/
//---------------------------------------------
enum {
	AB_BMSEQ_KEYTRACK_NOTHING	= AB_BMSEQ_NOTHING,
	
	//	for 5 key mode
	AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY1,			//	1 Key			(11,21,31,41)
	AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY2,			//	2 Key
	AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY3,			//	3 Key
	AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY4,			//	4 Key
	AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY5,			//	5 Key
	AB_BMSEQ_SUB_EVENT_KEYTRACK_SCRATCH,		//	scratch
	AB_BMSEQ_SUB_EVENT_KEYTRACK_SCRATCH_FREE,	//	free scratch
	//	for 7 Key mode
	AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY6,			//	6 key	
	AB_BMSEQ_SUB_EVENT_KEYTRACK_KEY7,			//	7 key	(for 7 Key mode)
	
	AB_BMSEQ_SUB_EVENT_KEYTRACK_COUNT,
};
typedef	int		ABBMseqSubEventType;

//------------------------------------------------------------------------------
//	BMS music data Event kind (sequencerp)
//------------------------------------------------------------------------------

enum {
	AB_BMSEQ_EVENT_KIND_NOTHING	= AB_BMSEQ_NOTHING,
	AB_BMSEQ_EVENT_KIND_KEY_TRACK,						//	1 Key...n Keyw肷Event
};
typedef	int		ABBMseqEventKind;

//------------------------------------------------------------------------------
//	BMS music data object array type (sequencerp)
//------------------------------------------------------------------------------
enum {
	AB_BMSEQ_OBJECT_ARRAY_NOTHING	= AB_BMSEQ_NOTHING,	//	ObjectzĂȂ
	AB_BMSEQ_OBJECT_ARRAY,								//	ObjectzĂ
};
typedef	int		ABBMseqObjectArrayType;

#endif	//	ABBMSConfig_h