/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GamePreference.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GamePreference.h"
#include	"GameString.h"

#include	"CWPreferenceService.h"
using namespace	code_worker;

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
GamePreference::GamePreference( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
GamePreference::~GamePreference( void )
{
}

//-------------------------------------------------------------------------------------------------
//	ۑ
//-------------------------------------------------------------------------------------------------
ABbool	GamePreference::writeBinary( const ABint8*  inKey,  const ABuint8*  inBuffer, const ABsize  inSize )
{
	GameString		str;
	str.setCString( inKey );
	ABbool	ret = PSWriteBinary( str.getString(), inBuffer, inSize );
	PSSynchronize();
	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	ǂݍ
//-------------------------------------------------------------------------------------------------
ABsize	GamePreference::getBinaryDize( const ABint8*  inKey )
{
	GameString		str;
	str.setCString( inKey );
	return	PSGetBinarySize( str.getString() );
}

ABbool	GamePreference::getCopyBinary( ABint8*  inKey, ABuint8*  ioBuffer, const ABsize  inSize )
{
	GameString		str;
	str.setCString( inKey );
	return	PSCopyBinary( str.getString(), ioBuffer, inSize );
}
