/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameSingleton.cpp

				Q[GWVOg
				VOgȃNX܂Ƃ߂̃VOgNXB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GameSingleton_h
#define	GameSingleton_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"CWorkerSingletonBase.h"

#include	"GameView.h"
#include	"GGRender.h"
#include	"GameJoystick.h"
#include	"GameAudio.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GameSingleton
{
public:

	//	܂Ƃ߂邾

	GGRender		m_render;
	GameJoystick	m_joystick;
	GameAudio		m_audio;
	
	GameView*		m_gameView;

protected:
	GameSingleton( void ):
		m_gameView( NULL )
	{
	};
	virtual ~GameSingleton( void ){
	};
	GameSingleton( const GameSingleton& );
	GameSingleton&	operator = ( const GameSingleton& );
};
//	singleton
typedef	code_worker::CWorkerSingletonBase<GameSingleton>		GameSingletonClass;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	Get singleton
//
//////////////////////////////////////////////////////////////////////////////////////////////////
GameSingleton&			GameGetSingleton( void );
GameView*				GameGetView( void );
GGRender&				GGGetRender( void );
GameJoystick&			GameGetJoystick( void );
GameAudio&				GameGetAudio( void );

#endif	GameSingleton_h
