/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameString.cpp

				t@C

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GameString_h
#define	GameString_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"

//	Encoding
#define		GS_ENCORDING_SYSTEM			( CFStringGetSystemEncoding() )
#define		GS_ENCORDING_WINDOW_LATIN1	( kCFStringEncodingWindowsLatin1 )
#define		GS_ENCORDING_MAC_ROMAN		( kCFStringEncodingMacRoman )
#define		GS_ENCORDING_ASCII			( kCFStringEncodingASCII )
#define		GS_ENCORDING_UNICODE		( kCFStringEncodingUnicode )
#define		GS_ENCORDING_UTF8			( kCFStringEncodingUTF8 )

#define		GS_ENCORDING_SHIT_JIS		( kTextEncodingShiftJIS )


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	GameString
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GameString
{
private:
	CFStringRef		m_ref;

public:
	GameString( void );
	~GameString( void );

	//	C񂩂琶
	ABbool	setCString( const ABint8*  inStr, const ABuint32  inEncording  = GS_ENCORDING_ASCII);
	
	//	C擾
	ABbool	getCString( ABint8*  outStr, const ABsize  inSize, const ABuint32  inEncording = GS_ENCORDING_ASCII);
	
	//	
	void	release();

	GEunicodeTextPtr		get( void ){
		return	(GEunicodeTextPtr)this->m_ref;
	}

	//	Copy
	void	copy( GEunicodeTextPtr  inString );

public:
	//	Ŏgp
	CFStringRef		getString( void ){
		return	this->m_ref;
	}
	
	void show( void ){
		CFShow(this->m_ref);
	}
};

#endif	GameString_h
