/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / PreferenceService
*	File:		CWPreferenceService.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/5/03	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWPreferenceService_h
#define	CWPreferenceService_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Function
//
////////////////////////////////////////////////////////////////////////////////

//	write preference data
CW_EXTERN	CWbool			PSWriteInt( const CFStringRef  inKeyString, const CWint  inValue );
CW_EXTERN	CWbool			PSWriteFloat( const CFStringRef  inKeyString, const CWfloat32  inValue );
CW_EXTERN	CWbool			PSWriteDouble( const CFStringRef  inKeyString, const CWfloat64  inValue );
CW_EXTERN	CWbool			PSWriteString( const CFStringRef  inKeyString, const CFStringRef  inValue );
CW_EXTERN	CWbool			PSWriteBinary( const CFStringRef  inKeyString, const CWuint8*  inData, const CWsize  inSize );

//	read preference data
CW_EXTERN	CWint			PSCopyInt( const CFStringRef  inKeyString );
CW_EXTERN	CWfloat32		PSCopyFloat( const CFStringRef  inKeyString );
CW_EXTERN	CWfloat64		PSCopyDouble( const CFStringRef  inKeyString );
CW_EXTERN	CFStringRef		PSCopyString( const CFStringRef  inKeyString );
//	ioData͗\ߊmۂĂKvL܂B
CW_EXTERN	CWsize			PSGetBinarySize( const CFStringRef  inKeyString );
CW_EXTERN	CWbool			PSCopyBinary( const CFStringRef  inKeyString, CWuint8*  ioData, const CWsize  inSize );

//	read preference data / syncro
CW_EXTERN	void				PSSynchronize( void );

//	get identity
//	sAvP[ṼohAACfeBeB擾AԂ܂B
CW_EXTERN	CFStringRef		PSGetIdentity( void );


//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//CWPreferenceService_h