/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / FileNavigationService
*	File:		CWResourceService.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				FileNavigatioñT|[g
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/19	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/04/09>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWResourceService_h
#define	CWResourceService_h

#include	"CWorkerConfig.h"

//	Carbon
#include 	<Carbon/Carbon.h>

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus
	

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//
//	oh
//
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	AvP[Voh擾
//
//		F	CFStringRef  inFrameWorkName
//		ߒlF	CFBundleRef						֎~
//------------------------------------------------------------------------------
CW_EXTERN CFBundleRef		RSGetMainBundleRef( void );

//------------------------------------------------------------------------------
//	AvP[VpbP[W̎wt[[Noh擾
//
//		F	CFStringRef  inFrameWorkName
//		ߒlF	CFBundleRef						gp͉Ă
//------------------------------------------------------------------------------
CW_EXTERN CFBundleRef		RSCopyFrameworkBundleRef( const CFStringRef  inFrameWorkName );

////////////////////////////////////////////////////////////////////////////////
//
//	Resource
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	woh̃\[XFSSpec擾
//
//		F@CFBundleRef			bundleRef			ǂݎoh
//		F@CFStringRef			fileDirectory		\[XtH_[ȉDirectory
//		F@CFStringRef			fileName			t@C
//		F@CFStringRef			fileType			t@Cgq
//		F@FSSpec*				pFileInfo			擾FSSpec
//		F	FSRef*				pFileRef			擾FSRef
//		ߒlF	CWresultCode
//------------------------------------------------------------------------------
CW_EXTERN CWresultCode		RSBundleGetResourceFile( 
	const CFBundleRef	bundleRef,
	const CFStringRef	fileDirectory, 
	const CFStringRef	fileName, 
	const CFStringRef	fileType,  
	FSSpec*				pFileInfo,  
	FSRef*				pFileRef
);

//------------------------------------------------------------------------------
//	\[XFSSpec擾
//
//		F@CFStringRef			fileDirectory		\[XtH_[ȉDirectory
//		F@CFStringRef			fileName			t@C
//		F@CFStringRef			fileType			t@Cgq
//		F@FSSpec*				pFileInfo			擾FSSpec
//		F	FSRef*				pFileRef			擾FSRef
//		ߒlF	CWresultCode
//------------------------------------------------------------------------------
#define	RSGetResourceFile( DIR, NAME, TYPE, SPEC, REF )	RSBundleGetResourceFile( RSGetMainBundleRef(), (DIR), (NAME), (TYPE), (SPEC), (REF) )

//------------------------------------------------------------------------------
//	woh̃[JCYeLXg擾
//
//		F	CFBundleRef  inBundleRef
//		F	CFStringRef  inKey
//		F	CFStringRef  inValue
//		F	CFStringRef  inTableName
//		ߒlF	CFStringRef
//------------------------------------------------------------------------------
CW_EXTERN CFStringRef		RSBundleCopyLocalizedString( const CFBundleRef  inBundleRef, const CFStringRef  inKey, const CFStringRef  inValue, const CFStringRef  inTableName );

//------------------------------------------------------------------------------
//	[JCYeLXg擾
//
//		F	CFStringRef  inKey
//		F	CFStringRef  inValue
//		ߒlF	CFStringRef
//------------------------------------------------------------------------------
#define	RSCopyLocalizedString( KEY, VALUE )						RSBundleCopyLocalizedString( RSGetMainBundleRef(), (KEY), (KEY), NULL )

//------------------------------------------------------------------------------
//	[JCYeLXg擾
//
//		F	CFStringRef  inKey
//		F	CFStringRef  inValue
//		F	CFStringRef  inTableName
//		ߒlF	CFStringRef
//------------------------------------------------------------------------------
#define	RSCopyLocalizedStringFromTable( KEY, VALUE, TABLE )		RSBundleCopyLocalizedString( RSGetMainBundleRef(), (KEY), (KEY), (TABLE) )

#ifdef __cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif __MWERKS__
#endif __cplusplus

#endif	//CWResourceService_h