/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	
*	File:		CWorkerConfig.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				Jxc[
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/02/01	Itinoshe Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWorkerConfig_h
#define	CWorkerConfig_h

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	C++֐Cւ̊OJ
//------------------------------------------------------------------------------
#ifdef	__cplusplus
	#define	CW_EXTERN	extern "C"
#else
	#define	CW_EXTERN
#endif	__cplusplus

//------------------------------------------------------------------------------
//	ˑ邩Ȃϐ^
//------------------------------------------------------------------------------
typedef	bool				_CWbool;

//------------------------------------------------------------------------------
//	ϐ^
//------------------------------------------------------------------------------
typedef	_CWbool				CWbool;

typedef	int					CWint;
typedef	char				CWint8;
typedef	short				CWint16;
typedef	long				CWint32;
typedef	long long			CWint64;

typedef	unsigned int		CWuint;
typedef	unsigned char		CWuint8;
typedef	unsigned short		CWuint16;
typedef	unsigned long		CWuint32;
typedef	unsigned long long	CWuint64;

typedef	float				CWfloat32;
typedef	double				CWfloat64;

typedef	unsigned int		CWsize;
typedef	unsigned long		CWusize;
typedef	int					CWtype;

//------------------------------------------------------------------------------
//	G[^
//------------------------------------------------------------------------------
typedef	CWtype				CWresultCode;
enum{
	CW_NO_ERROR					= 0,
	CW_ERROR					= -1,
	
	CW_FAITAL_MEMORY_ALLOC		= -2,						//	[̊mۂɎs
	CW_FAITAL_ARGUMENT			= -3,						//	G[
};

//------------------------------------------------------------------------------
//	B^
//------------------------------------------------------------------------------
#define		OPAQUA_STRUCT( TYPE )	TYPE{ void* _empty; }	//	J^\

////////////////////////////////////////////////////////////////////////////////
//
//	utility tool
//
////////////////////////////////////////////////////////////////////////////////
//	get array count
//	z̔z񐔂Ԃ
//		EX:
//
//		CWint		array[1000];
//		CWsize		arrayCount = CWGetArrayCount( CWint, array );
//
#define		CWGetArrayCount( T, V )	( sizeof(V) / sizeof(T) )

#endif	//CWorkerConfig_h