/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorkerUniversal
*	File:		CWorkerSingletonBase.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				singleton class
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/02/01	Itinoshe Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWorkerSingletonBase_h
#define	CWorkerSingletonBase_h

namespace code_worker{


/*
	p@

	//	Step 1
	//		singletonɂNX`

		class	Sample
		{
		protected:
			//	singleton̗Bꐫۂ߂ɁAInstance쐬łȂ悤݂
			Sample( void ){};
			virtual ~Sample( void ){};
			Sample( const Sample& );
			Sample&	operator = ( const Sample& );
		};


	//	Step 2
	//		singletonƂĒ`

		typedef	CWorkerSingletonBase<Sample>		SampleSingleton;


	//	Step 3
	//		gp

		Sample&   object = SampleSingleton::getInstance();

	//	ӓ_
	//		
			GCCCodeWarriorł́ATemplate̓WJ@قȂ̂ŒӁB
			@GCĆA *.cpp ɁAgetInstance()UƁAقȂCX^X𐶐B
			@ACWł́At@CɊ֌WȂP̃CX^XƂȂB
			@iCWŉCApplicationAXCodeŐRpCꂽɂւ炸ẢApplicationɉBj
			@GCCRpCɓKLqKvAǂĂȂ̂őΏĂȂB
			@肠AȒPȃANZbT֐pӂB
		
			Sample.h
				Sample&		SampleGetInstance( void );

			Sample.cpp
				Sample&		SampleGetInstance( void ){
					return	SampleSingleton::getInstance();
				}
*/

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
template< typename	T >	
class	CWorkerSingletonBase : public T{
public:

	//	Get singleton instance
	static 	T&	getInstance( void );

private:
	//	Create
	static	T&	_create( void );
};

//------------------------------------------------------------------------------
//	 Get singleton instance
//------------------------------------------------------------------------------
template< typename	T >	
T&	CWorkerSingletonBase<T>::getInstance( void )
{
	return	CWorkerSingletonBase<T>::_create();
}

//------------------------------------------------------------------------------
//	Create
//------------------------------------------------------------------------------
template< typename	T >	
T&		CWorkerSingletonBase<T>::_create( void ){
	static	CWorkerSingletonBase<T>		singlton;
	return	singlton;
}

}
#endif	//CWorkerSingletonBase_h