/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		AquanBeatsConfig.h

	Encoding:	Shift-JIS

				et@CŋLeݒB
				gDPʂŉB`͕ʂ̃t@CɕĂĉB

	Version:	
		version 1.00	2003/08/10	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	AquanBeatsConfig_h
#define	AquanBeatsConfig_h

#include	"OSconfig.h"
#include	"GameEngine.h"
#include	"GameFile.h"

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

/////////////////////////////////////////////////////////////////////////////////
/*
	AquaBeats Version Numver

	Eo[W݊ꍇ́A̒萔gĂB
	@Ⴆ΃}bNpɋ@\ǉƂ́A
	@AB_VERASION_0100_MACONLY	'M100'	Ȃǂƒ`āA#ifdefň͂񂾂肵Ă܂B
	Edl̕KvɉĐV؂ĂB
	iƗǂ@LΏOKj
*/
/////////////////////////////////////////////////////////////////////////////////

#define	MB_VERASION_0083			'0083'	//	(MacBeats݊)
#define	MB_VERASION_0095			'0095'	//	(MacBeats݊)
#define	MB_VERASION_0097			'0097'	//	(MacBeats݊)

#define	AB_VERASION_0100			'0100'	//	AquaBeats version 1.00 (MacBeats݊)

//	Jgo[W(ɍŐVo[W)
#define	AB_VERASION_COMPILE			AB_VERASION_0100




/*/////////////////////////////////////////////
*
*	AquanBeat Option
*	IvVݒʂ̒`ł
*
*//////////////////////////////////////////////
//---------------------------------------------
/*
*	game option
*/
//---------------------------------------------
enum
{
	AB_OPTION_FIRST		= 0,	//<-JnlB
	AB_OPTION_Nothing	= -1,	//<-lBtɏ͖̂ǁAďƎgl@0@n߂̂œsǂB
								//@ǉƂłAԂB
	
	AB_OPTION_Volume,
	AB_OPTION_IsSE,

	AB_OPTION_SPRIT_1,	//	󔒍s

	AB_OPTION_IsIgnorePoor,
	AB_OPTION_ComboLevel,
	AB_OPTION_HiSpeedLevel,

	AB_OPTION_All7Keys,

	AB_OPTION_SPRIT_2,	//	󔒍s

	AB_OPTION_LAYOUT_CENTER_PLAY,
	AB_OPTION_AUTO_PLAY_P1,
	AB_OPTION_AUTO_PLAY_P2,

	AB_OPTION_SPRIT_3,	//	󔒍s

	AB_OPTION_ScreenSize,
	AB_OPTION_Scheme,
	AB_OPTION_SchemeSet,

	AB_OPTION_SPRIT_4,	//	󔒍s

	AB_OPTION_SOUND_SAMPLE_RATE,
	AB_OPTION_SOUND_CHANNEL_COUNT,
	AB_OPTION_DRAW_FRAME_RATE,
	AB_OPTION_SOUND_CACHE_SIZE,

	AB_OPTION_SPRIT_5,	//	󔒍s

	AB_OPTION_RESET,
	AB_MENU_OK,
	AB_MENU_CANCEL,

	AB_OPTION_max,
};									//<-typedefŒڒ`ƁAGCCRpCswitchgpɑSgpȂƌxoB
typedef	ABtype	ABgameOptionType;	//<-g̕CyB

class	ABConfigCaptionArray{
public:
	//	̎擾֐(Vڂǉ炱ɂǉĂ)
	//@ȂӂɏĂ݂ƁAO[oϐ֗Bcppɏė΂ȂɂȂȂŌXyH
	static ABint8*		getLabelCaption( ABgameOptionType  inIndex )
	{
		static	ABint8*		value[AB_OPTION_max];
		static	ABbool		setup = false;
		
		if( !setup ){
			ABint	i;
			for( i = 0 ; i < sizeof(value) / sizeof(value[0]); i ++ ){
				//	NULLw肵Ă͂܂BVAłA\ȂȂĂ܂܂B
				value[i] = "";
			}

			value[AB_OPTION_Volume] 		= "MASTER VOLUME";			//	AB_OPTION_Volume,

			value[AB_OPTION_IsSE]		 	= "USE SOUND REVERB";		//	AB_OPTION_IsSE,

			value[AB_OPTION_IsIgnorePoor] 	= "USE IGNORE POOR";		//	AB_OPTION_IsIgnorePoor,
			value[AB_OPTION_ComboLevel] 	= "USE COMBO";				//	AB_OPTION_ComboLevel,
			value[AB_OPTION_HiSpeedLevel] 	= "HI-SPEED RATE";			//	AB_OPTION_HiSpeedLevel,
			value[AB_OPTION_All7Keys] 		= "FORCE 7 KEYS MODE";		//	AB_OPTION_All7Keys,

			value[AB_OPTION_LAYOUT_CENTER_PLAY] = "LAYOUT MODE CENTER PLAY";		//
			value[AB_OPTION_AUTO_PLAY_P1] 		= "AUTO PLAY MODE PLAYER 1";	//	
			value[AB_OPTION_AUTO_PLAY_P2] 		= "AUTO PLAY MODE PLAYER 2";		//	

			value[AB_OPTION_ScreenSize] 	= "SCREEN SIZE";			//	AB_OPTION_ScreenSize
			value[AB_OPTION_Scheme] 		= "SCHEME FOLDER";			//	AB_OPTION_Scheme
			value[AB_OPTION_SchemeSet] 		= "SCHEME SET";				//	AB_OPTION_SchemeSet

			value[AB_OPTION_SOUND_SAMPLE_RATE] 		= "SOUND SAMPLE RATE",		//	AB_OPTION_SOUND_SAMPLE_RATE,
			value[AB_OPTION_SOUND_CHANNEL_COUNT] 	= "SOUND CHANNEL MODE",		//	AB_OPTION_SOUND_CHANNEL_COUNT,
			value[AB_OPTION_DRAW_FRAME_RATE] 		= "DRAW FRAME RATE",		//	AB_OPTION_DRAW_FRAME_RATE,
			value[AB_OPTION_SOUND_CACHE_SIZE] 		= "CACHE SIZE";				//	AB_OPTION_SOUND_CACHE_SIZE

			value[AB_OPTION_RESET] 			= "-RESET DEFAULT";			//	AB_OPTION_RESET,
			value[AB_MENU_OK] 				= "-SAVE OPTION";			//	AB_MENU_OK,
			value[AB_MENU_CANCEL] 			= "-CANCEL";				//	AB_MENU_CANCEL,
			
			setup = true;
		}
		
		if( AB_OPTION_FIRST <= inIndex && inIndex < AB_OPTION_max ){
			return	value[ inIndex ];
		}
		else{
			return	NULL;
		}
	}
};

//---------------------------------------------
/*
*	key config
*/
//---------------------------------------------
enum
{
	AB_KEY_CONFIG_FIRST		= 0,
	AB_KEY_CONFIG_Nothing	= -1,
	
	//	ݒ\ȃL[BUSBuŎgp\Ȃ̂Ɍ肷BESCAL[̓L[{[hpƂAύXs\ɂĂB
	AB_KEY_CONFIG_1P_KEY1,
	AB_KEY_CONFIG_1P_KEY2,
	AB_KEY_CONFIG_1P_KEY3,
	AB_KEY_CONFIG_1P_KEY4,
	AB_KEY_CONFIG_1P_KEY5,
	AB_KEY_CONFIG_1P_KEY6,
	AB_KEY_CONFIG_1P_KEY7,
	AB_KEY_CONFIG_1P_SCRATCH_LEFT,			//	E
	AB_KEY_CONFIG_1P_SCRATCH_RIGHT,			//	

	AB_KEY_CONFIG_2P_KEY1,
	AB_KEY_CONFIG_2P_KEY2,
	AB_KEY_CONFIG_2P_KEY3,
	AB_KEY_CONFIG_2P_KEY4,
	AB_KEY_CONFIG_2P_KEY5,
	AB_KEY_CONFIG_2P_KEY6,
	AB_KEY_CONFIG_2P_KEY7,
	AB_KEY_CONFIG_2P_SCRATCH_LEFT,			//	E
	AB_KEY_CONFIG_2P_SCRATCH_RIGHT,			//	

	AB_KEY_CONFIG_START,

	AB_KEY_CONFIG_RESET,
	AB_KEY_CONFIG_OK,
	AB_KEY_CONFIG_CANCEL,

	AB_KEY_CONFIG_max,
};
typedef	ABtype	ABgameOptionType;

class	ABKeyConfigCaptionArray{
public:
	static ABint8*		getLabelCaption( ABgameOptionType  inIndex )
	{
		//	̎擾֐(Vڂǉ炱ɂǉĂ)
		//@ȂӂɏĂ݂ƁAO[oϐ֗Bcppɏė΂ȂɂȂȂŌXyH
		static	ABint8*		value[AB_KEY_CONFIG_max] =
		{
			"1P-KEY 1 (WHITE 1)......",		//	AB_KEY_CONFIG_1P_KEY1,
			"1P-KEY 2 (BLACK 1)......",		//	AB_KEY_CONFIG_1P_KEY2,
			"1P-KEY 3 (WHITE 2)......",		//	AB_KEY_CONFIG_1P_KEY3,
			"1P-KEY 4 (BLACK 2)......",		//	AB_KEY_CONFIG_1P_KEY4,
			"1P-KEY 5 (WHITE 3)......",		//	AB_KEY_CONFIG_1P_KEY5,
			"1P-KEY 6 (BLACK 3)......",		//	AB_KEY_CONFIG_1P_KEY6,
			"1P-KEY 7 (WHITE 4)......",		//	AB_KEY_CONFIG_1P_KEY7,
			"1P-SCRATCH TURN LEFT....",		//	AB_KEY_CONFIG_1P_SCRATCH_LEFT,
			"1P-SCRATCH TURN RIGHT...",		//	AB_KEY_CONFIG_1P_SCRATCH_RIGHT,

			"2P-KEY 1 (WHITE 1)......",		//	AB_KEY_CONFIG_2P_KEY1,
			"2P-KEY 2 (BLACK 1)......",		//	AB_KEY_CONFIG_2P_KEY2,
			"2P-KEY 3 (WHITE 2)......",		//	AB_KEY_CONFIG_2P_KEY3,
			"2P-KEY 4 (BLACK 2)......",		//	AB_KEY_CONFIG_2P_KEY4,
			"2P-KEY 5 (WHITE 3)......",		//	AB_KEY_CONFIG_2P_KEY5,
			"2P-KEY 6 (BLACK 3)......",		//	AB_KEY_CONFIG_2P_KEY6,
			"2P-KEY 7 (WHITE 4)......",		//	AB_KEY_CONFIG_2P_KEY7,
			"2P-SCRATCH TURN LEFT....",		//	AB_KEY_CONFIG_2P_SCRATCH_LEFT,
			"2P-SCRATCH TURN RIGHT...",		//	AB_KEY_CONFIG_2P_SCRATCH_RIGHT,

			"START BUTTON............",		//	AB_KEY_CONFIG_START,

			"RESET DEFAULT",						//	AB_MENU_RESET,
			"OK",									//	AB_MENU_OK,
			"CANCEL",								//	AB_MENU_CANCEL,
		};
		
		if( AB_KEY_CONFIG_FIRST <= inIndex && inIndex < AB_KEY_CONFIG_max ){
			return	value[ inIndex ];
		}
		else{
			return	NULL;
		}
	}
};

//---------------------------------------------
/*
*	^Cgʂ̃j[
*/
//---------------------------------------------
typedef enum{
	AB_TITLE_MENU_FREE_STYLE		= 0,
	AB_TITLE_MENU_ARCADE,
	AB_TITLE_MENU_EXPART,
	AB_TITLE_MENU_SELECT_SCHEME,
	AB_TITLE_MENU_KEY_CONFIG,
	AB_TITLE_MENU_OPTION,
	AB_TITLE_MENU_QUIT,
	
	AB_TITLE_MENU_COUNT,
} ABtitleMenuType;

//---------------------------------------------
/*
*	CONFIGURATION setting
*/
//---------------------------------------------
enum
{
	ABplayOption_Nothing = 0,

	ABplayOption_AutoPlay1P,
	ABplayOption_AutoPlay2P,
	ABplayOption_AutoScratch1P,
	ABplayOption_AutoScratch2P,

	ABplayOption_KeyMode,
	ABplayOption_HiSpeedLevel,
	ABplayOption_IsSudden,
	ABplayOption_IsHidden,
	ABplayOption_IsAnimation,

	ABplayOption_IsLayout5Keys,
	ABplayOption_IsLayout7Keys,
	ABplayOption_All7Keys,

	ABplayOption_NeonAnimation,
	ABplayOption_DrawGreatZone,
	ABplayOption_TitleShade,
	ABplayOption_SelectShade,
	ABplayOption_FastTyping,
	
	ABplayOption_Dance1UseBlitKey,
	ABplayOption_Dance2UseBlitKey,
	ABplayOption_BlinkSpark,
	ABplayOption_StandInLineStar,
	
	ABplayOption_BattlePlay,
	ABplayOption_DoublePlay,

	ABplayOption_GameLevel,
	ABplayOption_BlinkAnimObj,	
	ABplayOption_Dance3UseBlitKey,
	ABplayOption_Dance4UseBlitKey,

	ABplayOption_max,
};
typedef ABtype	ABplayOptionType;

//---------------------------------------------
/*
*	CONFIGURATION	combo lebal
*/
//---------------------------------------------
enum
{
	ABComboLevel_None,
	ABComboLevel_Great,
	ABComboLevel_Good
};
typedef ABtype	ABcomboLevelType;

//---------------------------------------------
/*
*	CONFIGURATION	note alocation pattern mode
*/
//---------------------------------------------
enum
{
	ABKeyMode_Normal,
	ABKeyMode_Mirror,
	ABKeyMode_Random,
	ABKeyMode_Shuffle
};
typedef ABtype	ABkeyModeType;

//	AB not suport
////---------------------------------------------
///*
//*	CONFIGURATION	track layout style (5 key)
//*/
////---------------------------------------------
//enum
//{
//	ABLauout5keys_RR,
//	ABLauout5keys_RL,
//	ABLauout5keys_LL,
//	ABLauout5keys_LR
//};
//typedef ABtype	ABlauout5keysType;

////---------------------------------------------
///*
//*	CONFIGURATION	track layout style (7 key)
//*/
////---------------------------------------------
//enum
//{
//	ABLauout7keys_LR,
//	ABLauout7keys_RR,
//	ABLauout7keys_LL,
//	ABLauout7keys_RL
//};
//typedef ABtype	ABlauout7keysType;

//---------------------------------------------
/*
*	CONFIGURATION	poor BGA display mode
*/
//---------------------------------------------
enum
{
	ABPoorMode_Picture = 0,
	ABPoorMode_Noise,
	ABPoorMode_None,
	ABPoorMode_AllNoise
};
typedef ABtype	ABpoorModeType;

//---------------------------------------------
/*
*	CONFIGURATION	play game level
*/
//---------------------------------------------
enum
{
	ABGameLevel_Normal,
	ABGameLevel_Easy,
	ABGameLevel_Hard,
	ABGameLevel_SuddenDeath
};
typedef ABtype	ABgameLevelType;

//---------------------------------------------
/*
*	Judge(gĂH)
*/
//---------------------------------------------
enum
{
	AB_JudgeType_JustGreat,
	AB_JudgeType_Great,
	AB_JudgeType_Good,
	AB_JudgeType_Bad,
	AB_JudgeType_Poor,
	AB_JudgeType_Miss,
	AB_JudgeType_None	
} ;
typedef ABtype	ABjudgeType;


/*/////////////////////////////////////////////
*
*	BMS Literal
*
*	BMSt@ĆA`ɋLq܂
*//////////////////////////////////////////////
//---------------------------------------------
/*
*	BMS information
*/
//---------------------------------------------
#define	AB_BMSInfoData_STR_Player		"#PLAYER"
#define	AB_BMSInfoData_STR_Genre		"#GENRE"
#define	AB_BMSInfoData_STR_Title		"#TITLE"
#define	AB_BMSInfoData_STR_Artist		"#ARTIST"
#define	AB_BMSInfoData_STR_BPM			"#BPM"
#define	AB_BMSInfoData_STR_PlayLevel	"#PLAYLEVEL"
#define	AB_BMSInfoData_STR_Rank			"#RANK"
#define	AB_BMSInfoData_STR_VolWav		"#VOLWAV"
#define	AB_BMSInfoData_STR_Total		"#TOTAL"
#define	AB_BMSInfoData_STR_StageFile	"#STAGEFILE"
#define	AB_BMSInfoData_STR_Random		"#RANDOM"
#define	AB_BMSInfoData_STR_Scheme		"#SCHEMEFILE"
#define	AB_BMSInfoData_STR_Midi			"#MIDIFILE"

#define	AB_BMSInfoData_STR_BMP			"#BMP"
#define	AB_BMSInfoData_STR_WAV			"#WAV"

//---------------------------------------------
/*
*	̒iړ邱Ɓj
*/
//---------------------------------------------
#define	AB_BMS_CHAR_LENGTH_Title		(255)
#define	AB_BMS_CHAR_LENGTH_Genre		(255)
#define	AB_BMS_CHAR_LENGTH_Artist		(255)
#define	AB_BMS_CHAR_LENGTH_FILENAME		(63)	//	macȂ̂63
#define	AB_BMS_CHAR_LENGTH_FILEPATH		(1024)

//---------------------------------------------
/*
*	BMS music data event type
*	BMSt@C̃V[PXCxgʒ`iړ܂͍폜邱Ɓj
*/
//---------------------------------------------
#define	AB_BMS_MUSIC_DATA_EVENT_MAX			255		//	Q̃Cxgʎq̍őlB̐܂ŃCxg`oB
#define	AB_BMS_MUSIC_DATA_OBJECT_MAX		512		//	IuWFNgz̃IuWFNg̍őlB

//-------------------------
//	vC[̔ԍiړ܂͍폜邱Ɓj
//-------------------------
enum{
	AB_BMS_MUSIC_DATA_PLAYER_NUMBER_1,	//	1player
	AB_BMS_MUSIC_DATA_PLAYER_NUMBER_2,	//	2player
};
typedef	int		ABbmsMusicDataPlayerType;

//---------------------------------------------
/*
*	BMS music data event type
*	BMSt@C̃V[PXCxgʒ`
*/
//---------------------------------------------
enum {
	//	10i
	AB_BMS_MUSIC_DATA_EVENT_NOTHING			= -1L,			//	l
	
	//	MacBeats compatible
	AB_BMS_MUSIC_DATA_EVENT_BACK_CHORUS		= 1L,			//	01:dont play WAV
	AB_BMS_MUSIC_DATA_EVENT_SET_BAR_RATE	= 2L,			//	02:߂̔{i_j
	AB_BMS_MUSIC_DATA_EVENT_CHANGE_BPM		= 3L,			//	03:BPMl̓rύX
	AB_BMS_MUSIC_DATA_EVENT_SET_BGA			= 4L,			//	04:BGA
//	AB_BMS_MUSIC_DATA_EVENT_SET_EXTEND		= 5L,			//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
	AB_BMS_MUSIC_DATA_EVENT_SET_ANIMATION	= 6L,			//	06:PoorAj[V̕ύX
	AB_BMS_MUSIC_DATA_EVENT_SET_LAYER		= 7L,			//	07:BGA Layer transparency key color
	AB_BMS_MUSIC_DATA_EVENT_SET_EX_BPM		= 8L,			//	08:gBPM

	AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P		= 10L,			//	11-19:1P	IuWFNg
	AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P		= 20L,			//	21-29:2P	IuWFNg
	AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_1P	= 30L,			//	31-39:1P	sIuWFNg
	AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_2P	= 40L,			//	41-49:2P	sIuWFNg

	//	*_OBJECT_*P OBJECT TYPE	(ZĎgp)
	//	for 5 key mode
	AB_BMS_MUSIC_DATA_OBJECT_KEY1			= 1,			//	1 Key			(11,21,31,41)
	AB_BMS_MUSIC_DATA_OBJECT_KEY2			= 2,			//	2 Key
	AB_BMS_MUSIC_DATA_OBJECT_KEY3			= 3,			//	3 Key
	AB_BMS_MUSIC_DATA_OBJECT_KEY4			= 4,			//	4 Key
	AB_BMS_MUSIC_DATA_OBJECT_KEY5			= 5,			//	5 Key
	AB_BMS_MUSIC_DATA_OBJECT_SCRATCH		= 6,			//	scratch
	AB_BMS_MUSIC_DATA_OBJECT_SCRATCH_FREE	= 7,			//	free scratch

	//	for 7 Key mode
	AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY6		= 8,			//	6 key
	AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY7		= 9,			//	7 key

	//::TODO::ǉdĺAK̊gdlȂ̂L
	//ex	AB_BMS_MUSIC_DATA_AB0100_OBJECT					//	aqua beats 1.00g
	
};
typedef	ABtype						ABbmsMusicDataEventType;
typedef	ABbmsMusicDataEventType		ABbmsMusicDataTrackNumber;	//	m[gԍB킩ɂOȂ̂Œ`B

/////////////////////////////////////////////
/*
*	BMS game playng status structure
*	EQ[vCɊ֘AAeXe[^XBXRAȂǂ܂ށB
*/
/////////////////////////////////////////////
struct ABgamePlayngStatusInfo{

	ABint	BMSfolderCount;			//	BMStH_[̑
	ABint	currentBMSfolderNumber;	//	IĂBMStH_[̔ԍ

	ABint	BMSdataCount;			//	PBMS̃f[^
	ABint	currentBMSdataNumber;	//	IĂPBMS̃f[^ԍ

	//	clean
	void	clean( void ){
		BMSfolderCount = 0;
		currentBMSfolderNumber = 0;

		BMSdataCount = 0;
		currentBMSdataNumber = 0;
	}
};
typedef	struct	ABgamePlayngStatusInfo	ABgamePlayngStatusInfo;
typedef	struct	ABgamePlayngStatusInfo*	ABgamePlayngStatusInfoPtr;

/////////////////////////////////////////////
/*
*	system structure
*/
/////////////////////////////////////////////
//-------------------------------------------
//	Player Data Structure
//-------------------------------------------
struct MStGamePlayerData{
	bool		flagOption[ ABplayOption_max ];	//etO
};
typedef	struct	MStGamePlayerData	MStGamePlayerData;
typedef	struct	MStGamePlayerData	*MStGamePlayerDataPtr;

//-------------------------------------------
//	AquaaBeats Game System Data Structure
//-------------------------------------------
struct MStGameSystemData{
	ABuint32		systemVersion;					//AB̃o[W	
	GameFileInfo	schemeFileInfo;					//XL[t@C
	ABint			schemeNumber;					//XL[ԍ
	ABint			DefaultScheme;
	bool			flagOption[ AB_OPTION_max ];	//etO
};
typedef	struct	MStGameSystemData	MStGameSystemData;
typedef	struct	MStGameSystemData	*MStGameSystemDataPtr;

#endif	//AquanBeatsConfig_h