/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneMusicSelect.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameSingleton.h"
#include	"ABSceneConfig.h"
#include	"ABSceneMusicSelect.h"

#include	"ABSingleton.h"

#include	"ABMBVAItemRenderMusicSelect.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABSceneMusicSelect::ABSceneMusicSelect( ABSceneRunner&  inRunner )
 : 
	ABSceneBase::ABSceneBase( inRunner )
{ 
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABSceneMusicSelect::~ABSceneMusicSelect( void )
{
}

////////////////////////////////////////////////////////////////////////////
//
//	V[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	V[i[NɌĂяo܂
//--------------------------------------------------------------------------
ABbool	ABSceneMusicSelect::onInitialize( void )
{
	return true;
}

//--------------------------------------------------------------------------
//	V[i[IOɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneMusicSelect::onFinalize( void )
{
}

//--------------------------------------------------------------------------
//	V[JnɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneMusicSelect::onEnterScene( void )
{
}

//--------------------------------------------------------------------------
//	V[IɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneMusicSelect::onExitScene( void )
{
}

//--------------------------------------------------------------------------
//	Q[[v
//--------------------------------------------------------------------------
void	ABSceneMusicSelect::onGameLoop( void )
{
	ABint	rowMove = 0;

	//	݂̃gK[ԂQ
	GameGetJoystick().update();
	ABTriggerState&		ts = GameGetJoystick().getState();

	//	j[IԂ̕`
	ABMBVAItemRenderMusicSelect*	renderer = static_cast<ABMBVAItemRenderMusicSelect*>(this->getRunner().mVARunner.getCurrentRender());

	//	j[I
	if( ts.flagPressMoveUp ){
		//	gK[̐ݒɂāA{^A邢͍{^ňړB
		//	{^Ԃ̂ݎQƂȂ΂ȂȂB
		renderer->m_bmsList.bmsListScrollDown();
	}
	else if( ts.flagPressMoveDown ){
		//	{^Ԃ̂ݎQƂȂ΂ȂȂB
		renderer->m_bmsList.bmsListScrollUp();
	}
	else if( ts.flagPushCancel ){
		//	^Cg
		this->getRunner().moveToScene( AB_SCENE_ENTRANCE );
	}
	else if( ts.flagPushSelecrt ){
		//	Đ
		this->getRunner().moveToScene( AB_SCENE_PLAY );
	}
}

//--------------------------------------------------------------------------
//	AvP[VCxg
//--------------------------------------------------------------------------
ABbool	ABSceneMusicSelect::onAppEvent( GEeventAppType  inAppEventType )
{
	return	true;
}

////////////////////////////////////////////////////////////////////////////
//
//	VhEV[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneMusicSelect::onEnterGameLoop( void )
{
}

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneMusicSelect::onExitGameLoop( void )
{
}
