/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneSplash.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABSceneConfig.h"
#include	"ABSceneSplash.h"
#include	"ABSingleton.h"
#include	"GameSingleton.h"

#include	"BMSFolder.h"
#include	"BMSRunner.h"
#include	"BMSEventAquanBeats.h"
#include	"BMSTimerAquanBeats.h"
#include	<string>

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABSceneSplash::ABSceneSplash( ABSceneRunner&  inRunner )
 :
	ABSceneBase::ABSceneBase( inRunner )
{ 
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABSceneSplash::~ABSceneSplash( void )
{
}

////////////////////////////////////////////////////////////////////////////
//
//	V[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	V[i[NɌĂяo܂
//--------------------------------------------------------------------------
ABbool	ABSceneSplash::onInitialize( void )
{
	return true;
}

//--------------------------------------------------------------------------
//	V[i[IOɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneSplash::onFinalize( void )
{
}

//--------------------------------------------------------------------------
//	V[JnɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneSplash::onEnterScene( void )
{
//	this->mCounter = 60 * 3;
}

//--------------------------------------------------------------------------
//	V[IɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneSplash::onExitScene( void )
{
}

//--------------------------------------------------------------------------
//	Q[[v
//--------------------------------------------------------------------------
void	ABSceneSplash::onGameLoop( void )
{
/*
	//	݂̃gK[ԂQ
	GameGetJoystick().update();
	ABTriggerState&		ts = GameGetJoystick().getState();

	--this->mCounter;
	if( ts.flagPushSelecrt || this->mCounter < 0 ){
		this->getRunner().moveToScene( AB_SCENE_ENTRANCE );
	}
*/

/*	
	//	TEST
	static	bool	initFlag = false;
	static	BMSFolder			folder;
	static	BMSSong*			song;
	static	BMSRunner			bmsRunner;
	static	BMSTimerAquanBeats	timer;
	static	BMSEventAquanBeats	eventActor;
	if( ! initFlag ){
		using namespace std;
		string		bmsMusic( ABGetPreference().pathBMSmusic );
		static	ABint	number = 0;
		static	ABint8*	bms[]={
			"sweet Folder",	//::TODO::
			"cranky [EURO DANCE] X-Y-Z ''Tin",
			"dimeuro",
			"20novce",	
			"stmusic",	
			"yk_evatv",	
	//		"hma",			//<-}Ii		
			"Congratulations_MQ",	
			"yukigesiki_MQ",	
			"ruined_relics_MQ",	
			"mybb",	
			"ruinrmx",	
			"panse",
			"success",	
	//		"pastelbms01",	//::TODO::eLXgǂݍ݃G[
			"nadesico",
		};
//		bmsMusic += bms[0];

		//	Ȉjuke{bNX
		bmsMusic += bms[number];
		++number;
		if( (sizeof(bms) / sizeof(ABint8*)) <= number ){
			number = 0;
		}

		ABint8*		bmsMusicName = const_cast<ABint8*>(bmsMusic.c_str());
		ABbool		ret;
		ret = folder.openFolder( bmsMusicName );
		song = folder.openSong( 0 );
		
		ret = bmsRunner.initialize( &timer, &eventActor );
		ret = bmsRunner.playSong( song, folder.getResource() );
		initFlag = true;
	}
	
	{
		if( bmsRunner.isEnd() ){
			bmsRunner.finalize( );
			folder.closeSong();
			song = NULL;
			initFlag = false;
//			this->getRunner().moveToScene( AB_SCENE_ENTRANCE );
		}
	}
*/
}

//--------------------------------------------------------------------------
//	AvP[VCxg
//--------------------------------------------------------------------------
ABbool	ABSceneSplash::onAppEvent( GEeventAppType  inAppEventType )
{
	return	true;
}

////////////////////////////////////////////////////////////////////////////
//
//	VhEV[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneSplash::onEnterGameLoop( void )
{
}

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneSplash::onExitGameLoop( void )
{
}
