/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneStageFinish.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABSceneStageFinish.h"

#include	"GameSingleton.h"
#include	"ABSceneConfig.h"
#include	"ABVAItemBindStageFinish.h"
#include	"ABSingleton.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABSceneStageFinish::ABSceneStageFinish( ABSceneRunner&  inRunner )
 : 
	ABSceneBase::ABSceneBase( inRunner )
{ 
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABSceneStageFinish::~ABSceneStageFinish( void )
{
}

////////////////////////////////////////////////////////////////////////////
//
//	V[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	V[i[NɌĂяo܂
//--------------------------------------------------------------------------
ABbool	ABSceneStageFinish::onInitialize( void )
{
	return true;
}

//--------------------------------------------------------------------------
//	V[i[IOɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneStageFinish::onFinalize( void )
{
}

//--------------------------------------------------------------------------
//	V[JnɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneStageFinish::onEnterScene( void )
{
	ABVAItemBindStageFinish*	binder = static_cast<ABVAItemBindStageFinish*>(this->getRunner().mVARunner.getCurrentBinder());
	ABBMSRunner&				bmsRunner = ABGetBMSRunner();

	ABint	i;
	for( i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT ; i++ ){
		binder->mConsumer[ i ] = bmsRunner.mBMSRunner.getMusicPlayer()->getComsumer( (BMSSeqEventPlayerNumber)i );
	}

	//	_Ci~bNoC_[̏
	//
	//	_Ci~bNoC_[ɏ`B
	//	XRAނ͑SĕɕϊAoC_[ɓnĂB
	//	͕ύX邾ŁAIɕ\̂B
	//
	
	memset( binder->mPramam.Player1.score, 0, sizeof(binder->mPramam.Player1.score) );
	memset( binder->mPramam.Player2.score, 0, sizeof(binder->mPramam.Player2.score) );
	
	//	eXgl
	//	Ŏ݂ɕ\ł鏊ɒڂĂB󔒂́ACAEg𑵂邽߂̂̂łB
}

//--------------------------------------------------------------------------
//	V[IɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneStageFinish::onExitScene( void )
{
}

//--------------------------------------------------------------------------
//	Q[[v
//--------------------------------------------------------------------------
void	ABSceneStageFinish::onGameLoop( void )
{
	//	犮
	ABVAItemBindStageFinish*	binder = static_cast<ABVAItemBindStageFinish*>(this->getRunner().mVARunner.getCurrentBinder());
	GameGetJoystick().update();
	ABTriggerState&		joystick = GameGetJoystick().getState();
	if( joystick.pushAny ){
		if( ABVAItemBindStageFinish::M_GRAPH_DRAW_TIME < binder->mDisplayCounter ){
			binder->mDisplayCounter = ABVAItemBindStageFinish::M_GRAPH_DRAW_TIME;
		}
		else{
			binder->mDisplayCounter = 0;
		}
	}
	if( binder->mDisplayCounter <= 0 ){
//		this->getRunner().moveToScene( AB_SCENE_PLAY );
		this->getRunner().moveToScene( AB_SCENE_MUSIC_SELECT );
	}
}

//--------------------------------------------------------------------------
//	AvP[VCxg
//--------------------------------------------------------------------------
ABbool	ABSceneStageFinish::onAppEvent( GEeventAppType  inAppEventType )
{
	return	true;
}

////////////////////////////////////////////////////////////////////////////
//
//	VhEV[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneStageFinish::onEnterGameLoop( void )
{
}

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneStageFinish::onExitGameLoop( void )
{
}
