/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneStagePlay.h

				Q[V[NX

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/15	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#ifndef	ABSceneStagePlay_h
#define	ABSceneStagePlay_h

#include	"GlobalConfig.h"
#include	"ABSceneBase.h"

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSceneStagePlay : public ABSceneBase
{

private:

	//	\ɕKvȃp[^
	//	oC_[ɓn߂ɁÂ𕶎ŎĂ܂B
	enum{
		M_CSTRING_SIZE = 8,		//	XRA\pɍ킹Ă
	};
	
	typedef	struct	MParam{

		ABint8		mValueBPM[ M_CSTRING_SIZE ];					//	C STRING
		ABint8		mValueFPS[ M_CSTRING_SIZE ];					//	C STRING

		typedef	struct	Player{
			ABint8		mValueScore[ M_CSTRING_SIZE ];				//	C STRING

			ABint8		mValueCountJustGreat[ M_CSTRING_SIZE ];		//	C STRING
			ABint8		mValueCountGreat[ M_CSTRING_SIZE ];			//	C STRING
			ABint8		mValueCountGood[ M_CSTRING_SIZE ];			//	C STRING
			ABint8		mValueCountBad[ M_CSTRING_SIZE ];			//	C STRING
			ABint8		mValueCountPoor[ M_CSTRING_SIZE ];			//	C STRING
			ABint8		mValueCountCombo[ M_CSTRING_SIZE ];			//	C STRING
			ABint8		mValueCountTotal[ M_CSTRING_SIZE ];			//	C STRING

			ABint8		mValueComboCounter[ M_CSTRING_SIZE ];		//	C STRING

			ABint		mValueTension;			//	int
		}	Player;
		Player	Player1, Player2;

		ABint8		mValuePlaingTimer[ M_CSTRING_SIZE ];			//	C STRING
		ABint		mValueLocation;				//	int

	} MParam;
	MParam 		mPramam;

	ABbool			mStartBMS;
	ABbool			mStartError;
public:
	explicit	ABSceneStagePlay( ABSceneRunner&  inRunner );
	virtual ~ABSceneStagePlay();

	//--------------------------------------------------------------------------
	//	V[Cxgnh[
	//--------------------------------------------------------------------------

	//	V[i[NɌĂяo܂
	//		[mۓs܂
	virtual ABbool	onInitialize( void );

	//	V[i[IOɌĂяo܂
	//		[mۓs܂
	virtual void	onFinalize( void );

	//	V[JnɌĂяo܂
	//		f[^̏s܂
	virtual void	onEnterScene( void );

	//	V[IɌĂяo܂
	//		f[^̌ns܂
	virtual void	onExitScene( void );

	//	Q[[v
	//		1/60b̏ɌĂяo܂B`揈͂ōs܂B
	virtual void	onGameLoop( void );

	//	AvP[VCxg
	//		falseԂƁACxg̑sj~܂B
	virtual ABbool	onAppEvent( GEeventAppType  inAppEventType );

	//--------------------------------------------------------------------------
	//	VhEV[Cxgnh[
	//		VhEV[ƂĐݒ肵Ƃ̂ݎs܂
	//--------------------------------------------------------------------------

	//	Q[[vȌ
	//		V[onGameLoop()̑OŌĂяo܂B
	virtual void	onEnterGameLoop( void );

	//	Q[[vȌ
	//		V[onGameLoop()̌ŌĂяo܂B
	virtual void	onExitGameLoop( void );

};

#endif	//	ABSceneStagePlay_h
