/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemBindStageFinish.cpp

				VAClientR[hƂ̋ns܂B
				VAƃf[^Ƃ肷ɂ́AoC_[pNX
				t܂B

				oC_[́AvZbgR[hɂSetUpperɒ񋟂Ȃ΂Ȃ܂B

				oSchemeɈˑȂ悤ĂB
				{Iɂ̓f[^̒LqĂB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItemBindStageFinish_h
#define	ABVAItemBindStageFinish_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"GlobalConfig.h"
#include	"ABVAItemBindBase.h"

#include	"ABVAItemDynamicBinder.h"

#include	"BMSConfig.h"
class	BMSConsumer;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemBindStageFinish : public ABVAItemBindBase
{
public:
	enum{
		M_GRAPH_COUNT_WIDTH = 120,
		M_GRAPH_DRAW_SPEED = 2,
		M_GRAPH_DRAW_TIME = M_GRAPH_COUNT_WIDTH * M_GRAPH_DRAW_SPEED,	//	ŒEFCg`bNJEg@+@]C
		M_GRAPH_TOTAL_TIME = M_GRAPH_DRAW_TIME +  + 60 * 5,	//	ŒEFCg`bNJEg@+@]C
	};

	//	̏Ԃ́AoChlΉÂ̂łB\ύXƂ͂ւĉB
	enum{
		M_SET_TYPE_COUNTER_TOTAL,
		M_SET_TYPE_COUNTER_MAX_COMBO,
		M_SET_TYPE_COUNTER_JUST_GRAET,
		M_SET_TYPE_COUNTER_GREAT,
		M_SET_TYPE_COUNTER_GOOD,
		M_SET_TYPE_COUNTER_BAD,
		M_SET_TYPE_COUNTER_POOR,
		M_SET_TYPE_SCORE,

		M_SET_TYPE_COUNT,
	};

	//	\ɕKvȃp[^
	//	oC_[ɓn߂ɁÂ𕶎ŎĂ܂B
	enum{
		M_CSTRING_SIZE = 8,		//	XRA\pɍ킹Ă
	};

	typedef	ABVAItemDynamicBindValueCString< ABint8[8] >	MBindValueCString;

	//	\ɕKvȃp[^
	//	̃|C^[ɕ\eSet܂B
	typedef	struct	MParam{

		typedef	struct	Player{
			ABint8		score[ ABVAItemBindStageFinish::M_SET_TYPE_COUNT ][ M_CSTRING_SIZE ];	//	mValue̎̂͂ɕێ
			
			MBindValueCString		mValue[M_SET_TYPE_COUNT];						//	C STRING@|C^[
		
		}	Player;
		Player	Player1;
		Player	Player2;

	} MParam;
	MParam 		mPramam;
	
	ABint	mDisplayCounter;	//	0ɂȂ܂ŕ\B(`bNJEg)

	BMSConsumer*		mConsumer[ BMS_BMSEQ_EVENT_PLAYER_COUNT ];

	ABint	mResultGraph[ BMS_BMSEQ_EVENT_PLAYER_COUNT ][M_GRAPH_COUNT_WIDTH];

public:
	ABVAItemBindStageFinish( void ){
	};
	virtual ~ABVAItemBindStageFinish( void ){
	};
	
	//	
	virtual ABbool	initialize( void )
	{
		ABbool	ret = ABVAItemBindBase::initialize();
		if( ret ){
			this->mDisplayCounter = M_GRAPH_TOTAL_TIME;
			memset( this->mConsumer, NULL, sizeof( this->mConsumer ) );
			memset( this->mResultGraph, -1, sizeof( this->mResultGraph ) );
		}
		return ret;
	}

	//	I
	virtual void	finalize( void ){
	}
};


#endif	ABVAItemBindStageFinish_h
