/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemBindStagePlay.cpp

				VAClientR[hƂ̋ns܂B
				VAƃf[^Ƃ肷ɂ́AoC_[pNX
				t܂B

				oC_[́AvZbgR[hɂSetUpperɒ񋟂Ȃ΂Ȃ܂B

				oSchemeɈˑȂ悤ĂB
				{Iɂ̓f[^̒LqĂB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItemBindStagePlay_h
#define	ABVAItemBindStagePlay_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"GlobalConfig.h"
#include	"GGTexture.h"

#include	"ABVAItemBinder.h"
#include	"ABVAItemDynamicBinder.h"

#include	"BMSConfig.h"
#include	"BMSPlayer.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemBindStagePlay : public ABVAItemBinder
{
public:
	enum{
		M_CSTRING_SIZE256 = 256,
		M_CSTRING_SIZE = 8,
	};
	typedef	ABVAItemDynamicBindValueCString< ABint8[M_CSTRING_SIZE256] >	MBindValueCString256;
	typedef	ABVAItemDynamicBindValueCString< ABint8[M_CSTRING_SIZE] >		MBindValueCString;

	//	\ɕKvȃp[^
	//	̃|C^[ɕ\eSet܂B
	typedef	struct	MParam{
	
		MBindValueCString256	mMusicTitle;	//	C STRING@|C^[
		MBindValueCString		mValueBPM;		//	C STRING@|C^[
		MBindValueCString		mValueFPS;		//	C STRING@|C^[

		typedef	struct	Player{
			MBindValueCString		mValueScore;			//	C STRING@|C^[

			MBindValueCString		mValueCountJustGreat;	//	C STRING@|C^[
			MBindValueCString		mValueCountGreat;		//	C STRING@|C^[
			MBindValueCString		mValueCountGood;		//	C STRING@|C^[
			MBindValueCString		mValueCountBad;			//	C STRING@|C^[
			MBindValueCString		mValueCountPoor;		//	C STRING@|C^[
			MBindValueCString		mValueCountCombo;		//	C STRING@|C^[
			MBindValueCString		mValueCountTotal;		//	C STRING@|C^[

			MBindValueCString		mValueComboCounter;		//	C STRING@|C^[

			ABVAItemDynamicBindTensionGaugeValue	mValueTension;			//	int |C^[
		}	Player;
		Player	Player1;
		Player	Player2;

		MBindValueCString		mValuePlaingTimer;			//	C STRING@|C^[
		ABVABindValueInt		mValueLocation;				//	int |C^[

	} MParam;
	MParam 		mPramam;

	//-----------------------------------------
	//	BMSf[^
	//-----------------------------------------
	enum{
		M_DRAW_TRACK_COUNT	= 8,	//	1 ... 7, scratch
	};

	//	obNCg
	ABbool		mTrackBackLightPress[BMS_BMSEQ_EVENT_PLAYER_COUNT][ BMS_SEQ_TRACK_COUNT ];

	typedef	struct	MBMSDrawInfo{
	
		typedef	struct	Player{
			//	茋
//			ABseqJudgeType		mJudgeTypeNeon;
//			ABseqJudgeType		mJudgeTypeObject;
			bool				mJudgeTypeSpark[ M_DRAW_TRACK_COUNT ];	//	L[ĔItrueɂB
		};
		Player	Player1;
		Player	Player2;
		

		//	poor摜ԍ
		typedef	struct	Poor{
			ABint		poorNumber;
			GGTexture*	texture;
			ABbool		visible;
			ABint		counter;		//	poor摜LȎԐ
		};
		Poor	mPoor;
		
		//	BGA\p̏	(OpenGLpsurfaceԍ)
		//	ʕ`͕b60BBMSt͂B]āABGA\肱ڂĂ܂B
		//	XggāAmɕ\B
		ABbool			mHaveBGA;
		typedef	struct	MBGAInfo{
			GGTexture*		mTextureLayer;
		};
		typedef	std::list<MBGAInfo>	MBGAInfoList;
		MBGAInfoList	mBGAInfoList[ BMS_BMSEQ_BGA_LAYER_COUNT ];
		
		void clean( void ){
			memset( &Player1, 0, sizeof(Player1) );
			memset( &Player2, 0, sizeof(Player2) );
			memset( &mPoor, 0, sizeof(mPoor) );
			for( ABint	i = 0 ; i < BMS_BMSEQ_BGA_LAYER_COUNT; i++ ){
				mBGAInfoList[i].clear();
			}
		}
		
	} MBMSDrawInfo;
	MBMSDrawInfo 		mBMSDrawInfo;
	BMSPlayerData*		mBMSPlayerData;	//	\pf[^
	ABint				mSchemeSetMode;	//	5Key ? 7Key ? 
public:
	ABVAItemBindStagePlay( void ){
	};
	virtual ~ABVAItemBindStagePlay( void ){
	};

	//	
	virtual ABbool	initialize( void ){
		this->mBMSDrawInfo.clean();
		return true;
	}
};


#endif	ABVAItemBindStagePlay_h
