/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemObject.cpp

	Encoding:	Shift-JIS

				VisualArchitecture item instance
				
				XvCgATEhA摜RESOURCEȂǂǗNXB
				hĕKvȃACe\zB

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItemObject_h
#define	ABVAItemObject_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<vector>

#include	"GlobalConfig.h"

class	ABVAItem;
class	ABVARunner;

//-----------------------------------------------
//	f[^
//-----------------------------------------------
typedef	ABtype	ABVAItemObjData;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemObject
{
private:
	ABuint		m_instanceNumber;
	ABVAItem*	m_itemArchitecture;
	ABVARunner*	m_runner;

public:
	ABVAItemObject( void )
	 : m_itemArchitecture( NULL ),
	 m_instanceNumber( 0 ),
	 m_runner( NULL )
	{
	}
	virtual	~ABVAItemObject( void ){
		this->cleanup();
	}

	//-----------------------------------------------
	//	setup
	//	EArchitectureɁAsB
	//-----------------------------------------------
	virtual	ABbool	setup( void ){
		return	true;
	};

	//-----------------------------------------------
	//	cleanup
	//	Esetup̌nB
	//-----------------------------------------------
	virtual	void	cleanup( void ){
	}

	//-----------------------------------------------
	//	Property
	//-----------------------------------------------
	
	//	Instancẽf[^ݒ肷
	//		EhNXinTypeŎʂAvoid*Œlݒ肷邱
	virtual	ABbool	setData( const ABVAItemObjData  inType, void*  outData ){
		ABbool	ret = true;

		switch( inType ){
			default:
				ret =  false;
				break;
		}

		return	ret;
	}

	//	Instancẽf[^擾
	//		EhNXinTypeŎʂAvoid*ŒlԂ
	virtual	ABbool	getData( const ABVAItemObjData  inType, void**  outData ){
		ABbool	ret = true;

		switch( inType ){
			default:
				ret =  false;
				break;
		}

		return	ret;
	}
	
	//	ACe𐶐ݒ肷
	void	setArchitecture( ABuint  inNumber, ABVARunner*  inRunner, ABVAItem*  inItem ){
		this->m_instanceNumber = inNumber;
		this->m_itemArchitecture = inItem;
		this->m_runner		 = inRunner;
	}

	//	ACe𐶐擾
	ABVAItem*	getArchitecture( void ){
		return	this->m_itemArchitecture;
	}
	
	//	Instanceԍ擾
	ABuint	getInstanceNumber( void ){
		return	this->m_instanceNumber;
	}
	
	//	runner擾
	ABVARunner*  getRunner( void ){
		return	this->m_runner;
	}

};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	ABVAItemObjectArray
//
//////////////////////////////////////////////////////////////////////////////////////////////////
typedef	std::vector< ABVAItemObject* >					ABVAItemObjectArray;
typedef	ABVAItemObjectArray::iterator					ABVAItemObjectArrayIt;


#endif	ABVAItemObject_h
