/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBScheme.h

				SchemeǗ܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBScheme_h
#define	ABMBScheme_h

#include	<vector>

#include	"OSconfig.h"

#include	"GameFileList.h"

#include	"ABMBSchemeParser.h"
#include	"ABMBSchemeData.h"


/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABMBScheme
{
//public:
//	ABMBResourceFileIDArray	m_resourceFiles;	//	Resourcet@C

private:
	ABMBSchemeSetArray		m_schemeArray;		//	ݎgpĂsceme data
	ABMBSchemeParser		m_parser;
	
	GameFileInfo		m_schemeDirectroy;		//	XL[tH_܂łdirectory
	GameFileList		m_scemeList;			//	QƂXL[tH_file info list
	
	GameFileInfo		m_scemeFolder;			//	ݎgpĂXL[(tH_[)
	GameFileInfo		m_scemeSetFile;			//	ݎgpĂXL[(eLXgtBA)
	
	ABbool	m_trueIsOpened;
	ABint	m_scemeNumber;
	
public:
	ABMBScheme();
	~ABMBScheme();

	//	open scheme directory
	//		EwDirectoryɗLSchemetH_[SĎW܂
	ABbool	openSchemeLibrary( ABint8*  inDirectory );
	
	//	get sceme count
	//		ESchemetH_̐Ԃ܂
	ABint		getCount( void );

	//	get number from folder name
	ABint		getSchemeNumber( ABint8*  inFolderName );

	//	open sceme data
	//		EwSchemetH_J܂
	ABbool	openScheme( ABint  inNumber );
	
	//	݊JĂSchemeԍ
	ABint	getOpenSchemeNumber( void ){
		return	this->m_scemeNumber;
	}
	
	//	݊JĂXL[tH_[
	GameFileInfo&	getSchemeFolder( void ){
		return	this->m_scemeFolder;
	}
	
	//	get sceme count
	//		EJĂSchemeSetԂ܂
	ABint		getSchemeCount( void );

	//	choice sceme data
	//		EJĂSchemewSet擾܂
	ABMBSchemeSet*	getScheme( ABint  inSetNumber );
	
	//	close sceme data
	//		E܂
	void	closeScheme( void );

private:
	//	scan scheme foleder
	ABbool	scanScemeFolder( GameFileInfo*  inFolder );
	
	//	open pics data / get on off screen buffer
	ABbool	openResource( GameFileInfo*  inScemeFolder, ABMBSchemeSet*  inSet );
	//	close pics dara
	void	closeResource( void );
	
	//	make fullpath
	void	makeFullpath( ABint8*  outFullPath , ABint8*  inFolderName, ABint8*  inFileName ,ABint  inFolderNameSize);
};

#endif	//	ABMBScheme_h
