/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVASchemeAdapter.cpp

				eLXgt@CȂǁAԃf[^ǂݎA
				VAItemɃf[^NXB
				
				̃NX́ASchemeXVƂɂPxĂяo܂B
				ACeInstance쐬OɎŝŁA
				ԃf[^̕KvȏŃACeXV鎖ł܂B

				̃NXł́AMacBeatSchemet@Cǂݍłԃf[^͂A
				ACeɏ^܂B
				
				ꕔ̃ACeiwi摜Ȃǁj͂̍ƂŊ܂A
				wǂ̃ACéAInstanceAɌvZKv܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBVASchemeAdapter_h
#define	ABMBVASchemeAdapter_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"GlobalConfig.h"
#include	"ABVASchemeAdapter.h"
#include	"ABVAItemConfig.h"


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABMBVASchemeAdapter : public ABVASchemeAdapter
{
private:
	ABMBScheme&		m_scheme;

public:
	ABMBVASchemeAdapter( ABMBScheme&  inScheme );
	virtual ~ABMBVASchemeAdapter( void );

	//	read scheme set
	virtual ABbool	readScheme( ABVARunner&  inRunner, ABuint  inMode, ABMBSchemeSet*  inScemeSet );

private:
	ABbool	setItem( ABVAItem*  inItem, ABuint  inMode, ABMBSchemeSet*  inScemeSet );

	//	ABVAItemSprite
	ABbool	setItemDrawSprite( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemSprite*  inItem );
	//	ABVAItemTextSprite
	ABbool	setItemDrawText( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemTextSprite*  inItem );

	//	ABVAItemResImage
	ABbool	setItemResSurface( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemResImage*  inItem );
	//	ABVAItemResFont
	ABbool	setItemResFont( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemResFont*  inItem );

	//	ABVAItemAnimation
	ABbool	setItemAnimation( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemAnimation*  inItem );

	//	ABVAItemData
	ABbool	setItemValue( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemData*  inItem );

	//	ABVAItemArray
//	bool	setItemArray( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemArray*  inItem );

private:
	//	set basic data
	void	setBasicData( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItem*  inItem );
	//	get element data
	void	getElementData(
					ABuint		inType,
					ABMBSchemeElement*		inElement,
					ABVAItem::attribute*	inItem,
					ABint*		outx,
					ABint*		outy,
					ABint*		outw,
					ABint*		outh
				);
};


#endif	ABMBVASchemeAdapter_h
