/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderList.cpp

				VA̕`x
				Xg\

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBVAItemRenderList_h
#define	ABMBVAItemRenderList_h



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"GlobalConfig.h"
#include	"ABVAItemRender.h"
#include	"ABVAItemBinderConfig.h"

#include	"BMSConfig.h"

//	ߐsR[obN	inRow͉zsԍ
typedef		void	(*ABVAListDataFillFunc)( ABint  inRow, void*  inUserData, ABint8*  outBuffer1, ABint  inRequestBufferSize );

//	sI
//	EtrueԂƍsIBfalseԂƍsIB
typedef		bool	(*ABVAListDataRowEnterFunc)( ABint  inExitRow, ABint  inEnterRow, void*  inUserData );

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABMBVAItemRenderList
{
public:
	ABint	mRowHeight;		//	Pȕ̃^Cg̍
	ABint	mTaegetRow;		//	Isl
	ABint	mListRowCount;	//	//	Xg̉zsif[^̑j
	ABint	mRowTextSpriteObjectKey;	//	sɎgpAVVAItem::mItemIDw肷邱
	GGRecti	mArea;			//	\
	ABint	mListTargetRow;			//	IĂ鉼zsԍif[^̍sԍj

private:
	//	Ps̍ő啶
	enum{
		M_LIST_ROW_TEXT_SIZE = 255,
	};

	//	ȖXgEXN[
	enum{
		M_SCROLL_NONE,
		M_SCROLL_UP,
		M_SCROLL_DOWN,
		M_SCROLL_LEFT,
		M_SCROLL_RIGHT,
	};

	//	XgɃf[^}@\
	//	݂̃Xg̏󋵁B
	enum{
		M_REQUIRE_DATA_NOTHING,	//	Request
		M_REQUIRE_DATA_FILL,	//	߂悤߂Ă
		M_REQUIRE_DATA_UPPER,	//	㑤Ɉǉ悤߂Ă
		M_REQUIRE_DATA_LOWER,	//	Ɉǉ悤߂Ă
	};
	ABint	mRequireData;
	
	ABint	mBmsListOffset;				//	hbgPʂ̃X[YXN[pJE^
	ABint	mScrollMode;				//	XN[
	ABint	mHiSpeedScroolCounter;		//	L[ςȂAsXN[Ƃ邽߂́A^C~OJE^[
	ABint	mScrollPosition;			//	XN[pxW

	ABint	mListHeadBMSIndex;			//	\Jnzsԍif[^Requestʒusj
	ABint	mListHeadViewRow;			//	\Jnsԍif[^Requestʒusj

	ABVAListDataFillFunc		mBmsListFillFunc;	//	Xg𖄂߂邽߂̊֐|C^B߂Ȃ΂ȂȂƂɌĂяo܂
	ABVAListDataRowEnterFunc	mBmsListRowEnter;	//	sIƂɌĂяo܂
	void*					mBmsListFillFuncUserData;

//	ABint	mListRowCount;			//	Xg̉zsif[^̍sj


public:
	ABMBVAItemRenderList( void );
	virtual ~ABMBVAItemRenderList( void );

	//	
	virtual ABbool	initialize( 
		ABVARunner*  inRunner, 
		ABVAItemBinder*  inBinder,
		ABVAListDataFillFunc		inFillFunc, 
		ABVAListDataRowEnterFunc	inRowEnterFunc,
		void*  inUserData, ABint	inListRowCount 
		 );

	//	I
	virtual void	finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

	//	Render
	virtual void	render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

	//	XN[s
	void	bmsListScrollUp( void ){
		if( this->mScrollMode == M_SCROLL_NONE ){
			this->mScrollMode = M_SCROLL_UP;
		}
	}
	void	bmsListScrollDown( void ){
		if( this->mScrollMode == M_SCROLL_NONE ){
			this->mScrollMode = M_SCROLL_DOWN;
		}
	}
	void	bmsListScrollLeft( void ){
		if( this->mScrollMode == M_SCROLL_NONE ){
			this->mScrollMode = M_SCROLL_LEFT;
		}
	}
	void	bmsListScrollRight( void ){
		if( this->mScrollMode == M_SCROLL_NONE ){
			this->mScrollMode = M_SCROLL_RIGHT;
		}
	}

};


#endif	ABMBVAItemRenderList_h
