/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderMusicSelect.cpp

				VA̕`s܂B
				KvɉĔhNX쐬܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBVAItemRenderMusicSelect_h
#define	ABMBVAItemRenderMusicSelect_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"GlobalConfig.h"
#include	"ABVAItemRender.h"
#include	"ABVAItemBinderConfig.h"
#include	"ABMBVAItemRenderList.h"

#include	"BMSParserConfig.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABMBVAItemRenderMusicSelect : public ABVAItemRender
{
public:
	
	//	ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFOInstance
	enum{
		M_ICON_BMS_INFO_7_OR_5,			//	V / T
		M_ICON_BMS_INFO_PALYER_COUNT,	//	vC[
		M_ICON_BMS_INFO_BGM,			//	BGA̗L
		M_ICON_BMS_INFO_RANK,			//	N
		M_ICON_BMS_INFO_COUNT,
	};
	//	Z̕сB̊֐́AEEE
	GGVector2f	getIconBMSCellLayout( ABint  inIconType, ABint  inLevel ){
	
		GGVector2f	result;

		result.set( inLevel, 0 );
		switch( inIconType ){
			case M_ICON_BMS_INFO_7_OR_5:		//	V / T
				result.y = 0;
				break;
			case M_ICON_BMS_INFO_PALYER_COUNT:	//	vC[
				result.y = 1;
				break;
			case M_ICON_BMS_INFO_BGM:			//	BGA̗L
				result.y = 2;
				break;
			case M_ICON_BMS_INFO_RANK:			//	N

				//	EEẼZW肷邽߂ɑ݂Ăcij
				{
					GGVector2f		layout[] = { 
						{ 1,4 },	//	rank easy
						{ 0,4 },	//	rank normal
						{ 1,3 },	//	rank hard
						{ 0,3 },	//	rank Very hard
					};
					result = layout[ inLevel ];
				}
				break;
		}
		return	result;
	};
	
	//	ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO
	enum{
		M_TEXT_BMS_INFO_TITLE,		//	FInfoAreaFBMS^Cg
		M_TEXT_BMS_INFO_GENRE,		//	FInfoAreaFW
		M_TEXT_BMS_INFO_ARTIST,		//	FInfoAreaFA[eBXg
		M_TEXT_BMS_INFO_BPM,		//	FInfoAreaFBPM
		M_TEXT_BMS_INFO_BMS_FOLDER,	//	FInfoAreaFBMStH_[ԍ
		M_TEXT_BMS_INFO_BMS_NUMBER,	//	FInfoAreaFBMSf[^ԍ
		
		M_TEXT_BMS_INFO_COUNT,
	};
	
	ABMBVAItemRenderList		m_bmsList;		//	ȖXg
	BMSTPSongInformation*		mBMSHeaderInfo;	//	Ƃ̃wb_ւ̃|C^

public:
	ABMBVAItemRenderMusicSelect( void );
	~ABMBVAItemRenderMusicSelect( void );

	//	
	virtual ABbool	initialize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );
	//{
	//	return false;
	//}

	//	I
	virtual void	finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

	//	Render
	virtual void	render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

	//	ȖXgߐs֐
	static	void	listFillFunc( ABint  inRow, void*  inUserData, ABint8*  outBuffer1, ABint  inRequestBufferSize );
	//	ȖXgsI֐
	static	bool	listRowEnterFunc( ABint  inExitRow, ABint  inEnterRow, void*  inUserData );
};


#endif	ABMBVAItemRenderMusicSelect_h
