/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderStageFinish.cpp

				VA̕`s܂B
				KvɉĔhNX쐬܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBVAItemRenderStageFinish_h
#define	ABMBVAItemRenderStageFinish_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"ABVAItemRender.h"
#include	"ABVAItemBinderConfig.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABMBVAItemRenderStageFinish : public ABVAItemRender
{
private:
	GGRecti		mGraphArea[2];
	ABint		mGraphCounter;
	ABint		mScoreNumber;
	ABbool		mOnInit;

public:
	ABMBVAItemRenderStageFinish( void );
	~ABMBVAItemRenderStageFinish( void );

	//	
	virtual ABbool	initialize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

	//	I
	virtual void	finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

	//	Render
	virtual void	render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

	//	setup data
	void	setupData( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

};


#endif	ABMBVAItemRenderStageFinish_h
