/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		MacBeatSchemeConfig.h

	Encoding:	Shift-JIS

				MacBeatSchemeɊ֘Aݒ
				ȉ`̓XL[ParserQƂełAR[h̎gpւ܂B
				VXL[ł̓T|[g܂B

	Version:	
		version 1.00	2003/08/10	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	MacBeatSchemeConfig_h
#define	MacBeatSchemeConfig_h

#include	"OSconfig.h"
#include	"GameEngine.h"

/*//////////////////////////////////////////////////////////////////////////////
*
*	Scheme
*
*///////////////////////////////////////////////////////////////////////////////
//-----------------------------------
//	z肵ĂXN[TCY
//-----------------------------------
enum{
	AB_SCHEME_SCREEN_SIZE_WIDTH		=	640,
	AB_SCHEME_SCREEN_SIZE_HEIGHT	=	480
};

//-----------------------------------
//	scheam file ext
//-----------------------------------
#define	AB_SCEME_SET_EXT					".mbscm"

//-----------------------------------
//	max scheam
//-----------------------------------
#define	AB_SCHEME_SET_COUNT 				8

//-----------------------------------
//	Scheme version
//-----------------------------------
#define	AB_SCHEME_PERSER_VERSION			"0.95"	//	macbeat compatible

//	current version
#define	AB_SCHEME_PERSER_CURRENT_VERSION	AB_SCHEME_PERSER_VERSION

//-----------------------------------
//	start key
//-----------------------------------
#define	AB_SCHEME_KEY_START_MAC_BEAT		"%MacBeat_Scheme_Resource"
//-----------------------------------
//	end key
//-----------------------------------
#define	AB_SCHEME_KEY_END					"%End"
//-----------------------------------
//	version key
//-----------------------------------
#define	AB_SCHEME_KEY_VERSION				"%FormatVersion"

//-----------------------------------
//	text word
//-----------------------------------
enum
{
	AB_SCHEME_WORD_VALUE	= 0,
	
	AB_SCHEME_WORD_VALUE_NONE,
	AB_SCHEME_WORD_VALUE_AUTO,
	AB_SCHEME_WORD_VALUE_CENTER,
	AB_SCHEME_WORD_VALUE_TRUE,
	AB_SCHEME_WORD_VALUE_FALSE,
	AB_SCHEME_WORD_VALUE_YES,
	AB_SCHEME_WORD_VALUE_NO,
	
	AB_SCHEME_WORD_VALUE_HIDE,			//	W-1lɊYB-W悤"HIDE"L[[hǉׂ
	AB_SCHEME_WORD_VALUE_MAX,
};
typedef	int		ABMBSchemeWord;
#define	AB_SCHEME_WORD_NONE		"none"
#define	AB_SCHEME_WORD_AUTO		"auto"
#define	AB_SCHEME_WORD_CENTER	"center"
#define	AB_SCHEME_WORD_TRUE		"true"
#define	AB_SCHEME_WORD_FALSE	"false"
#define	AB_SCHEME_WORD_YES		"yes"
#define	AB_SCHEME_WORD_NO		"no"

//-----------------------------------
//	Scheme mode key
//-----------------------------------
enum
{
	SCMode_start = 0,
	
	SCMode_5Keys = 0,
	SCMode_5Keys_CenterPlay,
	SCMode_7Keys,
	SCMode_7Keys_CenterPlay,
	
	SCMode_end
};
typedef int	ABMBSchemeMode;

//-----------------------------------
//	set key
//-----------------------------------
enum
{
	// ӁIFenumƂ_SchemeConst.h̑Ή萔K؂
	//         C邱ƁI
	SCHSetKey_start = 0,
	
	SCHSet_Actual_5Keys = 0,
	SCHSet_Actual_5Keys_CenterPlay,
	SCHSet_Actual_7Keys,
	SCHSet_Actual_7Keys_CenterPlay,
	SCHSet_Actual_Common,
	SCHSet_BaseSchemeName,
	SCHSet_Comment,
	SCHSet_CreatedDate,
	SCHSet_CreatorName,
	SCHSet_Resolution,
	SCHSet_Resource_5Keys,
	SCHSet_Resource_5Keys_CenterPlay,
	SCHSet_Resource_7Keys,
	SCHSet_Resource_7Keys_CenterPlay,
	SCHSet_Resource_Common,
	SCHSet_ResourceFolderName,
	SCHSet_SchemeName,
	SCHSet_SchemeTheme,
	SCHSet_Source_5Keys,
	SCHSet_Source_5Keys_CenterPlay,
	SCHSet_Source_7Keys,
	SCHSet_Source_7Keys_CenterPlay,
	SCHSet_Source_Common,
	SCHSet_Version,
	SCHSet_BgColor,
	
	SCHSetKey_end
};
typedef	int	ABMBSchemeSetKey;

//static const char *SCHSetKey[] =
inline	int	ABMBSchemeRegistSetKey( char**  keys )
{
	int		i = 0;
	
	// ӁIF̒萔Ƃ_Scheme.h̑ΉenumK؂
	//         C邱ƁI
	keys[ i++ ] = "*Actual_5Keys";
	keys[ i++ ] = "*Actual_5Keys_CenterPlay";
	keys[ i++ ] = "*Actual_7Keys";
	keys[ i++ ] = "*Actual_7Keys_CenterPlay";
	keys[ i++ ] = "*Actual_Common";
	keys[ i++ ] = "*BaseSchemeName";
	keys[ i++ ] = "*Comment";
	keys[ i++ ] = "*CreatedDate";
	keys[ i++ ] = "*CreatorName";
	keys[ i++ ] = "*Resolution";
	keys[ i++ ] = "*Resource_5Keys";
	keys[ i++ ] = "*Resource_5Keys_CenterPlay";
	keys[ i++ ] = "*Resource_7Keys";
	keys[ i++ ] = "*Resource_7Keys_CenterPlay";
	keys[ i++ ] = "*Resource_Common";
	keys[ i++ ] = "*ResourceFolderName";
	keys[ i++ ] = "*SchemeName";
	keys[ i++ ] = "*SchemeTheme";
	keys[ i++ ] = "*Source_5Keys";
	keys[ i++ ] = "*Source_5Keys_CenterPlay";
	keys[ i++ ] = "*Source_7Keys";
	keys[ i++ ] = "*Source_7Keys_CenterPlay";
	keys[ i++ ] = "*Source_Common";
	keys[ i++ ] = "*Version";
	keys[ i++ ] = "*BgColor";

	return	i;
};


enum
{
	SCHKey_key_nothing = -1,	//	vOp

	// ӁIFenumƂ_SchemeConst.h̑Ή萔K؂
	//         C邱ƁI
	// ӂQIFABDrawItemData.cppC邱ƁI
	SCHKey_start = 0,
	
	SCH_Animation = SCHKey_start,
	SCH_AnimObj1,
	SCH_AnimObj2,
	SCH_AnimObj3,
	SCH_AnimObj4,
	SCH_AutoPlayIcon_1P,
	SCH_AutoPlayIcon_2P,

	SCH_Bar,
	SCH_BPM,
	SCH_BMSInfoIcon,
	SCH_BMSTitleArea,

	SCH_Clear,
	SCH_ClockObj,
	SCH_PositionDraw,

	SCH_Display,
	SCH_DanceObj1,
	SCH_DanceObj2,
	SCH_DanceObj3,
	SCH_DanceObj4,

	SCH_Failed,
	SCH_Font1,
	SCH_Font2,
	SCH_FPS,

	SCH_GameModes,
	SCH_Gap,
	SCH_Gauge,
	SCH_Gauge2,
	SCH_GraphArea,
	SCH_GraphObj,
	SCH_GreatZone,

	SCH_Image1,
	SCH_Image2,
	SCH_Image3,
	SCH_Image4,
	SCH_Image5,
	SCH_Image6,
	SCH_Image7,
	SCH_Image8,
	SCH_InfoArea,
	
	/*SCH_sLight1,
	SCH_sLight2,
	SCH_sLight3,
	SCH_sLight4,
	SCH_sLight5,
	SCH_sLight6,
	SCH_sLight7,
	SCH_sLightScr,*/

	SCH_Judge,

	SCH_WKeyHit,
	SCH_BKeyHit,
	SCH_WKeyNote,
	SCH_BKeyNote,

	SCH_Line,
	SCH_Load,
	SCH_LoadBMS,

	SCH_Neon,
	SCH_Neon_1P,
	SCH_Neon_2P,
	SCH_NoteOffset,
	SCH_Number1,
	SCH_Number2,
	SCH_Number3,
	SCH_Number4,

	SCH_Object,

	SCH_PDOffset,
	SCH_PlayData,
	SCH_PlayField,
	SCH_PlayField_1P,
	SCH_PlayField_2P,
	SCH_PlayStep,

	SCH_Result,

	SCH_Spark,
	SCH_ScrchHit,
	SCH_ScrchNote,
	SCH_Score_1P,
	SCH_Score_2P,
	SCH_StageNumbers,
	SCH_Star,
//	SCH_String1,
//	SCH_String2,
//	SCH_String3,
//	SCH_String4,

	SCH_Title,
	SCH_TitleStrings,
	SCH_TurnTable,

	SCH_sAnimObj1,
	SCH_sAnimObj2,
	SCH_sAnimObj3,
	SCH_sAnimObj4,
	SCH_sAutoPlayIcon,
	SCH_sBMSInfoIcon,
	SCH_sDanceObj1,
	SCH_sDanceObj2,
	SCH_sDanceObj3,
	SCH_sDanceObj4,
	SCH_sBar,
	SCH_sJudge,
	SCH_sGameModes,
	SCH_sGauge,
	SCH_sGauge2,
	SCH_sGraphObj,
	SCH_sWKeyHit,
	SCH_sBKeyHit,
	SCH_sWKeyNote,
	SCH_sBKeyNote,
	SCH_sNeon,
	SCH_sNumber1,
	SCH_sNumber2,
	SCH_sNumber3,
	SCH_sNumber4,
	SCH_sScrchHit,
	SCH_sScrchNote,
	SCH_sSpark,
	SCH_sStageNumbers,
//	SCH_sString1,
//	SCH_sString2,
//	SCH_sString3,
//	SCH_sString4,
	SCH_sTitleStrings,
	
	/*SCH_Light1_1P,
	SCH_Light2_1P,
	SCH_Light3_1P,
	SCH_Light4_1P,
	SCH_Light5_1P,
	SCH_Light6_1P,
	SCH_Light7_1P,
	SCH_LightScr_1P,
	
	SCH_Light1_2P,
	SCH_Light2_2P,
	SCH_Light3_2P,
	SCH_Light4_2P,
	SCH_Light5_2P,
	SCH_Light6_2P,
	SCH_Light7_2P,
	SCH_LightScr_2P,*/
	
	SCH_N_JustGreat_1P,
	SCH_N_Great_1P,
	SCH_N_Good_1P,
	SCH_N_Bad_1P,
	SCH_N_Poor_1P,
	SCH_N_MaxCom_1P,
	SCH_N_Total_1P,

	SCH_N_JustGreat_2P,
	SCH_N_Great_2P,
	SCH_N_Good_2P,
	SCH_N_Bad_2P,
	SCH_N_Poor_2P,
	SCH_N_MaxCom_2P,
	SCH_N_Total_2P,
	
	SCH_NID_BPM,
	SCH_NID_FPS,
	SCH_NID_Score,
	SCH_NID_Combo,
	SCH_NID_Param,
	SCH_NID_Result,	

	SCH_Opt_NeonAnimation,
	SCH_Opt_DrawGreatZone,
	SCH_Opt_TitleShade,
	SCH_Opt_SelectShade,
	
	SCH_Opt_FastTyping,
	SCH_Opt_Dance1UseBlitKey,
	SCH_Opt_Dance2UseBlitKey,
	SCH_Opt_Dance3UseBlitKey,
	SCH_Opt_Dance4UseBlitKey,
	SCH_Opt_BlinkSpark,
	SCH_Opt_StandInLineStar,
	SCH_Opt_BlinkAnimObj,
	SCH_Opt_AnimObj1,
	SCH_Opt_AnimObj2,
	SCH_Opt_AnimObj3,
	SCH_Opt_AnimObj4,
	SCH_Opt_DanceObj1,
	SCH_Opt_DanceObj2,
	SCH_Opt_DanceObj3,
	SCH_Opt_DanceObj4,
	
	SCHKey_end,

	//	AnimationIuWFNg̐(SCH_OPT_*̐)
	ABMBSchemeItemAnimation_start = SCH_Opt_NeonAnimation,
	ABMBSchemeItemAnimation_Count = SCH_Opt_DanceObj4 - SCH_Opt_NeonAnimation,

};
typedef	ABtype	ABMBSchemeDataKey;

//static const char *SCHKey[] =
inline	int	ABMBSchemeRegistKey( char**  keys )
{
	int		i = 0;

	// ӁIF̒萔Ƃ_Scheme.h̑ΉenumK؂
	//         C邱ƁI
	keys[ i++ ] = "#Animation";
	keys[ i++ ] = "#AnimObj1";
	keys[ i++ ] = "#AnimObj2";
	keys[ i++ ] = "#AnimObj3";
	keys[ i++ ] = "#AnimObj4";
	keys[ i++ ] = "#AutoPlayIcon_1P";
	keys[ i++ ] = "#AutoPlayIcon_2P";

	keys[ i++ ] = "#Bar";
	keys[ i++ ] = "#BPM";
	keys[ i++ ] = "#BMSInfoIcon";
	keys[ i++ ] = "#BMSTitleArea";

	keys[ i++ ] = "#Clear";
	keys[ i++ ] = "#ClockObj";
	keys[ i++ ] = "#PositionDraw";

	keys[ i++ ] = "#Display";
	keys[ i++ ] = "#DanceObj1";
	keys[ i++ ] = "#DanceObj2";
	keys[ i++ ] = "#DanceObj3";
	keys[ i++ ] = "#DanceObj4";

	keys[ i++ ] = "#Failed";
	keys[ i++ ] = "#Font1";
	keys[ i++ ] = "#Font2";
	keys[ i++ ] = "#FPS";

	keys[ i++ ] = "#GameModes";
	keys[ i++ ] = "#Gap";
	keys[ i++ ] = "#Gauge";
	keys[ i++ ] = "#Gauge2";
	keys[ i++ ] = "#GraphArea";
	keys[ i++ ] = "#GraphObj";
	keys[ i++ ] = "#GreatZone";

	keys[ i++ ] = "#Image1";
	keys[ i++ ] = "#Image2";
	keys[ i++ ] = "#Image3";
	keys[ i++ ] = "#Image4";
	keys[ i++ ] = "#Image5";
	keys[ i++ ] = "#Image6";
	keys[ i++ ] = "#Image7";
	keys[ i++ ] = "#Image8";
	keys[ i++ ] = "#InfoArea";

/*	keys[ i++ ] =  "#sLight1";
	keys[ i++ ] = "#sLight2";
	keys[ i++ ] = "#sLight3";
	keys[ i++ ] = "#sLight4";
	keys[ i++ ] = "#sLight5";
	keys[ i++ ] = "#sLight6";
	keys[ i++ ] = "#sLight7";
	keys[ i++ ] = "#sLightScr";
*/

	keys[ i++ ] = "#Judge";

	keys[ i++ ] = "#WKeyHit";
	keys[ i++ ] = "#BKeyHit";
	keys[ i++ ] = "#WKeyNote";
	keys[ i++ ] = "#BKeyNote";

	keys[ i++ ] = "#Line";
	keys[ i++ ] = "#Load";
	keys[ i++ ] = "#LoadBMS";

	keys[ i++ ] = "#Neon";
	keys[ i++ ] = "#Neon_1P";
	keys[ i++ ] = "#Neon_2P";
	keys[ i++ ] = "#NoteOffset";
	keys[ i++ ] = "#Number1";
	keys[ i++ ] = "#Number2";
	keys[ i++ ] = "#Number3";
	keys[ i++ ] = "#Number4";

	keys[ i++ ] = "#Object";

	keys[ i++ ] = "#PDOffset";
	keys[ i++ ] = "#PlayData";
	keys[ i++ ] = "#PlayField";
	keys[ i++ ] = "#PlayField_1P";
	keys[ i++ ] = "#PlayField_2P";
	keys[ i++ ] = "#PlayStep";

	keys[ i++ ] = "#Result";

	keys[ i++ ] = "#Spark";
	keys[ i++ ] = "#ScrchHit";
	keys[ i++ ] = "#ScrchNote";
	keys[ i++ ] = "#Score_1P";
	keys[ i++ ] = "#Score_2P";
	keys[ i++ ] = "#StageNumbers";
	keys[ i++ ] = "#Star";
	//keys[ i++ ] = "#String1";
	//keys[ i++ ] = "#String2";
	//keys[ i++ ] = "#String3";
	//keys[ i++ ] = "#String4";

	keys[ i++ ] = "#Title";
	keys[ i++ ] = "#TitleStrings";
	keys[ i++ ] = "#TurnTable";

	keys[ i++ ] = "#sAnimObj1";
	keys[ i++ ] = "#sAnimObj2";
	keys[ i++ ] = "#sAnimObj3";
	keys[ i++ ] = "#sAnimObj4";
	keys[ i++ ] = "#sAutoPlayIcon";
	keys[ i++ ] = "#sBMSInfoIcon";
	keys[ i++ ] = "#sDanceObj1";
	keys[ i++ ] = "#sDanceObj2";
	keys[ i++ ] = "#sDanceObj3";
	keys[ i++ ] = "#sDanceObj4";
	keys[ i++ ] = "#sBar";
	keys[ i++ ] = "#sJudge";
	keys[ i++ ] = "#sGameModes";
	keys[ i++ ] = "#sGauge";
	keys[ i++ ] = "#sGauge2";
	keys[ i++ ] = "#sGraphObj";
	keys[ i++ ] = "#sWKeyHit";
	keys[ i++ ] = "#sBKeyHit";
	keys[ i++ ] = "#sWKeyNote";
	keys[ i++ ] = "#sBKeyNote";
	keys[ i++ ] = "#sNeon";
	keys[ i++ ] = "#sNumber1";
	keys[ i++ ] = "#sNumber2";
	keys[ i++ ] = "#sNumber3";
	keys[ i++ ] = "#sNumber4";
	keys[ i++ ] = "#sScrchHit";
	keys[ i++ ] = "#sScrchNote";
	keys[ i++ ] = "#sSpark";
	keys[ i++ ] = "#sStageNumbers";
	//keys[ i++ ] = "#sString1";
	//keys[ i++ ] = "#sString2";
	//keys[ i++ ] = "#sString3";
	//keys[ i++ ] = "#sString4";
	keys[ i++ ] = "#sTitleStrings";
/*
	keys[ i++ ] = "#Light1_1P";
	keys[ i++ ] = "#Light2_1P";
	keys[ i++ ] = "#Light3_1P";
	keys[ i++ ] = "#Light4_1P";
	keys[ i++ ] = "#Light5_1P";
	keys[ i++ ] = "#Light6_1P";
	keys[ i++ ] = "#Light7_1P";
	keys[ i++ ] = "#LightScr_1P";

	keys[ i++ ] = "#Light1_2P";
	keys[ i++ ] = "#Light2_2P";
	keys[ i++ ] = "#Light3_2P";
	keys[ i++ ] = "#Light4_2P";
	keys[ i++ ] = "#Light5_2P";
	keys[ i++ ] = "#Light6_2P";
	keys[ i++ ] = "#Light7_2P";
	keys[ i++ ] = "#LightScr_2P";
*/

	keys[ i++ ] = "#N_JustGreat_1P";
	keys[ i++ ] = "#N_Great_1P";
	keys[ i++ ] = "#N_Good_1P";
	keys[ i++ ] = "#N_Bad_1P";
	keys[ i++ ] = "#N_Poor_1P";
	keys[ i++ ] = "#N_MaxCom_1P";
	keys[ i++ ] = "#N_Total_1P";

	keys[ i++ ] = "#N_JustGreat_2P";
	keys[ i++ ] = "#N_Great_2P";
	keys[ i++ ] = "#N_Good_2P";
	keys[ i++ ] = "#N_Bad_2P";
	keys[ i++ ] = "#N_Poor_2P";
	keys[ i++ ] = "#N_MaxCom_2P";
	keys[ i++ ] = "#N_Total_2P";

	keys[ i++ ] = "#NID_BPM";
	keys[ i++ ] = "#NID_FPS";
	keys[ i++ ] = "#NID_Score";
	keys[ i++ ] = "#NID_Combo";
	keys[ i++ ] = "#NID_Param";
	keys[ i++ ] = "#NID_Result";

	keys[ i++ ] = "#Opt_NeonAnimation";
	keys[ i++ ] = "#Opt_DrawGreatZone";
	keys[ i++ ] = "#Opt_TitleShade";
	keys[ i++ ] = "#Opt_SelectShade";
	keys[ i++ ] = "#Opt_FastTyping";
	keys[ i++ ] = "#Opt_Dance1UseBlitKey";
	keys[ i++ ] = "#Opt_Dance2UseBlitKey";
	keys[ i++ ] = "#Opt_Dance3UseBlitKey";
	keys[ i++ ] = "#Opt_Dance4UseBlitKey";
	keys[ i++ ] = "#Opt_BlinkSpark";
	keys[ i++ ] = "#Opt_StandInLineStar";
	keys[ i++ ] = "#Opt_BlinkAnimObj";
	keys[ i++ ] = "#Opt_AnimObj1";
	keys[ i++ ] = "#Opt_AnimObj2";
	keys[ i++ ] = "#Opt_AnimObj3";
	keys[ i++ ] = "#Opt_AnimObj4";
	keys[ i++ ] = "#Opt_DanceObj1";
	keys[ i++ ] = "#Opt_DanceObj2";
	keys[ i++ ] = "#Opt_DanceObj3";
	keys[ i++ ] = "#Opt_DanceObj4";
		
	keys[ i++ ] = "Dummy_end";
	
	return	i;
};


enum
{
	// ӁIFenumƂ_SchemeConst.h̑Ή萔K؂
	//         C邱ƁI
	ResPict_nothing = -1,
	ResPict_start = 0,
	
	//ResPict_Opening = 0,
	ResPict_Title = 0,
	ResPict_Results,
	ResPict_NowLoading,
	ResPict_StageClear,
	ResPict_StageFailed,
	ResPict_TurnTable,
	ResPict_Star,
	ResPict_GraphObj,
	ResPict_NoAnimation,
	ResPict_PoorAnimation,	//
	ResPict_NoiseAnimation1,	//
	ResPict_NoiseAnimation2,	//
	ResPict_GaugeObj,
	ResPict_Neons,
	ResPict_PlayField,
	ResPict_Objects,
	ResPict_Judges,
	//ResPict_Lights,
	ResPict_Sparks,
	ResPict_HitLight,
	ResPict_BarObj,
//	ResPict_Strings,
	ResPict_Numbers,
	ResPict_TitleStrings,
	ResPict_InfoArea,
	ResPict_GameModes,
	ResPict_StageNumbers,
	ResPict_AnimObj1,
	ResPict_AnimObj2,
	ResPict_AnimObj3,
	ResPict_AnimObj4,
	ResPict_DanceObj1,
	ResPict_DanceObj2,
	ResPict_DanceObj3,
	ResPict_DanceObj4,
	ResPict_Image1,
	ResPict_Image2,
	ResPict_Image3,
	ResPict_Image4,
	ResPict_Image5,
	ResPict_Image6,
	ResPict_Image7,
	ResPict_Image8,
	ResPict_BMSInfoIcon,
	ResPict_AutoPlayIcon,
	
	ResPict_end
};
//	} ResPictKey;	< !! GCCACW8RpCł̓CNg(i++Ƃ)ɎgȂׁA܂
typedef int		ResPictKey;

//static const char *ResPict[] =
inline	int	ABMBSchemeRegistResPict( char**  keys )
{
	int		i = 0;

	// ӁIF̒萔Ƃ_Scheme.h̑ΉenumK؂
	//         C邱ƁI
	//"Opening",
	keys[ i++ ] = "#Title";
	keys[ i++ ] = "#Results";
	keys[ i++ ] = "#NowLoading";
	keys[ i++ ] = "#StageClear";
	keys[ i++ ] = "#StageFailed";
	keys[ i++ ] = "#TurnTable";
	keys[ i++ ] = "#Star";
	keys[ i++ ] = "#GraphObj";
	keys[ i++ ] = "#NoAnimation";
	keys[ i++ ] = "#PoorAnimation";
	keys[ i++ ] = "#NoiseAnimation1";
	keys[ i++ ] = "#NoiseAnimation2";
	keys[ i++ ] = "#GaugeObj";
	keys[ i++ ] = "#Neons";
	keys[ i++ ] = "#PlayField";
	keys[ i++ ] = "#Objects";
	keys[ i++ ] = "#Judges";
//	keys[ i++ ] = "#Lights";
	keys[ i++ ] = "#Sparks";
	keys[ i++ ] = "#HitLight";
	keys[ i++ ] = "#BarObj";
//	keys[ i++ ] = "#Strings";
	keys[ i++ ] = "#Numbers";
	keys[ i++ ] = "#TitleStrings";
	keys[ i++ ] = "#InfoArea";
	keys[ i++ ] = "#GameModes";
	keys[ i++ ] = "#StageNumbers";
	keys[ i++ ] = "#AnimObj1";
	keys[ i++ ] = "#AnimObj2";
	keys[ i++ ] = "#AnimObj3";
	keys[ i++ ] = "#AnimObj4";
	keys[ i++ ] = "#DanceObj1";
	keys[ i++ ] = "#DanceObj2";
	keys[ i++ ] = "#DanceObj3";
	keys[ i++ ] = "#DanceObj4";
	keys[ i++ ] = "#Image1";
	keys[ i++ ] = "#Image2";
	keys[ i++ ] = "#Image3";
	keys[ i++ ] = "#Image4";
	keys[ i++ ] = "#Image5";
	keys[ i++ ] = "#Image6";
	keys[ i++ ] = "#Image7";
	keys[ i++ ] = "#Image8";
	keys[ i++ ] = "#BMSInfoIcon";
	keys[ i++ ] = "#AutoPlayIcon";
	
	return	i;
};

//	ʉ	F
enum{
	ResSE_NOTHING	= -1,
};
typedef int		ResSEKey;

#endif	//MacBeatSchemeConfig_h