/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSequencer.h

				AquaBeatsV[PT[

				BMS CLASS LIBRARYɂ
					EBMSȂׂƗĂAێ琫߂̂_B


				ď̐B
				EBMSvC[			FAvP[V}BAquanBeatsBMSvC[ƌĂԎłB
				EBMSV[PT[		FBMS̍ĐsR|[lgB
				EBMSRV[}[		FBMSV[PT[vC邽߂̃R|[lgA
										@vC[ɑBlAt肷B
				EBMS~[WbNf[^	FeLXgǂݍ񂾃f[^B
				EBMSp[U[			FeLXgf[^ǂݍރR|[lgB

			EV[PT[̗_
				EBMS̍ĐEWCXeBbŃEE`EĐɕA₷邱Ƃ_B
				@BMSȊOSɐ؂藣ABMSĐ邾̋@\ɍi荞ށB
				@C[v́AV[PT[f[^ĐāAA`ɕKvȏQƂ悤ɂB
				@e픻AXRAvZAV[PT[ɂčsB
				@`AĐA͂ɂĂł͈؍lȂčςނAƂĂyɂȂ͂B
				ENXpɂAzIȃCxgB
				@KvɉāAV[PT[pNXo[ĂяoB
				@Q[[v͎ăVvɂȂA̋@\mɂȂB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSequencer_h
#define	ABSequencer_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"AquanBeatsConfig.h"

#include	"ABSeqData.h"
#include	"ABSeqLoop.h"
#include	"ABSeqTimeControllerBase.h"

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSequencer
{
public:
	ABSequencer();
	virtual	~ABSequencer();

	//-------------------------
	//	Method
	//-------------------------
	//	Initialize / Finalize
	bool	initialize
	( 
		int  inVibrantRange, 
		ABSeqTimeControllerBase*	inTimeController,
		ABSeqEventActionBase*		inEventAction,
		ABbmsMusicData*				inBMSdata
	);

	void	finalize( void );

	//-------------------------
	//	Play
	//-------------------------
	//	paly start
	void	play( void );
	//	paly pause
	void	pause( void );
	//	paly continue
	void	cont( void );
	//	paly stop
	void	stop( void );
	
	//-------------------------
	//	getter
	//-------------------------
	//	get bpm
	int		getBPM( void ){
		return	this->m_sequencerLoop.getBPM();
	}
	//	get data
	ABSeqData*	getSequencerData( void ){
		return	this->m_sequencerLoop.getSequencerData();
	}

private:

	enum{
		M_SEQMODE_STOP,
		M_SEQMODE_PLAY,
		M_SEQMODE_PAUSE,
	};
	typedef	ABtype		MseqModeType;

private:
	ABSeqLoop					m_sequencerLoop;
	MseqModeType				m_seqMode;
	ABSeqTimeControllerBase*	m_timeController;
};

#endif	//	ABSequencer_h
