/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSTimerAquanBeats.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSTimerAquanBeats_h
#define	BMSTimerAquanBeats_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"GameTimer.h"
#include	"BMSTimer.h"

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSTimerAquanBeats : public	BMSTimer, GameTimer
{
public:
	BMSTimerAquanBeats();
	virtual	~BMSTimerAquanBeats();

	//	setup
	virtual	ABbool	setup( void );
	//	cleanup
	virtual	void	cleanup( void );
	//	^C}[[vŌĂяo܂B
	virtual	void	onEventLoop( void );
	//	E^C}[ZbgB
	virtual	void	startTimer( ABfloat32  inBPM );
	//	E^C}[Đݒ肷B
	virtual	void	resetTimer( ABfloat32  inBPM );
	//	E^C}[~B
	virtual	void	stopTimer( void );
	
	double	m_startTime;
	double	m_rezo_millisec;
	double	m_pre_millisec;
	double	m_currentLocation;
	double	m_baseLocation;
	double	m_baseMillisec;
};

#endif	//	BMSTimerAquanBeats_h
