/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSConfig.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSConfig_h
#define	BMSConfig_h

#include	"GlobalConfig.h"

//------------------------------------------------------------------------------
//	l
//------------------------------------------------------------------------------
enum {
	BMS_BMSEQ_NOTHING	= -1,		
};

//------------------------------------------------------------------------------
//	\B
//------------------------------------------------------------------------------
enum{
	BMS_SEQ_EVENT_RESOLUTION	= 192,							//	Pߓ̕\B
	BMS_SEQ_EVENT_RESOLUTION4	= BMS_SEQ_EVENT_RESOLUTION / 4,	//	S̕\B
};


//	BPMlAP\Pʓ̕b擾
#define	BMS_GET_VALUE_BPM_TO_SECOND( BPM )			( 60.0f / ( (double)BPM * (double)BMS_SEQ_EVENT_RESOLUTION4) )

//	bA\Pʒl擾
#define	BMS_GET_VALUE_SECOND_TO_BPM( BPM, SECOND )	( SECOND / BMS_GET_VALUE_BPM_TO_SECOND(BPM) )

//---------------------------------------------
//
//	Event type
//
//	SequencerʂlBeLXgt@Ĉ̂Ƃ͋ʂ܂B
//
//---------------------------------------------
enum {
	BMS_BMSEQ_EVENT_NOTHING	= BMS_BMSEQ_NOTHING,		//	l

	//////////////////////////////////////	
	//	MacBeats compatible
	//////////////////////////////////////	
	BMS_BMSEQ_EVENT_BACK_CHORUS,		//	01:dont play WAV
	BMS_BMSEQ_EVENT_SET_BAR_RATE,		//	02:߂̔{i_j
	BMS_BMSEQ_EVENT_CHANGE_BPM,			//	03:BPMl̓rύX
	BMS_BMSEQ_EVENT_SET_BGA,			//	04:BGA
//	BMS_BMSEQ_EVENT_SET_EXTEND,			//	05:Extended Object(For BM98 YANEURAO ver.)	:	BMS not suported.
	BMS_BMSEQ_EVENT_SET_ANIMATION,		//	06:PoorAj[V̕ύX
	BMS_BMSEQ_EVENT_SET_LAYER,			//	07:BGA Layer transparency key color
	BMS_BMSEQ_EVENT_SET_EX_BPM,			//	08:gBPM

	BMS_BMSEQ_EVENT_OBJECT,				//	11-19:1P, 21-29:2P	IuWFNg
	BMS_BMSEQ_EVENT_HIDE_OBJECT,		//	31-39:1P, 41-49:2P	sIuWFNg

	//////////////////////////////////////
	//::TODO::ǉdĺAK̊gdlȂ̂L
	//ex	BMS_BMSEQ_EVENT_OBJECT					//	aqua beats 1.00g
	//////////////////////////////////////	
	
	//////////////////////////////////////	
	//	DDR
	//////////////////////////////////////	

	BMS_BMSEQ_EVENT_COUNT,
};
typedef	int		BMSSeqEventType;

//	for DEBUG
inline	ABint8*		BMSSeqGetEventTypeName( BMSSeqEventType  inType ){
	switch( inType ){
		case BMS_BMSEQ_EVENT_NOTHING:		//	l
			return	"BMS_BMSEQ_EVENT_NOTHING";
		case BMS_BMSEQ_EVENT_BACK_CHORUS:		//	01:dont play WAV
			return	"BMS_BMSEQ_EVENT_BACK_CHORUS";
		case BMS_BMSEQ_EVENT_SET_BAR_RATE:		//	02:߂̔{i_j
			return	"BMS_BMSEQ_EVENT_SET_BAR_RATE";
		case BMS_BMSEQ_EVENT_CHANGE_BPM:			//	03:BPMl̓rύX
			return	"BMS_BMSEQ_EVENT_CHANGE_BPM";
		case BMS_BMSEQ_EVENT_SET_BGA:			//	04:BGA
			return	"BMS_BMSEQ_EVENT_SET_BGA";
	//	case BMS_BMSEQEVENT_SET_EXTEND:			//	05:Extended Object(For BM98 YANEURAO ver.)	:	BMS not suported.
	//		return	"BMS_BMSEQEVENT_SET_EXTEND";
		case BMS_BMSEQ_EVENT_SET_ANIMATION:		//	06:PoorAj[V̕ύX
			return	"BMS_BMSEQ_EVENT_SET_ANIMATION";
		case BMS_BMSEQ_EVENT_SET_LAYER:			//	07:BGA Layer transparency key color
			return	"BMS_BMSEQ_EVENT_SET_LAYER";
		case BMS_BMSEQ_EVENT_SET_EX_BPM:			//	08:gBPM
			return	"BMS_BMSEQ_EVENT_SET_EX_BPM";

		case BMS_BMSEQ_EVENT_OBJECT:				//	11-19:1P, 21-29:2P	IuWFNg
			return	"BMS_BMSEQ_EVENT_OBJECT";
		case BMS_BMSEQ_EVENT_HIDE_OBJECT:		//	31-39:1P, 41-49:2P	sIuWFNg
			return	"BMS_BMSEQ_EVENT_HIDE_OBJECT";
		default:
			return	"UNKOEN EVENT";
	}
};

//------------------------------------------------------------------------------
//	BMS music data event type (sequencerp)
//
//	̃Cxgĺ@BMSbmsMusicDataEventType@Sequencerł̂ݎgpAgCxgłB
//	Sequencer̃vO~O邽߂̂̂Ȃ̂ŁAABMSf[^Ɋ܂߂Ă͂܂B
//
//------------------------------------------------------------------------------
enum{
	BMS_BMSEQ_EVENT_SOUND_CHANGE		= (int)0x10000001,		//	TEh`FWCxg(L[ɉ蓖Ă^C~Ow肷Cxg)
};

//------------------------------------------------------------------------------
//	BGA Layer
//------------------------------------------------------------------------------
enum{
	BMS_BMSEQ_BGA_LAYER_0,
	BMS_BMSEQ_BGA_LAYER_1,

	BMS_BMSEQ_BGA_LAYER_COUNT,
};
typedef	ABtype		BMSSeqEventBGALayerType;

//------------------------------------------------------------------------------
//	TRACK
//
//	eL[ɑΉ悤ɃgbNʂ܂B
//------------------------------------------------------------------------------
typedef enum BMSSeqEventTrackType{

	//	ObjectzȂEvent
	//	BackCHORUSABGAȂǂ̃Cxg͂̃gbNɑΉB
	BMS_SEQ_TRACK_EVENT,						

	//	[U[삷gbN
	BMS_SEQ_TRACK_KEY1,
	BMS_SEQ_TRACK_KEY2,
	BMS_SEQ_TRACK_KEY3,
	BMS_SEQ_TRACK_KEY4,
	BMS_SEQ_TRACK_KEY5,
	BMS_SEQ_TRACK_KEY6,
	BMS_SEQ_TRACK_KEY7,
	BMS_SEQ_TRACK_KEY_SCRATCH,
	BMS_SEQ_TRACK_KEY_SCRATCH_FREE,
	
	BMS_SEQ_TRACK_COUNT,
} BMSSeqEventTrackType;

//	for DEBUG
inline	ABint8*		BMSSeqGetTrackTypeName( BMSSeqEventTrackType  inType ){
	switch( inType ){
		case BMS_SEQ_TRACK_EVENT:						
			return	"BMS_SEQ_TRACK_EVENT";
		case BMS_SEQ_TRACK_KEY1:
			return	"BMS_SEQ_TRACK_KEY1";
		case BMS_SEQ_TRACK_KEY2:
			return	"BMS_SEQ_TRACK_KEY2";
		case BMS_SEQ_TRACK_KEY3:
			return	"BMS_SEQ_TRACK_KEY3";
		case BMS_SEQ_TRACK_KEY4:
			return	"BMS_SEQ_TRACK_KEY4";
		case BMS_SEQ_TRACK_KEY5:
			return	"BMS_SEQ_TRACK_KEY5";
		case BMS_SEQ_TRACK_KEY6:
			return	"BMS_SEQ_TRACK_KEY6";
		case BMS_SEQ_TRACK_KEY7:
			return	"BMS_SEQ_TRACK_KEY7";
		case BMS_SEQ_TRACK_KEY_SCRATCH:
			return	"BMS_SEQ_TRACK_KEY_SCRATCH";
		case BMS_SEQ_TRACK_KEY_SCRATCH_FREE:
			return	"BMS_SEQ_TRACK_KEY_SCRATCH_FREE";
		default:
			return	"UNKOWN TRACK";
	}
}

//------------------------------------------------------------------------------
//	Player number
//------------------------------------------------------------------------------
typedef enum BMSSeqEventPlayerNumber{

	BMS_BMSEQ_EVENT_PLAYER1,
	BMS_BMSEQ_EVENT_PLAYER2,

	BMS_BMSEQ_EVENT_PLAYER_COUNT,
} BMSSeqEventPlayerNumber;

//	for DEBUG
inline	ABint8*		BMSSeqGetPlayerNumberName( BMSSeqEventPlayerNumber  inType ){
	switch( inType ){
		case BMS_BMSEQ_EVENT_PLAYER1:
			return	"BMS_BMSEQ_EVENT_PLAYER1";
		case BMS_BMSEQ_EVENT_PLAYER2:
			return	"BMS_BMSEQ_EVENT_PLAYER2";
		default:
			return	"UNKOWN TRACK";
	}
}

//------------------------------------------------------------------------------
//	背x
//------------------------------------------------------------------------------
enum{
	BMS_SEQ_JUDGE_JUST_GREATE = 0,
	BMS_SEQ_JUDGE_GREATE,
	BMS_SEQ_JUDGE_GOOD,
	BMS_SEQ_JUDGE_BAD,
	BMS_SEQ_JUDGE_POOR,
	BMS_SEQ_JUDGE_MISS,

	BMS_SEQ_JUDGE_COUNT,
};
typedef	int		BMSSeqJudgeType;

//------------------------------------------------------------------------------
//	Q[x
//------------------------------------------------------------------------------
enum{
	BMS_SEQ_GAME_LEVEL_EASY			= 0,
	BMS_SEQ_GAME_LEVEL_NOMAL,
	BMS_SEQ_GAME_LEVEL_HARD,
	BMS_SEQ_GAME_LEVEL_VERY_HARD,
	
	BMS_SEQ_GAME_LEVEL_COUNT,
};
typedef	int		BMSSeqGameLevelType;

//------------------------------------------------------------------------------
//	EXPERT[hH
//------------------------------------------------------------------------------
enum{
	BMS_SEQ_EXPART_MODE_OFF,
	BMS_SEQ_EXPART_MODE_ON,

	BMS_SEQ_EXPART_MODE_COUNT,
};
typedef	int		BMSSeqExpartMode;

//------------------------------------------------------------------------------
//	I[gvC[h
//------------------------------------------------------------------------------
enum{
	BMS_SEQ_AUTO_PLAY_TYPE_NONE,
	BMS_SEQ_AUTO_PLAY_TYPE_ALL,
	BMS_SEQ_AUTO_PLAY_TYPE_KEY_TRACKS,
	BMS_SEQ_AUTO_PLAY_TYPE_SCRATCH_TRACKS,
	
	BMS_SEQ_AUTO_PLAY_TYPE_COUNT,
};
typedef	int	BMSSeqPlayType;

//------------------------------------------------------------------------------
//	XRA
//------------------------------------------------------------------------------
enum{
	//	1ȓ̓T
	BMS_SEQ_SCORE_1SONG_VALUE	= 200000L,
};

//------------------------------------------------------------------------------
//	TensionGaugeAResultGraph̏
//------------------------------------------------------------------------------
enum{
	BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_MAX = 60,
	BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_GAIN = 48,	//	ipoint
};

//------------------------------------------------------------------------------
//	BMS Player Config
//	tu̐ݒ
//------------------------------------------------------------------------------
typedef	struct BMSPlayerConfig{

	BMSSeqGameLevelType		gameLevel;
	BMSSeqExpartMode		expartMode;
	BMSSeqPlayType			autoPlayMode[BMS_BMSEQ_EVENT_PLAYER_COUNT];
	
	BMSPlayerConfig(){
		clean();
	}
	void	clean(){
		gameLevel		= BMS_SEQ_GAME_LEVEL_NOMAL;
		expartMode		= BMS_SEQ_EXPART_MODE_OFF;
		memset(	&autoPlayMode, BMS_SEQ_AUTO_PLAY_TYPE_NONE, sizeof( autoPlayMode )) ;
	}

} BMSPlayerConfig;

#endif	//	BMSConfig_h
