/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSConsumer.h

				BMSV[PT[ŃQ[vCliConsumerj̏


	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSConsumer_h
#define	BMSConsumer_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"BMSConfig.h"

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSConsumer
{
private:
	typedef	std::vector<int>	MintArray;
public:
	BMSConsumer()
	: m_init(false) {
	}
	virtual	~BMSConsumer(){
	}
	
	//-------------------------------------
	//	
	//-------------------------------------
	//	inTaoatalNoteCountBMSHeadeŕABMSf[^̃wb_ɏĂ#TotallA
	//	inTaoatalNoteCount́Af[^͂Ă̖{̉NOTE
	void	initialize( int  inTaoatalNoteCountBMSHeader, int  inTaoatalNoteCount, bool  inTrueIsDoublePlay ){

		printf( "inTaoatalNoteCountBMSHeader[%d], inTaoatalNoteCount[%d] \n", inTaoatalNoteCountBMSHeader, inTaoatalNoteCount );
	
		//	G~[V[hɂČv@ύX̂ŁANX\lKvB
	
		this->m_bmsHeaderTotalcount	= inTaoatalNoteCountBMSHeader;	//	BMSf[^HeaderɏĂ#TOTALl
		this->m_totalNoteCount		= inTaoatalNoteCount;			//	BMSf[^̃f[^̎ۂ̉NOTEl

		if( this->m_bmsHeaderTotalcount == 0 ){
			this->m_bmsHeaderTotalcount = ( 200 + inTaoatalNoteCount ) / 2.0 ; // 200ĂȂɁH
		}

		this->initJudgeBarometer();

		this->m_playerState.trueIsExist		= false;
		this->m_playerState.trueIsAutoPlay	= false;
		this->m_playerState.trueIsAutoScrach= false;
		//this->m_playerState.freezone;

		//this->m_resultGraph;
		this->m_score.totalJudgeNoteCount = 0 ;
		this->m_score.judgeNoteCount.clear();
		this->m_score.judgeNoteCount.resize( BMS_SEQ_JUDGE_COUNT, 0 );
													//poor,Bad,Good,Great,JustGreat
		this->m_score.noteValue				= BMS_SEQ_SCORE_1SONG_VALUE / (float)inTaoatalNoteCount;	
		this->m_score.totalScore			= 0;	//XRA
		this->m_score.grateComboCount		= 0;	//AO[g

		this->m_score.barometerJudge	= 6;		//Judgeɉđo[^[
		this->m_score.gudgeGreatGain	= 0;		//Great擾barometerJudge𑝉邽߂̒l

		this->m_score.comboCount		= 0;		//R{
//		this->m_score.comboCountMax		= 0;		//R{ől
		
		this->m_tensionGraph.index = 0;
		this->m_tensionGraph.array.clear();
		this->m_tensionGraph.array.resize( inTaoatalNoteCount, 0 );
		
		this->initJudgeBarometer();
		
		this->m_init =true;
		this->m_trueIsFinish = true;
	}

private:
	//	judgeBarometervZ
	enum{
		M_JUDGE_BAROMETER_NOMAL,
		M_JUDGE_BAROMETER_JUST_GREATE_SPECIFIC,
		M_JUDGE_BAROMETER_GOOD_SPECIFIC,
		M_JUDGE_BAROMETER_0_PROTECT,
		M_JUDGE_BAROMETER_0_PROTECT_JUST_GREATE_SPECIFIC,
	};
	
	//	ComboCounter
	enum{
		M_COMBO_COUNTER_NO_OPERATE,
		M_COMBO_COUNTER_CLAER,
		M_COMBO_COUNTER_PLUS,
	};

	//-------------------------------------
	//	barometerl
	//-------------------------------------
	void	initJudgeBarometer( void ){
		MjudgeBarometer*	jb;
		int	judgeType;
		
		//	MacBeaẗڐAʓ|ȕ̈
		//	@Ă݂ƁA܂܂܂[ZbeBOłH
		//------------------------------------------------------------------
		judgeType = BMS_SEQ_JUDGE_POOR;
		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_ON ];
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= - 2.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= - 3.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= - 6.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= -60.0f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_CLAER;
			
		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_OFF ];
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= - 0.7f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= - 1.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= - 3.6f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= -20.0f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_CLAER;

		//------------------------------------------------------------------
		judgeType = BMS_SEQ_JUDGE_MISS;
		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_ON ];
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= - 0.50f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= - 0.75f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= - 3.60f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= -30.00f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_NO_OPERATE;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_NO_OPERATE;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_NO_OPERATE;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_NO_OPERATE;

		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_OFF ];
		jb->barometer[ judgeType ][ judgeType ].value						= - 0.20f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= - 0.25f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= - 1.20f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= - 7.00f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_CLAER;

		//------------------------------------------------------------------
		judgeType = BMS_SEQ_JUDGE_BAD;
		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_ON ];
		jb->barometer[ judgeType	 ][ BMS_SEQ_GAME_LEVEL_EASY ].value		= - 0.70f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= - 1.00f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= - 3.60f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= -30.00f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_CLAER;

		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_OFF ];
		jb->barometer[ judgeType	 ][ BMS_SEQ_GAME_LEVEL_EASY ].value		= - 0.20f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= - 0.30f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= - 1.20f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= - 7.00f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_CLAER;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_CLAER;

		//------------------------------------------------------------------
		judgeType = BMS_SEQ_JUDGE_GOOD;
		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_ON ];
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= 0.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= 0.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= 0.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= 0.0f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_PLUS;

		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_OFF ];
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= 0.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= 0.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= 0.0f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= 0.0f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_GOOD_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_GOOD_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_PLUS;

		//------------------------------------------------------------------
		judgeType = BMS_SEQ_JUDGE_GREATE;
		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_ON ];
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= 0.02f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_0_PROTECT_JUST_GREATE_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_0_PROTECT_JUST_GREATE_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_0_PROTECT;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_0_PROTECT;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_PLUS;

		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_OFF ];
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= 0.02f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_JUST_GREATE_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_JUST_GREATE_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_PLUS;

		//------------------------------------------------------------------
		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_ON ];
		judgeType = BMS_SEQ_JUDGE_JUST_GREATE;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= 0.02f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_0_PROTECT_JUST_GREATE_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_0_PROTECT_JUST_GREATE_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_0_PROTECT;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_0_PROTECT;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_PLUS;

		jb = &this->m_judgeBarometer[ BMS_SEQ_EXPART_MODE_OFF ];
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].value			= 0.02f;
		jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].value		= 0.02f;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].id			= M_JUDGE_BAROMETER_JUST_GREATE_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].id		= M_JUDGE_BAROMETER_JUST_GREATE_SPECIFIC;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].id			= M_JUDGE_BAROMETER_NOMAL;
			jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].id	= M_JUDGE_BAROMETER_NOMAL;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_EASY ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_NOMAL ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_HARD ].combo			= M_COMBO_COUNTER_PLUS;
				jb->barometer[ judgeType ][ BMS_SEQ_GAME_LEVEL_VERY_HARD ].combo		= M_COMBO_COUNTER_PLUS;
		//------------------------------------------------------------------
	}


public:

	//-------------------------------------
	//O[g̑ʂ̐ݒ
	//-------------------------------------
	void	setJadgeGreatGete( bool  inTrueIsDoublePlay ){

		if( inTrueIsDoublePlay ){
 			this->m_bmsHeaderTotalcount = this->m_bmsHeaderTotalcount / 1.7f ;	//	1.7ĂȂɁH
		}
		
		this->m_score.gudgeGreatGain = this->m_bmsHeaderTotalcount * ( 60.0f / 100.0f ) / (float)this->m_totalNoteCount;
		if( inTrueIsDoublePlay ){
			//	2Playerɂlc
		}
	}
 
 	//-------------------------------------
	//	score counter 
	//-------------------------------------
	void	scoreCount( BMSSeqExpartMode  inExpartMode, BMSSeqJudgeType  inJudge, BMSSeqGameLevelType  inGameLevel ){

		//	count
		switch( inJudge ){
			case	BMS_SEQ_JUDGE_POOR:
				this->m_score.grateComboCount = 0;
				break;
			case	BMS_SEQ_JUDGE_BAD:
				this->m_score.grateComboCount = 0;
				break;
			case	BMS_SEQ_JUDGE_MISS:
				break;
			case	BMS_SEQ_JUDGE_JUST_GREATE:
				++this->m_score.grateComboCount;
				this->m_score.totalScore += this->getScoreValue( this->m_score.grateComboCount );
				break;
			case	BMS_SEQ_JUDGE_GREATE:
				++this->m_score.grateComboCount;
				this->m_score.totalScore += (float)this->getScoreValue( this->m_score.grateComboCount ) / 2.0f;
				break;
			case	BMS_SEQ_JUDGE_GOOD:
				this->m_score.grateComboCount = 0;
				this->m_score.totalScore += (float)this->getScoreValue( this->m_score.grateComboCount ) / 10.0f;
				break;
		}
		
		//	XCount
		this->judgeCount( inJudge );
		this->addJudgeBarometer( inExpartMode, inJudge, inGameLevel );
		this->addComboCounter( inExpartMode, inJudge, inGameLevel );
	}

	//-------------------------------------
	//	record
	//-------------------------------------
	void	recordPlayData( void ){
	}

	//-------------------------------------
	//	t
	//-------------------------------------
	void	palyFinish( void ){
		this->m_trueIsFinish = true;
	}

	//-------------------------------------
	//	is clear ?
	//-------------------------------------
	bool	isClear( void ){
		//	Sm[gtĂāAŏITensionw芄𒴂ĂOK
		if( this->m_tensionGraph.index == m_totalNoteCount && 40 <= this->m_score.barometerJudge ){
			return true;
		}
		return false;
	}

private:

	//-------------------------------------
	//	judgeCount
	//-------------------------------------
	void	judgeCount( BMSSeqJudgeType  inJudge ){
		//	̃VvȃR[hPoorCountႤ
		++this->m_score.judgeNoteCount[ inJudge ];
		++this->m_score.totalJudgeNoteCount;
	}

	//-------------------------------------
	//	barometer
	//-------------------------------------
	void	addJudgeBarometer( BMSSeqExpartMode  inExpartMode, BMSSeqJudgeType  inJudge, BMSSeqGameLevelType  inGameLevel ){
		MjudgeBarometer::Mvalue*	 bv = &( this->m_judgeBarometer[ inExpartMode ].barometer[ inJudge ][ inGameLevel ] );
		float	barometer	= bv->value;

		//	judge BAROMETER
		switch( bv->id ){
			case	M_JUDGE_BAROMETER_NOMAL:
				this->m_score.barometerJudge	+= barometer;
				break;

			case	M_JUDGE_BAROMETER_JUST_GREATE_SPECIFIC:
				this->m_score.barometerJudge	+=  this->m_score.gudgeGreatGain;
				break;

			case	M_JUDGE_BAROMETER_0_PROTECT_JUST_GREATE_SPECIFIC:
				if( this->m_score.barometerJudge != 0 ){
					//	0łȂΉZ
					this->m_score.barometerJudge	+=  this->m_score.gudgeGreatGain;
				}
				break;

			case	M_JUDGE_BAROMETER_GOOD_SPECIFIC:
				float	gain;
				if( 1.0f < this->m_score.gudgeGreatGain  ){
					gain = 1.0f;
				}
				else{
					gain = this->m_score.gudgeGreatGain;
				}

				this->m_score.barometerJudge	+= gain / 5.0f;
				break;

			case	M_JUDGE_BAROMETER_0_PROTECT:
				if( this->m_score.barometerJudge != 0 ){
					//	0łȂΉZ
					this->m_score.barometerJudge	+= barometer;
				}
				break;
		}
		
		if( BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_MAX < this->m_score.barometerJudge ){
			this->m_score.barometerJudge = BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_MAX;
		}
		else if( this->m_score.barometerJudge < 0 ){
			this->m_score.barometerJudge = 0;
		}
		
		//	L^
		this->m_tensionGraph.array[ this->m_tensionGraph.index++ ] = this->m_score.barometerJudge;
	}

	//-------------------------------------
	//	combo counter 
	//-------------------------------------
	void	addComboCounter( BMSSeqExpartMode  inExpartMode, BMSSeqJudgeType  inJudge, BMSSeqGameLevelType  inGameLevel ){
		MjudgeBarometer::Mvalue*	 bv = &( this->m_judgeBarometer[ inExpartMode ].barometer[ inJudge ][ inGameLevel ] );
		int		combo		= bv->combo;

		//	combp counter
		switch( combo ){
			case M_COMBO_COUNTER_CLAER:
				this->m_score.comboCount = 0;
				break;
			case M_COMBO_COUNTER_PLUS:
				++this->m_score.comboCount;
				break;
			case M_COMBO_COUNTER_NO_OPERATE:
				break;
		}
	}
	//-------------------------------------
	//	get score value
	//-------------------------------------
	inline ABint	getScoreValue( ABint  inComboCount ){
		//	MacBeat Player.c 283s̈ڐA
		/*
			myPlayerData[pp].score.GTB[0]	= 200000/myPlayerData[pp].score.nts;		//ŏ̓_	200000/Note
			z += myPlayerData[pp].score.GTB[0];
			x = myPlayerData[pp].score.GTB[0];
			for( i=1; i<=(myPlayerData[pp].score.nts-2); i++ )
			{
				myPlayerData[pp].score.GTB[i] = x;
				z += x;
			}
			myPlayerData[pp].score.GTB[myPlayerData[pp].score.nts-1] = 200000-z;
		*/
		//	vɁAscore͐vZ㕂_̌덷A200000_ɂȂȂB␳KvłB
		int		value = ( inComboCount == this->m_totalNoteCount ? 
					 ( BMS_SEQ_SCORE_1SONG_VALUE - this->m_score.noteValue * (this->m_totalNoteCount - 1 ) ) : this->m_score.noteValue );
		return	value;
	}

public:
	//	give barometer
	typedef struct{
		typedef struct{
			float	value;
			int		combo;
			int		id;
		}	Mvalue;
	
		Mvalue	barometer[ BMS_SEQ_JUDGE_COUNT ][ BMS_SEQ_GAME_LEVEL_COUNT ];
	
	}	MjudgeBarometer;
	

	//	ResultGraph
	typedef struct{
		ABint		index;
		MintArray	array;		//OtpɋL^B

	}	MtensionGraphData;

	//	Score
	typedef struct{
		MintArray	judgeNoteCount;			//poor,Bad,Good,Great,JustGreat
		int			totalJudgeNoteCount;	//poor,Bad,Good,Great,JustGreat̍v

		int			noteValue;				//1Notẻli1NotẽXRAjintłȂ΂ȂȂ
		int			totalScore;				//XRA
		int			grateComboCount;		//AO[g

		float		barometerJudge;			//Judgeɉđo[^[(Tensionl)
		float		gudgeGreatGain;			//Great擾barometerJudge𑝉邽߂̒l

		int			comboCount;				//R{
//		int			comboCountMax;			//R{ől
	}	MScoreData;

	//	FZone
	typedef struct{
		bool		trueIsActive;
		bool		trueIsLasting;
		bool		trueIsCleared;
		bool		trueIsGreat;

	}	MFreeZoneState;

	//	Player
	typedef struct{
		bool			trueIsExist;
		bool			trueIsAutoPlay;
		bool			trueIsAutoScrach;
		MFreeZoneState	freezone;

	}	MPlayerState;

	//	data
	MPlayerState		m_playerState;
	MtensionGraphData	m_tensionGraph;
	MScoreData			m_score;
	ABint				m_bmsHeaderTotalcount;	//	BMSf[^HeaderɏĂ#TOTALl
	ABint				m_totalNoteCount;		//	BMSf[^̃f[^̎ۂ̉NOTEl
	bool				m_trueIsFinish;			//	tItrueɂB
	
	ABint				m_waveData[10];
	MjudgeBarometer		m_judgeBarometer[ BMS_SEQ_EXPART_MODE_COUNT ];

	bool	m_init;
};

#endif	//	BMSConsumer_h
