/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSJudge.h

				AquaBeatsV[PT[	

				EL[ɂ͂Ɖ̈ʒuABAD,GOOD,GREAT,JUST GREAT𔻒肷B

				lA茋ʂ́ÃNXɎȂB
				@O܂ł肾sAlȂǂOɒuƂŔėp߂ĂB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSJudge_h
#define	BMSJudge_h

#include	<vector>

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"BMSConfig.h"

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSJudge
{
private:
	//---------------------
	//	p
	//---------------------
	typedef	struct	MjudgeInfo{
	
		float		range;		//	ʒu͔LƂ鋗B1ߓ192\̒lƂB
								//	MacBeatł́APߓ 256ipixeljŌvZĂB
		float		score;
		
		MjudgeInfo(){
			range = 0;
			score = 0;
		}
	}	MjudgeInfo;

	typedef	std::vector<MjudgeInfo>	MjudgeInfoArray;
	MjudgeInfoArray					m_judgeInfoArray;

public:
	BMSJudge(){
		this->clear();
	}
	virtual	~BMSJudge(){
	};


	//---------------------
	//	
	//---------------------

	//	ǉ
	//	Ebad,greate,ȂǁAeǉBQ[[h؂ւ閈ɁAēxݒ肵ȂƁB
	void		addJudgeInfo( BMSSeqJudgeType  inJudge, float  inRange ){
		MjudgeInfo		judgeInfo;
		
		judgeInfo.range	= inRange;
		this->m_judgeInfoArray[inJudge] = judgeInfo;
	}
	
	//	clear
	void	clear( void ){
		this->m_judgeInfoArray.clear();
		this->m_judgeInfoArray.resize(BMS_SEQ_JUDGE_COUNT);
	}

	//---------------------
	//	Get/Set
	//---------------------
	float	getRange( int  inJudgeInfoID ){
		MjudgeInfo*		judgeInfo = &( this->m_judgeInfoArray[ inJudgeInfoID ] );
		return	judgeInfo->range;
	}
	void	getRange( int  inJudgeInfoID, float  inValue ){
		MjudgeInfo*		judgeInfo = &( this->m_judgeInfoArray[ inJudgeInfoID ] );
		judgeInfo->range = inValue;
	}


	//---------------------
	//	
	//	E肵ȂB]ĂƂĂVvB
	//	@BĂȂǂ̏wf͊Oōς܂B
	//---------------------
	bool	judge( int  inJudgeInfoID, float  inLocation, float  inNoteLocation, bool*  outPoorIsTrue ){

		*outPoorIsTrue = false;
		float  range = inLocation - inNoteLocation;	//	݂̃P[VA肵̃P[V̍߂

		if( range < 0 ){
			//	̂́Aǂ悤H
			range *= 0.2;
			range *= -1.0f;
		}
		
		//	
		MjudgeInfo*		judgeInfo = &( this->m_judgeInfoArray[ inJudgeInfoID ] );
		if( judgeInfo == NULL ){
			return false;
		}
		if( judgeInfo->range == -1){
			if( (inLocation - inNoteLocation) < 0 ){
				//	poor
				*outPoorIsTrue = true;
			}
			else{
				*outPoorIsTrue = false;
			}
			return false;
		}
		else{
			if( range < judgeInfo->range ){
				//	i
				return true;
			}
			else{
				//	si
				return false;
			}
		}
	}

};

#endif	//	BMSJudge_h
