/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSJudgeValue.h

				AquaBeatsV[PT[	

				EL[ɂ͂Ɖ̈ʒuABAD,GOOD,GREAT,JUST GREAT𔻒肷B
				@ۂ̒l`܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSJudgeValue_h
#define	BMSJudgeValue_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"BMSConfig.h"
#include	"BMSJudge.h"

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSJudgeValue
{
private:
	BMSJudge		m_judgeArray[ BMS_SEQ_GAME_LEVEL_COUNT ];				//	Q[̃xɕێ

public:
	BMSJudgeValue(){
	};
	virtual	~BMSJudgeValue(){
	};

	//---------------------
	//	̏
	//---------------------
	void		initialize( int  inBPM ){
		BMSJudge*			jc;

		//	ABł́AyI𑜓xx[XŏĂ̂ŁA摜hbg̈ړXs[hlKv܂B
		//	@̕A₷ȂƎv܂B
		//	@lMacBeatɋ߂Ă܂ÅIɈႤBKɒĂˁB
		
		//	MacBeaťvZ̈Ӗς킩iĵŁAƎɍlĂ݂c
		//	BMP120i * 1.0f jƂAȂ͒Ȃ悤( BPM240Ł@*2.0f )AxȂ͒ZȂ悤AB
		float	balance = 1.0f * ( (ABfloat32)inBPM / 120.0f );	

		//	BMS_SEQ_GAME_LEVEL_EASY
		jc	= &this->m_judgeArray[ BMS_SEQ_GAME_LEVEL_EASY ];
		jc->clear();
		jc->addJudgeInfo( BMS_SEQ_JUDGE_JUST_GREATE	,  9.5f	* balance );	//	BMS_SEQ_JUDGE_JUST_GREATE
		jc->addJudgeInfo( BMS_SEQ_JUDGE_GREATE		, 19.0f	* balance );	//	BMS_SEQ_JUDGE_GREATE
		jc->addJudgeInfo( BMS_SEQ_JUDGE_GOOD		, 36.0f	* balance );	//	BMS_SEQ_JUDGE_GOOD
		jc->addJudgeInfo( BMS_SEQ_JUDGE_BAD			, 46.0f	* balance);		//	BMS_SEQ_JUDGE_BAD
		jc->addJudgeInfo( BMS_SEQ_JUDGE_POOR		, -1				  );	//	BMS_SEQ_JUDGE_POOR	(<--ŌɕKĂB)
		//	MISS͕svł
		
		//	BMS_SEQ_GAME_LEVEL_NOMAL
		jc	= &this->m_judgeArray[ BMS_SEQ_GAME_LEVEL_NOMAL ];
		jc->clear();
		jc->addJudgeInfo( BMS_SEQ_JUDGE_JUST_GREATE	,  8.2f	* balance );	//	BMS_SEQ_JUDGE_JUST_GREATE
		jc->addJudgeInfo( BMS_SEQ_JUDGE_GREATE		, 16.4f	* balance );	//	BMS_SEQ_JUDGE_GREATE
		jc->addJudgeInfo( BMS_SEQ_JUDGE_GOOD		, 34.0f	* balance );	//	BMS_SEQ_JUDGE_GOOD
		jc->addJudgeInfo( BMS_SEQ_JUDGE_BAD			, 46.0f	* balance );	//	BMS_SEQ_JUDGE_BAD
		jc->addJudgeInfo( BMS_SEQ_JUDGE_POOR		, -1				  );	//	BMS_SEQ_JUDGE_POOR	(<--ŌɕKĂB)
		//	MISS͕svł

		//	BMS_SEQ_GAME_LEVEL_HARD
		jc	= &this->m_judgeArray[ BMS_SEQ_GAME_LEVEL_HARD ];
		jc->clear();
		jc->addJudgeInfo( BMS_SEQ_JUDGE_JUST_GREATE	,  7.0f	* balance );	//	BMS_SEQ_JUDGE_JUST_GREATE
		jc->addJudgeInfo( BMS_SEQ_JUDGE_GREATE		, 14.0f	* balance );	//	BMS_SEQ_JUDGE_GREATE
		jc->addJudgeInfo( BMS_SEQ_JUDGE_GOOD		, 29.0f	* balance );	//	BMS_SEQ_JUDGE_GOOD
		jc->addJudgeInfo( BMS_SEQ_JUDGE_BAD			, 45.0f	* balance );	//	BMS_SEQ_JUDGE_BAD
		jc->addJudgeInfo( BMS_SEQ_JUDGE_POOR		, -1				  );	//	BMS_SEQ_JUDGE_POOR	(<--ŌɕKĂB)
		//	MISS͕svł

		//	BMS_SEQ_GAME_LEVEL_VERY_HARD
		jc	= &this->m_judgeArray[ BMS_SEQ_GAME_LEVEL_VERY_HARD ];
		jc->clear();
		jc->addJudgeInfo( BMS_SEQ_JUDGE_JUST_GREATE,  6.0f 	* balance);		//	BMS_SEQ_JUDGE_JUST_GREATE
		jc->addJudgeInfo( BMS_SEQ_JUDGE_GREATE,		 12.0f	* balance );	//	BMS_SEQ_JUDGE_GREATE
		jc->addJudgeInfo( BMS_SEQ_JUDGE_GOOD,		 24.0f	* balance );	//	BMS_SEQ_JUDGE_GOOD
		jc->addJudgeInfo( BMS_SEQ_JUDGE_BAD,		 43.0f	* balance );	//	BMS_SEQ_JUDGE_BAD
		jc->addJudgeInfo( BMS_SEQ_JUDGE_POOR,		 -1				  );	//	BMS_SEQ_JUDGE_POOR	(<--ŌɕKĂB)
		//	MISS͕svł
	}

	//---------------------
	//	
	//---------------------
	bool judge( BMSSeqGameLevelType  inGameLevel, float  inLocation, float  inNoteLocation, BMSSeqJudgeType*  outJudgeType ){
		int		j;
		bool	result;
		bool	poorIsTrue;

		for( j = 0 ; j < BMS_SEQ_JUDGE_COUNT; j++ ){
			result = this->m_judgeArray[ inGameLevel ].judge( j, inLocation, inNoteLocation, &poorIsTrue );
			if( ! result ){
				//	薳̎
				if( poorIsTrue ){
					//	Ă
					*outJudgeType = BMS_SEQ_JUDGE_POOR;
					return	true;
				}
				//	̑̔Ȃ̂ŁAs
			}
			else{
				//	L̎
				*outJudgeType = j;
				return	true;
			}
		}

		//	Y
		*outJudgeType = BMS_SEQ_JUDGE_POOR;
		return	true;
	}

};

#endif	//	BMSJudgeValue_h
