/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSParserConfig.h

				eLXgtH[}bgɊւ`B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSParserConfig_h
#define	BMSParserConfig_h

#include	"GlobalConfig.h"
#include	"BMSConfig.h"

/////////////////////////////////////////////////////////////////////////////////
//
//	eLXg\̒`
//
//	BMSt@C̏ǂݎɎgp`B
//
/////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
//	gqXg
//------------------------------------------------------------------------------
inline ABint8*		BMSGetFileExtBMP( ABuint  inNumber ){
	static	ABint8*		ext[] = {
		"bm",	//	5L[?
		"bms",	//	5L[
		"bme",	//	7L[
		"mbm",	//	7L[H
	};
	
	if( (sizeof(ext) / sizeof(ABint8*)) <= inNumber ){
		return NULL;
	}
	return	ext[inNumber];
}

inline ABint8*		BMSGetFileExtWAV( ABuint  inNumber ){
	static	ABint8*		ext[] = {
		"mp3",	//	MP3
		"MP3",	//	MP3
	};
	
	if( (sizeof(ext) / sizeof(ABint8*)) <= inNumber ){
		return NULL;
	}
	return	ext[inNumber];
}

//------------------------------------------------------------------------------
//
//	text literal
//
//------------------------------------------------------------------------------
#define	BMS_TP_InfoData_STR_Player		"#PLAYER"
#define	BMS_TP_InfoData_STR_Genre		"#GENRE"
#define	BMS_TP_InfoData_STR_Title		"#TITLE"
#define	BMS_TP_InfoData_STR_Artist		"#ARTIST"
#define	BMS_TP_InfoData_STR_BPM			"#BPM"
#define	BMS_TP_InfoData_STR_PlayLevel	"#PLAYLEVEL"
#define	BMS_TP_InfoData_STR_Rank		"#RANK"
#define	BMS_TP_InfoData_STR_VolWav		"#VOLWAV"
#define	BMS_TP_InfoData_STR_Total		"#TOTAL"
#define	BMS_TP_InfoData_STR_StageFile	"#STAGEFILE"
#define	BMS_TP_InfoData_STR_Scheme		"#SCHEMEFILE"
#define	BMS_TP_InfoData_STR_Midi		"#MIDIFILE"

#define	BMS_TP_InfoData_STR_BMP			"#BMP"
#define	BMS_TP_InfoData_STR_WAV			"#WAV"

#define	BMS_TP_eventData_STR_RANDOM		"#RANDOM"
#define	BMS_TP_eventData_STR_IF			"#IF"
#define	BMS_TP_eventData_STR_ENDIF		"#ENDIF"

//------------------------------------------------------------------------------
//
//	text length
//
//------------------------------------------------------------------------------
#define	BMS_TP_CHAR_LENGTH_TITLE		(255)
#define	BMS_TP_CHAR_LENGTH_GENRE		(255)
#define	BMS_TP_CHAR_LENGTH_ARTIST		(255)
#define	BMS_TP_CHAR_LENGTH_FILENAME		(63)	//	macȂ̂63
#define	BMS_TP_CHAR_LENGTH_FILEPATH		(1024)

//------------------------------------------------------------------------------
//
//	ő吔
//
//------------------------------------------------------------------------------
#define	BMS_TP_EVENT_MAX			255		//	Q̃Cxgʎq̍őlB̐܂ŃCxg`oB
#define	BMS_TP_OBJECT_ARRAY_MAX		512		//	IuWFNgz̃IuWFNg̍őlB

//------------------------------------------------------------------------------
//
//	Event
//	EBM98ł̓`lƌĂԂ̂łB
//
//------------------------------------------------------------------------------
typedef	ABtype		BMSTPEventType;					//	ZĎgp邽߁AenumtypedefȂ

enum {
	//	10i
	BMS_TP_EVENT_NOTHING			= -1L,			//	l
	
	//	MacBeats compatible
	BMS_TP_EVENT_BACK_CHORUS		= 1L,			//	01:dont play WAV
	BMS_TP_EVENT_SET_BAR_RATE		= 2L,			//	02:߂̔{i_j
	BMS_TP_EVENT_CHANGE_BPM			= 3L,			//	03:BPMl̓rύX
	BMS_TP_EVENT_SET_BGA			= 4L,			//	04:BGA
//	BMS_TP_EVENT_SET_EXTEND			= 5L,			//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
	BMS_TP_EVENT_SET_ANIMATION		= 6L,			//	06:PoorAj[V̕ύX
	BMS_TP_EVENT_SET_LAYER			= 7L,			//	07:BGA Layer transparency key color
	BMS_TP_EVENT_SET_EX_BPM			= 8L,			//	08:gBPM

	BMS_TP_EVENT_OBJECT_1P			= 10L,			//	11-19:1P	IuWFNg
	BMS_TP_EVENT_OBJECT_2P			= 20L,			//	21-29:2P	IuWFNg
	BMS_TP_EVENT_HIDE_OBJECT_1P		= 30L,			//	31-39:1P	sIuWFNg
	BMS_TP_EVENT_HIDE_OBJECT_2P		= 40L,			//	41-49:2P	sIuWFNg

	//::TODO::ǉdĺAK̊gdlȂ̂L
	//ex	BMS_TP_AB0100_OBJECT					//	aqua beats 1.00g
	
};

enum{

	//
	//	*_OBJECT_*P OBJECT TYPE	
	//
	//	BMS_TP_EVENT_OBJECT_*, BMS_TP_EVENT_HIDE_OBJECT_*  ƉZĎgp܂B
	//

	//	for 1 - 5 key mode
	BMS_TP_OBJECT_KEY1				= 1,			//	1 Key			(11,21,31,41)
	BMS_TP_OBJECT_KEY2				= 2,			//	2 Key
	BMS_TP_OBJECT_KEY3				= 3,			//	3 Key
	BMS_TP_OBJECT_KEY4				= 4,			//	4 Key
	BMS_TP_OBJECT_KEY5				= 5,			//	5 Key
	
	BMS_TP_OBJECT_SCRATCH			= 6,			//	scratch
	BMS_TP_OBJECT_SCRATCH_FREE		= 7,			//	free scratch

	//	for 1 - 7 Key mode
	BMS_TP_OBJECT_MODE7_KEY6		= 8,			//	6 key
	BMS_TP_OBJECT_MODE7_KEY7		= 9,			//	7 key
};


inline	BMSSeqEventType	BMSSeqGetEventType( BMSTPEventType  inTPEvent ){
	BMSSeqEventType		t = BMS_BMSEQ_EVENT_NOTHING;
	switch( inTPEvent ){
		case BMS_TP_EVENT_NOTHING:
			t = BMS_BMSEQ_EVENT_NOTHING;
			break;
			
		//	MacBeats compatible
		case BMS_TP_EVENT_BACK_CHORUS:
			t = BMS_BMSEQ_EVENT_BACK_CHORUS;
			break;
			
		case BMS_TP_EVENT_SET_BAR_RATE:
			t = BMS_BMSEQ_EVENT_SET_BAR_RATE;
			break;
			
		case BMS_TP_EVENT_CHANGE_BPM:
			t = BMS_BMSEQ_EVENT_CHANGE_BPM;
			break;
			
		case BMS_TP_EVENT_SET_BGA:
			t = BMS_BMSEQ_EVENT_SET_BGA;
			break;
			
		case BMS_TP_EVENT_SET_ANIMATION:
			t = BMS_BMSEQ_EVENT_SET_ANIMATION;
			break;
			
		case BMS_TP_EVENT_SET_LAYER:
			t = BMS_BMSEQ_EVENT_SET_LAYER;
			break;
			
		case BMS_TP_EVENT_SET_EX_BPM:
			t = BMS_BMSEQ_EVENT_SET_EX_BPM;
			break;

		case BMS_TP_EVENT_OBJECT_1P:
		case BMS_TP_EVENT_OBJECT_2P:
			t = BMS_BMSEQ_EVENT_OBJECT;
			break;
			
		case BMS_TP_EVENT_HIDE_OBJECT_1P:
		case BMS_TP_EVENT_HIDE_OBJECT_2P:
			t = BMS_BMSEQ_EVENT_HIDE_OBJECT;
			break;
	}
	return	t;
}


inline	BMSSeqEventTrackType	BMSSeqGetTrackNumber( BMSTPEventType  inTPTrack ){
	BMSSeqEventTrackType		trackNumber = BMS_SEQ_TRACK_EVENT;
	switch( inTPTrack ){
		case	BMS_TP_OBJECT_KEY1:
			trackNumber = BMS_SEQ_TRACK_KEY1;
			break;
		case	BMS_TP_OBJECT_KEY2:
			trackNumber = BMS_SEQ_TRACK_KEY2;
			break;
		case	BMS_TP_OBJECT_KEY3:
			trackNumber = BMS_SEQ_TRACK_KEY3;
			break;
		case	BMS_TP_OBJECT_KEY4:
			trackNumber = BMS_SEQ_TRACK_KEY4;
			break;
		case	BMS_TP_OBJECT_KEY5:
			trackNumber = BMS_SEQ_TRACK_KEY5;
			break;
		case	BMS_TP_OBJECT_SCRATCH:
			trackNumber = BMS_SEQ_TRACK_KEY_SCRATCH;
			break;
		case	BMS_TP_OBJECT_SCRATCH_FREE:
			trackNumber = BMS_SEQ_TRACK_KEY_SCRATCH_FREE;
			break;
		case	BMS_TP_OBJECT_MODE7_KEY6:
			trackNumber = BMS_SEQ_TRACK_KEY6;
			break;
		case	BMS_TP_OBJECT_MODE7_KEY7:
			trackNumber = BMS_SEQ_TRACK_KEY7;
			break;
	}
	return	trackNumber;
};

//------------------------------------------------------------------------------
//	vCNij
//------------------------------------------------------------------------------
typedef enum BMSTPRank{

	BMS_TP_RANK_EASY		= 1,
	BMS_TP_RANK_NORMAL		= 2,
	BMS_TP_RANK_HARD		= 3,
	BMS_TP_RANK_VERY_HARD	= 4,

} BMSTPRank;

//------------------------------------------------------------------------------
//	Target Player count
//	vCΏۂƂĂlB
//------------------------------------------------------------------------------
typedef enum BMSTPTargetPlayerCount{

	BMS_TP_FOR_1_PLAYER	= 1,
	BMS_TP_FOR_2_PLAYER = 2,

	BMS_TP_COUNT,
} BMSTPTargetPlayerCount;

/////////////////////////////////////////////////////////////////////////////////
//
//	ʗp
//
//	ȉ͓ǂݍݎParserɔ肷eȂ̂ŁAI[gNumberƂĂB
//
/////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	Key track count
//	5@L[ or 7 L[
//------------------------------------------------------------------------------
typedef enum BMSTPKeyModeType{

	BMS_TP_KEY_TYPE_5KEY,
	BMS_TP_KEY_TYPE_7KEY,

	BMS_TP_KEY_TYPE_COUNT,
} BMSTPKeyModeType;

//------------------------------------------------------------------------------
//	BGA̗L
//------------------------------------------------------------------------------
typedef enum BMSTPBGAType{

	BMS_TP_BGA_TYPE_NOTHING,
	BMS_TP_BGA_TYPE_HAVING,

	BMS_TP_BGA_TYPE_COUNT,
} BMSTPBGAType;

/////////////////////////////////////////////////////////////////////////////////
//
//	Structure
//
/////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
//
//	information Structure
//
//	BMS̊e[
//
//------------------------------------------------------------------------------
typedef struct BMSTPSongInformation{
	
	//	BMSeLXgt@CɏLĂ
	ABint8	strTitle[BMS_TP_CHAR_LENGTH_TITLE];
	ABint8	strGenre[BMS_TP_CHAR_LENGTH_GENRE];
	ABint8	strArtist[BMS_TP_CHAR_LENGTH_ARTIST];

	ABint					bpm;
	ABint					playerLevel;
	BMSTPTargetPlayerCount	player;			//	1P, or 2P	::TODO::͒PɃvC[lw肵Ă邾H
	BMSTPRank				rank;			//	ABbmsRank
	ABint					total;
	ABint					volWav;	
	
	ABint8	fileNameStageFile[BMS_TP_CHAR_LENGTH_FILENAME];
	ABint8	fileNameMidi[BMS_TP_CHAR_LENGTH_FILENAME];
	ABint8	fileNameScheme[BMS_TP_CHAR_LENGTH_FILENAME];

	//	p
	BMSTPKeyModeType			keyModeType;	//	5key ? 7key ?
	BMSTPBGAType				BGAType;		//	have BGA ?

	ABint8						directoryName[BMS_TP_CHAR_LENGTH_FILENAME];	//	tH_[̖O

	ABuint						stageBMPData;	//	Xe[Wt@C̉摜B摜f[^͕̂̂ʓrǗB
	ABuint						midiFileData;	//	MIDIf[^ւ̎Q

	ABuint						missBMPData;	//	~X摜BBM98dlł͉tf[^Ɋ܂܂邪A{Iɂ̓wb_łƌȂ邽߁AɎB
	ABuint						lastBarID;		//	Ō̏ߔԍ

	//	RANDOMw͂Ɋ܂܂ȂBiȃf[^̃p[XɏvvZbTIȖBj

	//	֐
	void	clean( void ){
		//	defaultlݒ肷
		strTitle[0] = 0;
		strGenre[0] = 0;
		strArtist[0]= 0;
		bpm			= 130;
		playerLevel	= 0;
		player		= BMS_TP_FOR_1_PLAYER;
		rank		= BMS_TP_RANK_NORMAL;
		total		= 0;
		volWav		= 100;
		
		fileNameStageFile[0]	= 0;
		fileNameMidi[0]			= 0;
		fileNameScheme[0]		= 0;

		stageBMPData = 0;
		midiFileData = 0;
		keyModeType = BMS_TP_KEY_TYPE_5KEY;			//	5key ? 7key ?
		BGAType 	= BMS_TP_BGA_TYPE_NOTHING;		//	have BGA ?
		directoryName[0] = 0;
		
		missBMPData = 0;
		lastBarID = 0;
	}
	
} BMSTPSongInformation, *BMSTPSongInformationPtr;

//------------------------------------------------------------------------------
//	BMS Material BitMap
//------------------------------------------------------------------------------
typedef struct	BMSMaterialBMP
{
	ABint				number;
	ABint8				filename[BMS_TP_CHAR_LENGTH_FILENAME];

	//	f[^ւ̎QƂ͔ԍōs܂Bۂ̃f[^͕ʓrǗ܂B
	ABint				bmpData;		

	BMSMaterialBMP(){
		clean();
	}

	//	֐
	void	clean( void ){
		number		= 0;
		filename[0]	= 0;
		bmpData		= 0;
	}
} BMSMaterialBMP, *BMSMaterialBMPPtr;

typedef	std::vector<BMSMaterialBMP>			BMSMaterialBMPArray;
typedef	BMSMaterialBMPArray::iterator		BMSMaterialBMPArrayIt;

//------------------------------------------------------------------------------
//	BMS Material Sound Data
//------------------------------------------------------------------------------
typedef struct	BMSMaterialWAV
{
	ABint				number;
	ABint8				filename[BMS_TP_CHAR_LENGTH_FILENAME];

	//	f[^ւ̎QƂ͔ԍōs܂Bۂ̃f[^͕ʓrǗ܂B
	ABint				wavData;		

	BMSMaterialWAV(){
		clean();
	}

	//	֐
	void	clean( void ){
		number		= 0;
		filename[0]	= 0;
		wavData		= 0;
	}
} BMSMaterialWAV, *BMSMaterialWAVPtr;
typedef	std::vector<BMSMaterialWAV>			BMSMaterialWAVArray;
typedef	BMSMaterialWAVArray::iterator		BMSMaterialWAVArrayIt;

//------------------------------------------------------------------------------
//	BMS BPM Data
//------------------------------------------------------------------------------
typedef struct	BMSTableBPM
{
	ABint				number;
	ABfloat32			bpm;

	BMSTableBPM(){
		clean();
	}

	//	֐
	void	clean( void ){
		number		= 0;
		bpm			= 0.0f;
	}
} BMSTableBPM, *BMSTableBPMPtr;
typedef	std::vector<BMSTableBPM>			BMSBMSTableBPMArray;
typedef	BMSBMSTableBPMArray::iterator		BMSTableBPMArrayIt;

//------------------------------------------------------------------------------
//	BMS BGA Data
//------------------------------------------------------------------------------
typedef struct	BMSTableBGA
{
	ABint				number;

	//	֐
	void	clean( void ){
		number		= 0;
	}
} BMSTableBGA, *BMSTableBGAPtr;
typedef	std::vector<BMSTableBGA>			BMSTableBGAArray;
typedef	BMSTableBGAArray::iterator			BMSTableBGAArrayIt;

//------------------------------------------------------------------------------
//	BMS Object Array
//------------------------------------------------------------------------------

typedef	std::vector<ABint>					BMSObjectDataArray;
typedef	BMSObjectDataArray::iterator		BMSObjectDataArrayIt;

//------------------------------------------------------------------------------
//	BMS Vibrant Data
//	Pߕ̏B
//------------------------------------------------------------------------------
typedef struct	BMSTPVibrantData
{
	ABint						barID;			//	ID
	BMSTPEventType				eventType;		//	Cxg

	BMSObjectDataArray			objectArray;	//	IuWFNgf[^zieventTypeɂĎgωj
	ABfloat64					value;			//	lieventTypeɂĎgωj
	bool						visible;		//	Es	::TODO::<-delete

	BMSSeqEventPlayerNumber		player;			//	player
	BMSTPEventType				trackNumber;	//	0,1key~7key,scratch,etc̎wB0͑gbNB

	//	֐
	void	clean( void ){
		barID		= 0;
		eventType	= BMS_TP_EVENT_NOTHING;
		value		= 0;
		visible		= 0;
		player		= BMS_BMSEQ_EVENT_PLAYER1;
		trackNumber	= BMS_SEQ_TRACK_EVENT;
		objectArray.reserve( BMS_TP_OBJECT_ARRAY_MAX );
		objectArray.clear();
	}

	//	IuWFNgf[^
	long	getObjectCount( void ){
		return	objectArray.size();
	}

} BMSTPVibrantData, *BMSTPVibrantDataPtr;

typedef	std::vector<BMSTPVibrantData>			BMSTPVibrantDataArray;
typedef	BMSTPVibrantDataArray::iterator			BMSTPVibrantDataArrayIt;

//-------------------------------------------
//	BMS Music Data class
//	Pȕ̏
//-------------------------------------------

typedef	struct	BMSTPSongData{
	
	BMSTPSongInformation		information;				//	header info
	BMSMaterialBMPArray			materialBMPArray;			//	matireal STL vector array
	BMSMaterialWAVArray			materialWAVArray;			//	matireal STL vector array
	BMSBMSTableBPMArray			tableBPMArray;				//	ext bpm  STL vector array
	BMSTableBGAArray			tableBGAArray;				//	BGA 	 STL vector array
	BMSTPVibrantDataArray		eventDataArray;				//	sequence STL vector array

	BMSTPSongData(){
		clean();
	}

	//	֐
	void	clean( void ){
		this->information.clean();
		this->materialBMPArray.clear();
		this->materialWAVArray.clear();
		this->tableBPMArray.clear();
		this->tableBGAArray.clear();
		this->eventDataArray.clear();
	}
	
	//	BMP擾
	ABint	getBMPData( ABuint  inIndex ){
		return	materialBMPArray[ inIndex ].bmpData;
	}
	ABint8*	getBMPFileName( ABuint  inIndex ){
		return	materialBMPArray[ inIndex ].filename;
	}
	
	//	WAV擾
	ABint	getWAVData( ABuint  inIndex ){
		return	materialWAVArray[ inIndex ].wavData;
	}
	ABint8*	getWAVFileName( ABuint  inIndex ){
		return	materialBMPArray[ inIndex ].filename;
	}
	
	//	BPM擾
	ABfloat32	getBPM( ABuint  inIndex ){
		return	tableBPMArray[ inIndex ].bpm;
	}
	
} BMSTPSongData;


#endif	//	BMSParserConfig_h
