/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABParser.cpp

				BMS`
				ʓ|ȎĂ邪Ao邾Select-Case𖳂enumȂǒlɂ镪ȂB
				萔͔ޕɕÛŁAT̂̂t̂ʓ|B
				ȂقǁAdlύXɋȂB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////


#include	"ABParser.h"

#include	<ctype.h>
#include	<algorithm>
#include	<iostream>

using namespace std;

/*//////////////////////////////////////////////////////////////////////////////
*	class AB BMS Music Analyzer MacBeat 
*///////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------
//	class Architecture MacBeat
//	MacBeatdl̉͋@\NXB
//
//	̃NX̖ړIBMSf[^\̎dlEɂ邱ƂłB
//	IgݗĂ鎖ł΁ABM,DDR,Mac,WinʌɊgtH[}bg𕪗ł邾낤B
//	ł͂̃NXSĂȂ̂ŗ]ӖȂȂi͂|GɂȂƂȂjB
//
//----------------------------------------------------------------
class	ABBMSMusicArchitectureMacBeat : public	ABBMSMusicArchitecture
{
private:
	typedef	ABBMSArchitectureBase		MArchitecture;

public:
	//--------------------------------
	//	Cxgl擾邽߂̃CxgʎqΉNX
	//--------------------------------
	template< typename  scanType >	//	ǂݎ^w肷鎖Blong
	class MTypeValue :  public	MArchitecture{
	public:
		MTypeValue(){};
		virtual ~MTypeValue(){};
		//	Cxg̉͂Ǝ擾܂BŒl̎擾AIuWFNgz̉͂sB
		bool	analyze( ABbmsEventData&  outEventData, long  inBarID, long  inEventType, long  inEventTrackNumber, char*  inValue ) {
			if( typeid(scanType) == typeid(long) ){
				long	v;
				sscanf( inValue, "%ld", &v );
				outEventData.value = v;
			}
			else if( typeid(scanType) == typeid(double) ){
				double	v;
				sscanf( inValue, "%lf", &v );
				outEventData.value = v;
			}
			else{
				return false;
			}
			outEventData.barID		= inBarID;
			outEventData.eventType	= inEventType;
			return true;
		}
	};
	
	//--------------------------------
	//	CxgʎqvC[io[AgbNԍ܂ł鎞̏NX
	//	݂NotepIuWFNgzł̂ݎgĂB
	//--------------------------------
	class MTypeTrackEvents :  public	MArchitecture{
	public:
		MTypeTrackEvents(){};
		virtual ~MTypeTrackEvents(){};
		//	Cxg̉͂Ǝ擾܂BŒl̎擾AIuWFNgz̉͂sB
		bool	analyze( ABbmsEventData&  outEventData, long  inBarID, long  inEventType, long  inEventTrackNumber, char*  inValue ){
			
			//	gbNio[擾
			outEventData.trackNumber = (inEventType % 10);										//	10̈ʂ擾
			if( AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY7 < outEventData.trackNumber ){
				//	unkown or not suported track
				cout << "-unkown or not suported track." << endl;
				return false;
			}	//	Ή̃gbNԍł
			
			//	vC[io[擾
			outEventData.eventType = inEventType - outEventData.trackNumber;	//	1̈ʂ؂̂
			switch( outEventData.eventType ){
				case AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P:				//	11-19:1P	IuWFNg
					outEventData.visible = true;
					outEventData.player = AB_BMS_MUSIC_DATA_PLAYER_NUMBER_1;
					++outEventData.noteEventCount;
					break;
				case AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P:				//	21-29:2P	IuWFNg
					outEventData.visible = true;
					outEventData.player = AB_BMS_MUSIC_DATA_PLAYER_NUMBER_2;
					++outEventData.noteEventCount;
					break;
				case AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_1P:		//	31-39:1P	sIuWFNg
					outEventData.visible = false;
					outEventData.player = AB_BMS_MUSIC_DATA_PLAYER_NUMBER_1;
					break;
				case AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_2P:		//	41-49:2P	sIuWFNg
					outEventData.visible = false;
					outEventData.player = AB_BMS_MUSIC_DATA_PLAYER_NUMBER_2;
					break;
				default:
					//	unkown or not suported events
					cout << "-unkown or not suported events." << endl;
					return false;
					break;
			}
			return true;
		}
	};
	
	//--------------------------------
	//	IuWFNgz^̃CxglKvƂCxgʎqΉNX
	//	KeyBoardZonezp(ՖɃCxgĂ^Cv)
	//--------------------------------
	template< class T = MArchitecture >	//	ev[g^@ɂāAIuWFNgz񏈗ȗ̂B
	class MTypeValueObjects :  public	MArchitecture{
	public:
		MTypeValueObjects(){
			mObjectValueType = M_OBJECT_TYPE_16;
		};
		virtual ~MTypeValueObjects(){};
		
		//	ǂݎIuWFNgzl̐lʂw肵ĂB
		typedef enum{
			M_OBJECT_TYPE_16,	//	16i
			M_OBJECT_TYPE_36,	//	36ii 0...9, a...z j
		} MObjectValueType;
		MObjectValueType	mObjectValueType;
		
		//	Cxg̉͂Ǝ擾܂BŒl̎擾AIuWFNgz̉͂sB
		bool	analyze( ABbmsEventData&  outEventData, long  inBarID, long  inEventType, long  inEventTrackNumber, char*  inValue ){
			bool	result = false;
			
			outEventData.barID 		= inBarID;
			outEventData.eventType	= inEventType;

			//	NOTEzũIuWFNgz񂩂ǂł͉Ȃ󂾂AgbNԍ擾݂B
			//	ev[gMTypeTrackEventsŖƂ͉NȂA
			//	ev[gMTypeTrackEventŝƂ̓gbNԍ擾łB
			result = this->m_trackAnaryzer.analyze( outEventData, inBarID, inEventType, inEventTrackNumber, inValue );
			if( ! result ){ return result; }
			
			//	
			{
				//	
				char	str[3]			={ 0, 0, 0 };
				long	objectCount		= 0;
				int		object	= 0;
				char*	dataBufferPtr	= inValue;
				
				//	
				//	̒iKŏ߂̏dɂčlKv͖BlɋlߍOKB
				while( ( *dataBufferPtr != 0 ) && ( objectCount <= AB_BMS_MUSIC_DATA_OBJECT_MAX ) ){
					//	ɂunsigned char16iŊi[B
					str[0] = tolower( *(dataBufferPtr + 0) );
					str[1] = tolower( *(dataBufferPtr + 1) );
					
					switch( this->mObjectValueType ){
						case M_OBJECT_TYPE_16:
							//	16iœǂݍ
							sscanf( str, "%x", &object );
							break;
						case M_OBJECT_TYPE_36:
							//	36iœǂݍ
							object = ABParser::convCharToNum( str, 2 );
							if( object < 0 ){
								object  = 0;
							}
							break;
					};
					outEventData.objectArray.push_back( object );
					++objectCount;
					dataBufferPtr += 2;
				}
			}
			return	true;
		}
	private:
		T	m_trackAnaryzer;
	};
		
public:
	ABBMSMusicArchitectureMacBeat(){
		this->init();
	};
	virtual ~ABBMSMusicArchitectureMacBeat(){};

	//----------------------------------------	
	//	tH[}bg\z
	//	EǂݎׂCxgʎq͑SĂŏݒ肵܂B
	//	EResourcẽIuWFNgźAM_OBJECT_TYPE_36w肵ĂBȗƂPUilœǂݎ܂B
	//----------------------------------------	
	virtual void	setupDataFormat(){
	
		//	Cxgʎq
		this->mTypeBackChorus.mObjectValueType	= MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv
		this->mTypeSetBGA.mObjectValueType		= MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv
		this->mTypeSetAnimation.mObjectValueType = MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv
		this->mTypeSetLayer.mObjectValueType	= MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv

		this->setData( &this->mTypeBackChorus, 	AB_BMS_MUSIC_DATA_EVENT_BACK_CHORUS );	//	01:dont play WAV
		this->setData( &this->mTypeSetBarRate, 	AB_BMS_MUSIC_DATA_EVENT_SET_BAR_RATE);	//	02:߂̔{i_j
		this->setData( &this->mTypeChangeBPM, 	AB_BMS_MUSIC_DATA_EVENT_CHANGE_BPM	 );	//	03:BPMl̓rύX
		this->setData( &this->mTypeSetBGA, 		AB_BMS_MUSIC_DATA_EVENT_SET_BGA		 );	//	04:BGA
		//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
		this->setData( &this->mTypeSetAnimation,AB_BMS_MUSIC_DATA_EVENT_SET_ANIMATION );	//	06:PoorAj[V̕ύX
		this->setData( &this->mTypeSetLayer, 	AB_BMS_MUSIC_DATA_EVENT_SET_LAYER );		//	07:BGA Layer transparency key color
		this->setData( &this->mTypeSetExBPM, 	AB_BMS_MUSIC_DATA_EVENT_SET_EX_BPM	 );		//	08:gBPM

		ABbmsMusicDataTrackNumber	noteNumber[M_TRACK_COUNT] = {
			AB_BMS_MUSIC_DATA_OBJECT_KEY1,				//	1 Key			(11,21,31,41)
			AB_BMS_MUSIC_DATA_OBJECT_KEY2,				//	2 Key
			AB_BMS_MUSIC_DATA_OBJECT_KEY3,				//	3 Key
			AB_BMS_MUSIC_DATA_OBJECT_KEY4,				//	4 Key
			AB_BMS_MUSIC_DATA_OBJECT_KEY5,				//	5 Key
			AB_BMS_MUSIC_DATA_OBJECT_SCRATCH,			//	scratch
			AB_BMS_MUSIC_DATA_OBJECT_SCRATCH_FREE,		//	free scratch
			AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY6,		//	6 key
			AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY7,		//	7 key
		};
		ABint	i;
		for( i = 0; i < M_TRACK_COUNT ; i++ ){
			this->mTypeObjectShow1p[i].mObjectValueType = MTypeValueObjects<MTypeTrackEvents>::M_OBJECT_TYPE_36;	//	36ĩIuWFNgz͂̎w肪Kv
			this->mTypeObjectShow2p[i].mObjectValueType = MTypeValueObjects<MTypeTrackEvents>::M_OBJECT_TYPE_36;	//	36ĩIuWFNgz͂̎w肪Kv
			this->mTypeObjectHide1p[i].mObjectValueType = MTypeValueObjects<MTypeTrackEvents>::M_OBJECT_TYPE_36;	//	36ĩIuWFNgz͂̎w肪Kv
			this->mTypeObjectHide2p[i].mObjectValueType = MTypeValueObjects<MTypeTrackEvents>::M_OBJECT_TYPE_36;	//	36ĩIuWFNgz͂̎w肪Kv

			this->setData( &this->mTypeObjectShow1p[i], noteNumber[i] + AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P );		//	11-19:1P	IuWFNg
			this->setData( &this->mTypeObjectShow2p[i], noteNumber[i] + AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P );		//	21-29:2P	IuWFNg
			this->setData( &this->mTypeObjectHide1p[i], noteNumber[i] + AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_1P );	//	31-39:1P	sIuWFNg
			this->setData( &this->mTypeObjectHide2p[i], noteNumber[i] + AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_2P );	//	41-49:2P	sIuWFNg
		}
	};

public:
	//	BMSʎq`
	MTypeValueObjects<>		mTypeBackChorus;		//	01:dont play WAV
	MTypeValue<double>		mTypeSetBarRate;		//	02:߂̔{i_j
	MTypeValueObjects<>		mTypeChangeBPM;			//	03:BPMl̓rύX
	MTypeValueObjects<>		mTypeSetBGA;			//	04:BGA
	//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
	MTypeValueObjects<>		mTypeSetAnimation;		//	06:PoorAj[V̕ύX
	MTypeValueObjects<>		mTypeSetLayer;			//	07:BGA Layer transparency key color
	MTypeValue<long>		mTypeSetExBPM;			//	08:gBPM

	enum{
		M_TRACK_COUNT = AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY7
	};
	MTypeValueObjects<MTypeTrackEvents>		mTypeObjectShow1p[M_TRACK_COUNT];	//	11-19:1P	IuWFNg
	MTypeValueObjects<MTypeTrackEvents>		mTypeObjectShow2p[M_TRACK_COUNT];	//	21-29:2P	IuWFNg
	MTypeValueObjects<MTypeTrackEvents>		mTypeObjectHide1p[M_TRACK_COUNT];	//	31-39:1P	sIuWFNg
	MTypeValueObjects<MTypeTrackEvents>		mTypeObjectHide2p[M_TRACK_COUNT];	//	41-49:2P	sIuWFNg
};


/*//////////////////////////////////////////////////////////////////////////////
*	class ABParser
*///////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABParser::ABParser()
{
	this->m_loadMode = AB_LOAD_ALL_DATA;
	this->setupEventTable();
}
//	copy constructer
ABParser::ABParser( ABLoadMode  inLoadMode )
{
	this->m_loadMode = inLoadMode;
	this->setupEventTable();
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABParser::~ABParser()
{
	delete	this->m_musicArchitecture;
}
//-------------------------------------------------------
//	BMSCxgʎq`
//-------------------------------------------------------
void	ABParser::setupEventTable( void )
{
	try{
		this->m_musicArchitecture = new ABBMSMusicArchitectureMacBeat;
	}
	catch(...){
		this->m_musicArchitecture = NULL;
	}
}

//-------------------------------------------------------
//	BMSt@Cǂݍ
//-------------------------------------------------------
bool	ABParser::loadBMSFile( GameFileInfo*  inFileInfoPtr, ABbmsMusicData*  refMusicData )
{
	bool			result = false;
	char*			textBuffer = NULL;
	MVecTextArray	rowArray; 
	unsigned int	bufSize;
	
	//	eLXgǂݍ
	ABint8		filePath[ 1024 ];
	inFileInfoPtr->copyPath( (ABuint8*)filePath, sizeof( filePath ) );
	result = GameTextParser::readFileToBuffer( filePath, &textBuffer, &bufSize );
	if( ! result ){
		//	t@CG[
		return result;
	}
	
	do{
		if( bufSize == 0 ){
			//	t@C
			break;
		}
		
		//	eLXgobt@sPʂłԂ
		this->m_parserTool.sliceRows( textBuffer, bufSize, &rowArray );

		//	eLXgobt@@RpC
		//	E̎_őp\ȏԂɂĂ
		{
			//	eLXg -> wb_[f[^ifޏj
			result = this->readBMSheaderData( refMusicData, &rowArray );
			if( ! result ){
				//	"\pThis is not BMS file.";
				break;
			}
			
			if( this->m_loadMode == AB_LOAD_ALL_DATA ){
				//	eLXg -> Cxgf[^`
				result = this->readBMSeventData( refMusicData, &rowArray );
				if( ! result ){
					//	̓G[FCxgf[^
					break;
				}
			}
		}

		
		result = true;
	}while( false );
	
	//	eLXgobt@
	GameTextParser::releaseFileBuffer( textBuffer );

	return result;
}

//-------------------------------------------------------
//	eLXg -> wb_[f[^
//	Eǂݍޕ
//		E~[WbNip^A̓j
//		Efޏit@Cj
//-------------------------------------------------------
bool	ABParser::readBMSheaderData( ABbmsMusicData*  refMusicData, MVecTextArray*  inArray )
{
	MVecTextArray::iterator		it;
	//MVecTextArray::iterator		itTest;
	char*			buffer;
	char*		CHAR_SHARP_CODE		= "#";
	char			dataBuffer[1024];

	long			lvalue;
	char*			cvalue;
	char			literalBuffer[16];	//	#̎擾p
	char			resValueBuffer[3];	//	ʔԍ擾p
	
	ABbmsMaterialBMPdata	bmpData;
	ABbmsMaterialWAVdata	wavData;
	
	bool	flagMaterial;
	bool	flagComplete;

	cout << "ABParser::readBMSheaderData() Read header data." << endl;

	//	f[^so
	it = inArray->begin();
	this->m_parserTool.findRow( inArray, it, CHAR_SHARP_CODE );

	//	
	ABint	arraySize = (10 + 26) * (10 + 26);
	refMusicData->materialBMPdataArray.resize( arraySize );	//	i΁j͍œK̗]nLłȁB
	refMusicData->materialWAVdataArray.resize( arraySize );

	//	f[^ǂ݂ƂJn
	while( it != inArray->end() ){

		//::TODO::ԂɕłƂ͌ȂACf[^Ƃ̋ʂoȂߑS悤B
		//	mainf[^܂łǂ݂Ƃ̂ŁACf[^R[hoĂI
		//itTest = it;
		//if( ! this->m_parserTool.findRow( inArray, itTest, CHAR_MAINDATA_CODE ) ){
		//	//	end
		//	break;
		//}
		
		
		//-----------------------------
		//	36iϊ test code
		//	ȏɏ̂Ȃ񂾂iϊAVCƎv鎞͎gpĂ݂Ɨǂ낤j
		//-----------------------------
		/*
		{
			int		testx, testy ;
			int		testv ;
			char*	testdata = "0123456789abcdefghijklmnopqrstuvwxyz";	//ُnisɂȂ邾낤l̃P[Xp^[j͏ȗij
			char	testbuf[ 3 ] = {
				0,0,0,
			};
			
			for(testy=0;testy<36;testy++){
				for(testx=0;testx<36;testx++){
					testbuf[ 0 ] = testdata[ testy  ];
					testbuf[ 1 ] = testdata[ testx ];
					testv = this->convCharToNum( testbuf, 2 );
					cout << testv << " <- " << testbuf << " / ";
				}
			}
			cout << endl ;
		}
		*/
		//-----------------------------
		//	36iϊ test code܂
		//-----------------------------
		
		buffer = *it;

		bmpData.clean();
		wavData.clean();
		lvalue = 0;
		cvalue = NULL;
		flagMaterial = false;
		flagComplete = false;

		//	Sēǂݎw̎
		if( this->m_loadMode == AB_LOAD_ALL_DATA ){
		
			//	fރf[^ǂݎ
			sscanf( buffer, "%4s%2s %s", literalBuffer, resValueBuffer, dataBuffer );

			//	resValueBuffer  resValue
			if( resValueBuffer[0] != 0 ){
				flagMaterial = true;
				flagComplete = true;
				if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_BMP ) ){
					//	hit	AB_BMSInfoData_STR_BMP
					bmpData.number = this->convCharToNum( resValueBuffer, 2 );
					strncpy( bmpData.filename, dataBuffer, AB_BMS_CHAR_LENGTH_FILENAME );
//					refMusicData->materialBMPdataArray.push_back( bmpData );
					refMusicData->materialBMPdataArray[bmpData.number] = bmpData;
					cout << "-READ > bmpData.filename:" << dataBuffer << ",bmpData.number:" << bmpData.number << endl ;
				}
				//::TODO::MP3KvB
				else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_WAV ) ){
					//	hit	AB_BMSInfoData_STR_WAV
					wavData.number = this->convCharToNum( resValueBuffer, 2 );
					strncpy( wavData.filename, dataBuffer, AB_BMS_CHAR_LENGTH_FILENAME );
//					refMusicData->materialWAVdataArray.push_back( wavData );
					refMusicData->materialWAVdataArray[wavData.number] = wavData;
					
					cout << "-READ > wavData.filename:" << dataBuffer << ",wavData.number:" << wavData.number << endl ;
				}
				else{
					flagMaterial = false;
					flagComplete = false;
				}
			}
					
		}//if
		
		//	fނł͖literaĺAHEADER񂾂낤Ɨ\B
		if( ! flagMaterial ){
			//	other key word
			sscanf( buffer, "%s %s", literalBuffer, dataBuffer );
			
			//	ᖡ
			//::TODO::VL[𑝂₷Ƃ͂ɒǉ
			flagComplete = true;
			if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Player ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->headerInfo.player = lvalue;
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Genre ) ){
				cvalue = &refMusicData->headerInfo.strGenre[0];
				this->getBufferValue( dataBuffer, cvalue );
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Title ) ){
				cvalue = &refMusicData->headerInfo.strTitle[0];
				this->getBufferValue( dataBuffer, cvalue );
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Artist ) ){
				cvalue = &refMusicData->headerInfo.strArtist[0];
				this->getBufferValue( dataBuffer, cvalue );
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_BPM ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->headerInfo.bpm = lvalue;
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_PlayLevel ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->headerInfo.playerLevel = lvalue;
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Rank ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->headerInfo.rank = lvalue;
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_VolWav ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->headerInfo.volWav = lvalue	;
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Total ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->headerInfo.total = lvalue;
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_StageFile ) ){
				cvalue = &refMusicData->headerInfo.fileNameStageFile[0];
				this->getBufferValue( dataBuffer, cvalue );
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Random ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->headerInfo.random = lvalue;
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Scheme ) ){
				cvalue = &refMusicData->headerInfo.fileNameScheme[0];
				this->getBufferValue( dataBuffer, cvalue );
			}
			else if( 0 == strcmp( literalBuffer, AB_BMSInfoData_STR_Midi ) ){
				cvalue = &refMusicData->headerInfo.fileNameMidi[0];
				this->getBufferValue( dataBuffer, cvalue );
			}
			else {
				//	unkown key word
				flagComplete = false;
				//cout << "-READ unkown header > " << literalBuffer << endl;
			}
		}
		
		if( flagComplete ){
			//	ǂݍ񂾍s폜iCxgf[^`̃f[^ǂݍ݂𑬂j
			it = inArray->erase( it );
		}
		else {
			++it;
		}
	}

	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Player 	<< ",value:" << refMusicData->headerInfo.player << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Genre 	<< ",value:" << refMusicData->headerInfo.strGenre << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Title 	<< ",value:" << refMusicData->headerInfo.strTitle << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Artist 	<< ",value:" << refMusicData->headerInfo.strArtist << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_BPM 		<< ",value:" << refMusicData->headerInfo.bpm << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_PlayLevel << ",value:" << refMusicData->headerInfo.playerLevel << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Rank 	<< ",value:" << refMusicData->headerInfo.rank << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_VolWav 	<< ",value:" << refMusicData->headerInfo.volWav << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Total 	<< ",value:" << refMusicData->headerInfo.total << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_StageFile << ",value:" << refMusicData->headerInfo.fileNameStageFile << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Random 	<< ",value:" << refMusicData->headerInfo.random << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Scheme 	<< ",value:" << refMusicData->headerInfo.fileNameScheme << endl ;
	cout << "-READ > literalBuffer:" << AB_BMSInfoData_STR_Midi 	<< ",value:" << refMusicData->headerInfo.fileNameMidi << endl ;

	cout << "ABParser::readBMSheaderData() Read header data finish." << endl;

	return	true;
}

//-------------------------------------------------------
//	eLXg -> Cxgf[^`
//-------------------------------------------------------
bool	ABParser::readBMSeventData( ABbmsMusicData*  refMusicData, MVecTextArray*  inArray )
{
	bool			result = false;
	MVecTextArray::iterator		it;
	char*			buffer;

	long			barID;
	long			eventType;
	long			eventTrackNumber;
	double			dvalue;
	char			dataBuffer[1024];
	bool			unkown;
	
	char*			CHAR_SHARP_CODE	= "#";
	ABbmsEventData	eventData;
	
	cout << "ABParser::readBMSeventData() Read event data." << endl;
	
	
	int		useMaxTrackCount = 0;	//	gbNi5,7L[ʗpj
	bool	trueHaveBGA = false;
	
	//	f[^so
	it = inArray->begin();
	this->m_parserTool.findRow( inArray, it, CHAR_SHARP_CODE );

	//	f[^ǂ݂ƂJn
	while( it != inArray->end() ){
		buffer = (*it++);

		//	
		eventData.clean();
		unkown 			= false;
		barID			= 0;
		eventType		= 0;
		eventTrackNumber	= 0;
		dataBuffer[0]	= 0;
		dvalue			= 0;
		
		//	read rows
		//	Cxg^Cv16iȂ10i?
		sscanf( buffer, "#%3ld%2ld:%s", &barID, &eventType, dataBuffer );

		//	f[^͂AeventDataɊi[B
		cout << "-READ EVENT > " << barID << "," << eventType << "," << eventTrackNumber << "," << dataBuffer << endl ;
		eventData.clean();
		result = this->m_musicArchitecture->analyze( eventData, barID, eventType, eventTrackNumber, dataBuffer );
		if( !result ){
			//	sB̃Cxg͓ǂݎs\łB
			cout << "  -READ ERROR." << endl;
			break;
		}
		else{
			cout << "  -EVENT > ";
			cout << "barID:" << eventData.barID << ",";
			cout << "eventType:" << eventData.eventType << ",";
			cout << "player:" << eventData.player << ",";
			cout << "visible:" << eventData.visible << ",";
			cout << "trackNumber:" << eventData.trackNumber<< ",";
			cout << "value:" << eventData.value<< ",";
			cout << "objectArray:" << eventData.objectArray.size();
			cout << endl;
			
			//	ABbmsMusicDataɊi[
			refMusicData->eventDataArray.push_back( eventData );
			refMusicData->noteEventCount += eventData.noteEventCount;
			
			if( useMaxTrackCount < eventData.trackNumber ){
				useMaxTrackCount = eventData.trackNumber;
			}
			if( eventData.eventType == AB_BMS_MUSIC_DATA_EVENT_SET_BGA ){
				trueHaveBGA =  true;
			}
		}
	}
	
	cout << "ABParser::readBMSeventData() Read event data finish." << endl;

	if( !result ){
		return	false;
	}
	
	//	Headerɐݒ
	if( AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY6 <= useMaxTrackCount ){
		refMusicData->headerInfo.keyModeType = AB_BMS_KEY_TYPE_7KEY;
	}
	else{
		refMusicData->headerInfo.keyModeType = AB_BMS_KEY_TYPE_5KEY;
	}
	if( trueHaveBGA ){
		refMusicData->headerInfo.BGAType = AB_BMS_BGA_TYPE_HAVING;
	}
	else{
		refMusicData->headerInfo.BGAType = AB_BMS_BGA_TYPE_NOTHING;
	}
	
	return	true;
}

//-------------------------------------------------------
//	obt@̕擾
//-------------------------------------------------------
//	擾
void	ABParser::getBufferValue( char*  inBuffer, char*  outValue )
{
	sscanf( inBuffer, "%s", outValue );
}
//	POi擾(long^)
void	ABParser::getBufferValue( char*  inBuffer, long*  outValue )
{
	sscanf( inBuffer, "%ld", outValue );
}
//	POi擾(double^)
void	ABParser::getBufferValue( char*  inBuffer, double*  outValue )
{
	sscanf( inBuffer, "%lf", outValue );
}
//	PUi擾(unsigned long^)
void	ABParser::getBufferValue( char*  inBuffer, unsigned long*  outValue )
{
	unsigned long  value = 0;
	sscanf( inBuffer, "%x", &value );
	if( value == 0 ){
		sscanf( inBuffer, "%X", &value );
	}
	*outValue = value;
}

//-------------------------------------------------------
//	io[ɕϊ( 36i )
//-------------------------------------------------------
int		ABParser::convCharToNum( char*  inBuffer, int  inLength )
{
	int		li = 0;
	char	lc = 0;
	int		resValue = 0;

	for( li = 0; li < inLength; li ++ ){
		resValue *= 36;

		lc = tolower( inBuffer[li] );	//	A -> a

		if( '0' <= lc && lc <= '9'){
			resValue += lc - '0';
		}
		else if( 'a' <= lc && lc <= 'z'){
			resValue += 10 + (lc - 'a');
		}
		else{
			//	Ǖs\
			break;
		}
	}
	return	resValue;
}
