/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqBMEventAction.h

				AquaBeatsV[PT[ EventAction

				ESequencer͓ǂݍ񂾃f[^EventoƁÃNXo[sB
				ENX́ÃNXp邱ƂŁAeEventsłB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSeqBMEventAction_h
#define	ABSeqBMEventAction_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABSeqData.h"
#include	"ABSeqBMSong.h"
#include	"ABSeqEventActionBase.h"

class	ABVARunner;
class	ABMBVAItemRenderStagePlay;
class	ABVAItemBindStagePlay;

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqBMEventAction	: public	ABSeqEventActionBase
{
public:
	ABVARunner*						mVARunner;				//	VAɕ``B
	ABMBVAItemRenderStagePlay*		mVAItemRenderStagePlay;	//	VAɕ``B
	ABVAItemBindStagePlay*			mVAItemBindStagePlay;	//	VAɕ``B
	
public:
	ABSeqBMEventAction();
	~ABSeqBMEventAction();
	
	//----------------------------------
	//	initialize finalize
	//----------------------------------
	virtual	void	initialize( void );
	virtual	void	finalize( void );

	//----------------------------------
	//	fetch@EventHandler	vibrant
	//	Oɐǂ݂AsEventHandler
	//	EŃL[ATCsȂ܂
	//----------------------------------
	virtual	void	fetchEventSelecter( ABSeqData*  inData, ABbmsMusicDataEventType  inEventType, ABseqTrackType  inTrackType, int  inObject, ABbmsEventData*  inEvent  );

	//----------------------------------
	//	EventHandler
	//	WXg^C~OŎsCxgnh[
	//	EBGAȂǂ̐؂ւs܂
	//----------------------------------
	virtual	void	eventSelecter( ABSeqData*  inData, ABbmsMusicDataEventType  inEventType, ABseqTrackType  inTrackType, int  inObject, ABbmsEventData*  inEvent, bool  inTrueIsAutoPlay  );

	//----------------------------------
	//	EventHandler	object arrays
	//	EߓňEventBĐAAnimationȂǂȂ
	//----------------------------------
	//	IuWFNgzEvent
	virtual	void	onToggleNote( ABSeqData*  inData, ABseqTrackType  inTrackType, int  inObject );
	//	m[gKEYBOARDɃATC
	virtual	void	onAssignNote( ABSeqData*  inData, ABseqTrackType  inTrackType, int  inObject );

	//-------------------------------------------------------
	//	Request
	//-------------------------------------------------------
	//	݂LOCATIONXV
	virtual void	updateLocation( int  inLocation );
	
	//	߂ς
	virtual void	changeVibrant( int  inLocation );

	//	consumer̓͏Request
	virtual	void	requestPushKeyStatus( int  inLocation );

	//	requestPushKeyStatusŃL[͂󂯎Å֐R[ĂB
	virtual	void	doPushKey( ABseqTrackType  inTrackType, int  inLocation, bool  inTrueIsPress );

	//	ʕ`RequestiIuWFNgʂɂPߒPʂŔzuj
	virtual	void	requestDrawSetObject( ABseqTrackType  inTrackType, ABint  inLocation );

	//	茋ʂ
	virtual	void	reportJudge( ABSeqData*  inData,ABseqTrackType  inTrackType, ABseqJudgeType  inJudgeType );

private:
	typedef struct{
		int		object;
		ABbmsMaterialWAVdata*	wavData;
		int		soundChannel;
	} MsoundData;

	MsoundData		m_nextSoundData[ AB_SEQ_TRACK_COUNT ];
	
	ABuint			m_chorusTrack;
};

#endif	//	ABSeqBMEventAction_h
