/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameView.cpp

				Q[\ʃVF

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GameView_h
#define	GameView_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"CWorkerConfig.h"
#include	"GUIView.h"

#include	"ABView.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GameView : public	GUIView
{
private:
	ABView&		m_abView;

public:
	GameView( ABView&  inView );
	~GameView( void );

	//	initialize
	virtual	CWbool			onInit( void );
	//	finalize
	virtual	void			onFinal( void );
	//	change screen mode
	virtual	void			onChangeScreenMode( CWbool  inTrueIsFullScreenMode );
	//	`ƃ_[ƃXbv
	//	XbvtrueԂĂBfalseԂƃXbv܂B
	virtual	CWbool			onDraw( void );
	//	`̈XV
	virtual	void			onReshape( void );

	//	AvP[VCxgɌĂт܂
	virtual CWbool			onAppEvent( const GVSeventApp  inEvent );

};


#endif	GameView_h
