//	GVSApplication

#ifndef	GUIApp_h
#define	GUIApp_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"CWorkerConfig.h"
#include	"GVSApplication.h"
#include	"GUIMenu.h"
#include	"GUIView.h"
#include	"GVSTimerEvent.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GUIApp : public	code_worker::GVSApplication, code_worker::GVSTimerEvent
{
public:
	GUIMenu			m_menu;
	GUIView&		m_view;

	CWint			m_value;

public:
	GUIApp( GUIView&  inView );
	~GUIApp( void );
	
	CWbool	initialize( void );
	void	finalize( void );
	
	//	t[[gŃ^C}[Zbg
	//	E̊֐͎sɃt[[gύX邽߂ɗpӂ́B
	CWbool	setTimerLoop( const CWint  inFrameRate );

	//	^C}[[vŌĂяo܂B
	virtual void	onEventLoop( void );
	//	CxgɌĂт܂
	virtual GVSeventResult	onEventHandler( const GVSeventApp  inEvent );
	
	//	AvP[VI
	static	void	appQuit( void ){
		code_worker::GVSApplication	appri;
			appri.quit();
	}
	//	[TCY
	static	SInt32	getPhysicalMemorySize( void ){
		return	ms_physicalMemorySize;
	}
	static	SInt32	ms_physicalMemorySize;
};

#endif	GUIApp_h

