/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameMediaService
*	File:		GMSAudioCD.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				MacOS 10.0 later
*				
*				CD-ROM̎xB
*
*				MacOS Xł͒ڃI[fBICDĐi͗pӂĂ܂B
*				̂ACD-ROM̃gbN͑S'AIFF'Ŏ擾ł܂B
*				āACD-ROM̃t@CpX擾ł΁A
*				Ƃ͕ʂ̃t@CƂāAQuickTime邢AudioUnitɐ܂ĊłB
*				CD-ROMɈˑȂ߁AႦΓ̃tH_zCD-ROMƌĂQ[œsǂƎv܂B
*
*				̃NX̋@\́A
*					open		ړĨI[fBICDAA}Egs\ɂAfsRefԂB
*					release		A}Eg\ɂB
*
*				Eaudio-cdmł܂B
*				Ecd̃pX\߉Ăꍇ́AʂɃt@CANZXȒPłB
*				EۂɃI[fBIĐɂ́A擾 fsRef DirectoryƂāAt@CTĂB
*				EgbNԍ͐擪ɕtĂԍŔfł܂B
*
*	FileVersion:
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/29	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GMSAudioCD_h
#define	GMSAudioCD_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameMediaService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GMSAudioCD
{
private:
	FSVolumeRefNum		n_volumeRefNum;	//	QƂĂAudioCD

public:
	GMSAudioCD( void );
	virtual	~GMSAudioCD( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////
	
	//	CD-ROMJAǂݎ
	//		E[X܂ŁAAudioCD̃CWFNgs\ɂ܂B
	//
	//		F@CWint	inVolumeNumber			1 ... n		ŏɔAudioCDPƂāAAudioCD̔ԍw肵܂B
	//		F@FSRef*  outAudioCDFileRef		AudioCDFSRefԂ܂B
	//		ߒlF@CWresultCode					G[R[h
	CWresultCode	open( const CWint  inVolumeNumber /* = 1 */, FSRef*  outAudioCDFileRef );

	//	p
	//
	//		ߒlF@CWresultCode	G[R[h
	CWresultCode	release( void );

private:
};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GMSAudioCD_h