/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameViewService
*	File:		CWGameViewService.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/19	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/03/22>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWGameViewService_h
#define	CWGameViewService_h

#include	"CWorkerConfig.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	Cxg߂l
//------------------------------------------------------------------------------
enum{
	//	Cxg
	GVS_EVENT_RESULT_OK,
	
	//	CxgȂ
	GVS_EVENT_RESULT_NO,
};
typedef	CWtype		GVSeventResult;

////////////////////////////////////////////////////////////////////////////////
//
//	Define APP
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	AvP[VCxg
//------------------------------------------------------------------------------
enum{
	//	IO
	//		j[AAbvCxgɂIiVXeIɔIE܂jB
	GVS_EVENT_APP_QUIT,

	//	ANeBuɂȂ܂
	GVS_EVENT_APP_ACTIVATE,

	//	fBANeBuɂȂ܂
	GVS_EVENT_APP_DEACTIVATE,
};
typedef	CWtype		GVSeventApp;

////////////////////////////////////////////////////////////////////////////////
//
//	Define MENU
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	j[Cxg
//------------------------------------------------------------------------------
enum{
	//	j[I܂B
	GVS_EVENT_MENU_SELECTED,
	
	//	j[̍XVvB̃^C~OŁAj[̕\Ԃ̌Ms܂B
	GVS_EVENT_MENU_UPDATE,
};
typedef	CWtype		GVSeventMenu;

////////////////////////////////////////////////////////////////////////////////
//
//	Define WINDOW
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	EBhE
//------------------------------------------------------------------------------

//	@\

enum{
	//	N[Y{^iԐF̃{^jt܂
	GVS_WINDOW_ATTRIBUTE_CLOSE_BUTTON		= 1L << 1,

	//	~j}CY{^iF̃{^jt܂
	GVS_WINDOW_ATTRIBUTE_MINIMIZE_BUTTON	= 1L << 2,

	//	Y[{^iΐF̃{^jt܂
	GVS_WINDOW_ATTRIBUTE_ZOOM_BUTTON		= 1L << 3,
		
	//	TCY\ɂ܂
	GVS_WINDOW_ATTRIBUTE_RESIZE				= 1L << 4,

	//	}EXCxg擾܂
	GVS_WINDOW_ATTRIBUTE_GET_MOUSE_EVENT	= 1L << 5, 

	//	L[{[hXCxg擾܂
	GVS_WINDOW_ATTRIBUTE_GET_KEYBOARD_EVENT	= 1L << 6, 

	//	^ubgCxg擾܂
	GVS_WINDOW_ATTRIBUTE_GET_TABLET_EVENT	= 1L << 7, 
};
typedef	CWtype		GVSwindowAttribute;

//	O

enum{
	//	W
	GVS_WINDOW_APPEARANCE_NORAML,

	//	^̊Oςɂ܂
	GVS_WINDOW_APPEARANCE_METAL,
	
	//	̃EBhEɂ܂
	GVS_WINDOW_APPEARANCE_OVERLAY,
};
typedef	CWtype		GVSwindowAppearance;

//	|WV
//		10.2Ȍ̃^Cv̂݃T|[g
enum{
	//	Cʂ̒S
	GVS_WINDOW_POSITION_CENTER_ON_MAIN_SCREEN,
	
	//	őOʂ̃EBhȆO̒S
	GVS_WINDOW_POSITION_CENTER_ON_PARENT_WINDOW,
	
	//	Cʂ̍őOʁAEBhEƂ͂Ă܂
	GVS_WINDOW_POSITION_CASCADE_ON_MAIN_SCREEN,

	//	őOʂ̃EBhE̍őOʁAEBhEƂ͂Ă܂
	GVS_WINDOW_POSITION_CASCADE_ON_PARENT_WINDOW,

	//	őOʂ̃EBhE̍őOʁAEBhEƂ͂Ă܂BʃTCYɍ킹ēKɒ܂B
	GVS_WINDOW_POSITION_CASCADE_START_AT_PARENT_WINDOW,

	//	CʂAlert|WV	
	GVS_WINDOW_ALART_POSITION_ON_MAIN_SCREEN,

	//	őOʂ̃EBhȆOAlert|WV	
	GVS_WINDOW_ALART_POSITION_ON_PARENT_WINDOW,
};
typedef	CWtype		GVSwindowPosition;

//------------------------------------------------------------------------------
//	r[Cxg
//------------------------------------------------------------------------------
enum{
	//	J
	GVS_EVENT_VIEW_OPEN,

	//	O
	GVS_EVENT_VIEW_CLOSE,
	
	//	ړ܂
	GVS_EVENT_VIEW_MOVE,

	//	TCY܂
	//		EOpenGLł͂̃^C~OŃReLXg̃Abvf[gKvłB
	//		@XɃTCYAړ̍Œ͌JԂCxg΂邽߁Aʂ̍ĕ`KvłB
	//		@ړ邾ł̂ŁATCŶ݂ʂ悤ɂĂB
	//		EEBhEJĂт܂B
	GVS_EVENT_VIEW_RESIZE,

	//	Y[{^NbN܂
	GVS_EVENT_VIEW_ZOOMED,

	//	ANeBuɂȂ܂
	GVS_EVENT_VIEW_ACTIVATE,

	//	fBANeBuɂȂ܂
	GVS_EVENT_VIEW_DEACTIVATE,

	//	𑜓x؂ւ܂iʃTCYF[xj
	GVS_EVENT_VIEW_CHANGE_DISPLAY_MODE,
};
typedef	CWtype		GVSeventView;

//------------------------------------------------------------------------------
//	}EXCxg
//		ẼCxǵAEBhEANeBuԂ̂Ƃ̂ݔ܂B
//------------------------------------------------------------------------------
enum{
	//	{^NbN܂
	GVS_EVENT_MOUSE_DOWN,

	//	{^𗣂܂
	GVS_EVENT_MOUSE_UP,
	
	//	}EXړ܂
	GVS_EVENT_MOUSE_MOVED,

	//	}EXhbO܂
	//		NbŃAhbOołȂBENbN͗LB
	GVS_EVENT_MOUSE_DRAGGED,

	//	zC[𓮂܂
	GVS_EVENT_MOUSE_WHEEL_MOVED,
};
typedef	CWtype		GVSeventMouse;

//	}EX{^
enum{
	GVS_EVENT_MOUSE_BUTTON_PRIMARY		= 1,		//	{^
	GVS_EVENT_MOUSE_BUTTON_SECONDARY	= 2,		//	E{^
	GVS_EVENT_MOUSE_BUTTON_TERTIARY		= 3,		//	O{^
};
typedef CWuint16	GVSeventMouseButton;

//	zC[
enum{
	GVS_EVENT_MOUSE_WHEEL_AXIS_X	= 0,	//	XWHEELł
	GVS_EVENT_MOUSE_WHEEL_AXIS_Y	= 0,	//	YWHEELł
};
typedef CWuint16	GVSeventMouseWheelAxis;

//	Cxgf[^
typedef	struct	GVSMouseEventData{
	CWfloat32				x;			//	[JW
	CWfloat32				y;			//	[JW
	GVSeventMouseButton		button;		//	NbN{^
	CWuint32				clickCount;	//	NbN񐔁iVONbNA_uNbNAgvNbNAetc.j
	GVSeventMouseWheelAxis	wheelAxis;	//	wheel̕
	CWint16					wheelDelta;	//	wheel̉]
	CWuint32				modifire;	//	fBt@C[L[
	
} GVSMouseEventData;

//------------------------------------------------------------------------------
//	L[{[hCxg
//		ẼCxǵAEBhEANeBuԂ̂Ƃ̂ݔ܂B
//------------------------------------------------------------------------------
enum{
	//	L[܂
	GVS_EVENT_KEYBORAD_DOWN,

	//	L[Ă܂
	GVS_EVENT_KEYBORAD_PRESS,
	
	//	L[𗣂܂
	GVS_EVENT_KEYBORAD_UP,
	
	//	fBt@C[L[𑀍삵܂
	GVS_EVENT_KEYBORAD_MODIFIERS_CHANGE,
};
typedef	CWtype		GVSeventKeyboard;

//	Cxgf[^
typedef	struct	GVSKeyboardEventData{	
	CWint8		charCode;		//	macintosh̃R[h
	CWuint32	keyCode;		//	L[R[h
	CWuint32	modifire;		//	fBt@C[L[
			
} GVSKeyboardEventData;

//------------------------------------------------------------------------------
//	^ubgCxg
//		EW̓}EXŎ擾ł̂ŁA^ubg͕KvȂ̂΂ނ悤Ɏgp܂B
//		ẼCxǵAEBhEANeBuԂ̂Ƃ̂ݔ܂B
//------------------------------------------------------------------------------
enum{
	//	^ubg̓͂󂯕t܂
	GVS_EVENT_TABLET_POINT,

	//	^ubgfoCXiyjAANeBu܂̓fBANeBuɂȂiڋ߁A܂͗j
	GVS_EVENT_TABLET_PROXIMITY,
};
typedef	CWtype		GVSeventTablet;

//	Cxgf[^
typedef	struct	GVSTabletEventData{
	CWint32		absX;                   /* absolute x coordinate in tablet space at full tablet resolution */
	CWint32		absY;                   /* absolute y coordinate in tablet space at full tablet resolution */
	CWint32		absZ;                   /* absolute z coordinate in tablet space at full tablet resolution */
	CWuint16	buttons;                /* one bit per button - bit 0 is first button - 1 = closed */
	CWuint16	pressure;               /* scaled pressure value; MAXPRESSURE=(2^16)-1, MINPRESSURE=0 */
	CWint16		tiltX;                  /* scaled tilt x value; range is -((2^15)-1) to (2^15)-1 (-32767 to 32767) */
	CWuint16	tiltY;                  /* scaled tilt y value; range is -((2^15)-1) to (2^15)-1 (-32767 to 32767) */
	CWuint16	rotation;               /* Fixed-point representation of device rotation in a 10.6 format */
	CWuint16	tangentialPressure;     /* tangential pressure on the device; range same as tilt */
	CWuint16	deviceID;               /* system-assigned unique device ID - matches to deviceID field in proximity event */
	CWuint16	vendor1;                /* vendor-defined signed 16-bit integer */
	CWuint16	vendor2;                /* vendor-defined signed 16-bit integer */
	CWuint16	vendor3;                /* vendor-defined signed 16-bit integer */
} GVSTabletEventData;

typedef	struct	GVSTabletProximityEventData{
	CWuint16	vendorID;               /* vendor-defined ID - typically will be USB vendor ID */
	CWuint16	tabletID;               /* vendor-defined tablet ID - typically will be USB product ID for the tablet */
	CWuint16	pointerID;              /* vendor-defined ID of the specific pointing device */
	CWuint16	deviceID;               /* system-assigned unique device ID - matches to deviceID field in tablet event */
	CWint16		systemTabletID;         /* system-assigned unique tablet ID */
	CWint16		vendorPointerType;      /* vendor-defined pointer type */
	CWint32		pointerSerialNumber;    /* vendor-defined serial number of the specific pointing device */
	CWuint64	uniqueID;               /* vendor-defined unique ID for this pointer */
	CWuint32	capabilityMask;         /* mask representing the capabilities of the device */
	CWuint8		pointerType;            /* type of pointing device - enum to be defined */
	CWuint8		enterProximity;         /* non-zero = entering; zero = leaving */
} GVSTabletProximityEventData;

////////////////////////////////////////////////////////////////////////////////
//
//	Define Alert
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	A[g^Cv
//------------------------------------------------------------------------------
typedef enum	GVSalartType{
	GVS_ALART_TYPE_STOP,		//	stop icon
	GVS_ALART_TYPE_NOTE,		//	note icon
	GVS_ALART_TYPE_CAUTION,		//	caution icon
	GVS_ALART_TYPE_PLAIN,		//	nothing
	
}	GVSalartType;

//------------------------------------------------------------------------------
//	{^^Cv
//------------------------------------------------------------------------------
enum{
	GVS_ALART_BUTTON_DEFAULT_OK,		//	OK{^default
	GVS_ALART_BUTTON_DEFAULT_CANCEL,	//	LZ{^default
	GVS_ALART_BUTTON_DEFAULT_OTHER,		//	R{^default
};
typedef	CWtype		GVSalartButtonType;

//------------------------------------------------------------------------------
//	_CAO߂l
//------------------------------------------------------------------------------
enum{
	GVS_ALART_RESULT_NOTHING,	//	G[Ȃǂ̖߂lB
	
	GVS_ALART_RESULT_OK,		//	click OK button
	GVS_ALART_RESULT_CANCEL,	//	click CANCEL button
	GVS_ALART_RESULT_OTHER,		//	click OTHER button
	
};
typedef	CWtype		GVSalartResultType;



////////////////////////////////////////////////////////////////////////////////
//
//	Function / Mouse
//
////////////////////////////////////////////////////////////////////////////////

//	}EXJ[\\
void	GVSShowMouse( void );

//	}EXJ[\B
void	GVSHideMouse( void );

//	}EXJ[\W擾(O[oWł)
//		F CWint16*  outLocationX	W X
//		F CWint16*  outLocationY	W Y
void	GVSGetMouseLocation( CWint16*  outLocationX, CWint16*  outLocationY );

//	}EXNbN擾
//		NbN݂̂̔łB
//
//		ߒlF CWbool					true = {^NbNAfalse = NbNĂȂ
CWbool	GVSGetMouseClick( void );

////////////////////////////////////////////////////////////////////////////////
//
//	Function
//
////////////////////////////////////////////////////////////////////////////////
/*
::TODO::
//	L[擾
void	GVSGetKey( void );
*/

////////////////////////////////////////////////////////////////////////////////
//
//	Function / IME
//
////////////////////////////////////////////////////////////////////////////////

//	̓\bh[hpɂ
void	GVSDisableKeyScript( void );

////////////////////////////////////////////////////////////////////////////////
//
//	Function / Dialog
//
////////////////////////////////////////////////////////////////////////////////

//	A[g_CAO\
//
//		FGVSalartType	inType					ACR̎
//		FCFStringRef	inErrorTitle			bZ[W^Cg
//		FCFStringRef	inErrorMessage			bZ[W
//		FGVSalartButtonType	inButtonType	{^^Cv
//		FCFStringRef	inOKButtonCaption		OK{^̖́iftHgl̏ꍇ́ANULLnj
//		FCFStringRef	inCancelButtonCaption	LZ{^̖́isv̏ꍇ́ANULLnj
//		FCFStringRef	inOtherButtonCaption	R̃{^isv̏ꍇ́ANULLnj
//		ߒlFGVSalartResultType					NbNꂽ{^
GVSalartResultType	GVSShowAlartDialog( 
	const GVSalartType	inType, 
	const CFStringRef	inErrorTitle,
	const CFStringRef	inErrorMessage,
	const GVSalartButtonType	inButtonType,
	const CFStringRef	inOKButtonCaption,
	const CFStringRef	inCancelButtonCaption,
	const CFStringRef	inOtherButtonCaption
);

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

#endif	//CWGameViewService_h