/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameViewService
*	File:		GVSApplication.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				ApplicationƂĂ̋@\񋟂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GVSApplication_h
#define	GVSApplication_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameViewService.h"

#include	"GVSMenu.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GVSApplication
{
private:
	EventHandlerUPP		m_appEventHandlerUpp;
	EventHandlerRef		m_appHandlerRef;
	
public:
	GVSApplication( void );
	virtual	~GVSApplication( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////
	//	Cxg[vs
	//		EAvP[V̏Iij[ł̏IAVXȅIAGVSApplication::quit()̌ĂяojL܂
	//		@̊֐𔲂܂B
	//	
	//		߂lF@CWresultCode		G[R[h
	CWresultCode	run( void );

	//	Cxg[v~
	void	quit( void );

	///////////////////////////////////////////
	//	virtual
	///////////////////////////////////////////
	//	CxgɌĂт܂
	//	
	//		߂lF@GVSeventResult	Cxgǂ̃tOBꍇACxg`FC͏I܂B
	virtual GVSeventResult	onEventHandler( const GVSeventApp  inEvent );

private:
	//	AvP[VCxgnh[CXg[
	CWresultCode	installAppEventHandler( void );
	//	AvP[VCxgnh[ACXg[
	void	removeAppEventHandler( void );
	
	//	j[Cxgnh[
	static pascal OSStatus appEventHandler( EventHandlerCallRef  inNextHandler, EventRef  inEvent, void*  inUserData );
};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GVSApplication_h